<?php 
/**
 * @name esia_pdns
 * @description page qui permet au service web du pdns de prevenir qu'une nouvelle GESA est configurée
 * @author George Julien <j.george@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 0.1.1
 * @date 25/04/2015
 */

/*@NAME: getRequetsParam
 *@IN: 	$name: Nom du paramètre HTTP
 *@OUT:  Contenu de la variable
 *@TREAT: Récupére un paramètre HTTP sans se préocupper de savoir si elle est envoyée via un requête GET ou un POST 
 *@EXCEPTION: /
 */
function isAuthorizedHost($ip){
	$allowed_hosts=array( "10.20.1", "10.10.0","10.7.0.43","10.7.0.13" );

	foreach($allowed_hosts as $allowed_host){
		$allowed_array=explode(".",$allowed_host);
		$ip_array=explode(".",$ip);

		$ret=true;			
		for($i=0;$i<count($allowed_array)&&$ret;$i++){
			$ret=($allowed_array[$i] == $ip_array[$i]);	
		}
		if($ret) return true;
	}
	return false;
}

function sendError($msg){
        $json["success"]=false;
        $json["message"]=$msg;
        echo json_encode($json);
        exit; 
}

function addGesa($dbconnection,$sn=null,$fqdn=null){
	if( $sn == null ) throw new Exception("Missed needed parameter sn");
	if( $fqdn == null ) throw new Exception("Missed needed parameter fqdn");
	$esialog = new EsiaLog(FILE_LOG,"PDNS_SERVER");	

	$gesa = new Gesa();
	// $gesa->setIPv4Adress($gesa_ip);
	$gesa->setName($fqdn);
	$gesa->setSNMPVersion(2);
	$gesa->setType("gesa");
	$gesa->setDescription("New Gesa registred on ".date("Y-m-d h:i:sa"));

	$gesa->setId(Model_adm::addNode($dbconnection,$gesa));
	$esialog->write('ESIA NODE', 'add node '.$gesa->getName().' success');

	Model_adm::addAddDeviceInRootGroup($dbconnection,$gesa);
	Model_gesa::addGESA($dbconnection,$gesa->getId(),$gesa->getMaxSlot(),$sn);
	$esialog->write('ESIA NODE', 'addAddDeviceInRootGroup '.$gesa->getName().' success');
}

function checkGesa($dbconnection,$sn=null,$fqdn=null){
	if( $sn == null ) throw new Exception("Missed needed parameter sn");
	$esialog = new EsiaLog(FILE_LOG,"PDNS_SERVER");

	try{
	$gesa=Model_gesa::getGesaIDBySN($dbconnection,$sn);
	$gesa=Model_gesa::getInstanceGesa($dbconnection,$gesa);
	}
	catch(Exception $ex) {}
	if( !$gesa ) addGesa($dbconnection,$sn,$fqdn);

	exec(NRPE_PATH.' -H '.$gesa->getName().' -t3 -p 5666 -c gesa_version 2>&1',$output,$ret);
	if( $ret == 0 ) {
		$json["ok"]=true;
		array_push($json,$output);
	}
	else {
		if(isset($output[0]))   throw new Exception("Error nrpe : ".$output[0]);
		else throw new Exception("check_nrpe à retourner une erreur sans message");
	}
}

$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include_once $path.'/esia.conf.php';
include_once $path.'/Model_adm.php';
include_once LIB_LOG;
include_once MVCMODEL;
include_once $path.'/plugin/gesa/gesa_model.php';

$action=@$_REQUEST['action'];
$gesa_sn=@$_REQUEST['sn'];
$gesa_name=@$_REQUEST['fqdn'];

$response=$json=array();
if ( !isAuthorizedHost($_SERVER["REMOTE_ADDR"]) ) sendError("Not authorized");

try{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
        $dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
}
catch(Exception $ex){
	sendError("Unable to connect to DB : ".$ex->getMessage());
}

try{
	switch($action){
//		case "add" :
//			addGesa($dbconnection,$gesa_sn,$gesa_name);
//			break;
		case "check" :
			checkGesa($dbconnection,$gesa_sn,$gesa_name);
			break;
		default :
			sendError("Unknow action type");
	}	
	echo json_encode(array("success"=>true));	
}
catch(Exception $ex){
	sendError($ex->getMessage());
}
?>
