<?php
/**
 * @name adm_plugin.inc.php
 * @description page gérant les plugins exécutés par les différents démon
 * 				elle est incluse par la page administration.php
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2013
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 11/04/2013
 */
$smarty->assign('adm_plugin', 'adm_plugin');
include_once MVCMODEL;
if(isset($_GET['action']))
{
	$action = $_GET['action'];
}
else
{
	$action="list";
	$smarty->assign('plugin_menu','yes');
}
$err_treat=0;
//ajout ou modification d'un plugin de check existant
if($action=="addtreat" || $action=="modtreat")
{
	if(isset($_POST['name'])&&!empty($_POST['name']))
	{
		$_POST['type']='pooling';
		$exec='/usr/local/esia/plugins/'.$_POST['path'];
		//on test que le fichier est bien executable et que interval est bien un entier >0
		if(is_executable($exec)&& ctype_digit($_POST['interval']))
		{
			//plugin de check
			if($_POST['type']=='pooling')
			{
				try
				{
					//si on veut modifier un plugin 'check' existant
					if($action=="modtreat"&&is_numeric($_POST['id']))
					{
						$id = Model_adm::UpdateCheckPlugin($dbconnection,$_POST['id'],$_POST['name'],$exec,$_POST['parameter'],$_POST['interval'],$_POST['description'],$_POST['priority'] );
						$esialog->write('ESIA PLUGIN', 'UPDATE check plugin success '.$_POST['name']);
						$smarty->assign('adm_plugin_success',$lang['ADM_PLUGIN_UPDATE_SUCCESSD']);
						$_GET['id'] = $_POST['id'];
					}
					else //on ajout un nouveau plugin de check
					{
						$id = Model_adm::addCheckPlugin($dbconnection,$_POST['name'],$exec,$_POST['parameter'],$_POST['interval'],$_POST['description'],$_POST['priority'] );
						$esialog->write('ESIA PLUGIN', 'ADD check plugin success '.$_POST['name']);
						$smarty->assign('adm_plugin_success',$lang['ADM_PLUGIN_ADD_SUCCESS']);
						$_GET['id'] = $id;
					}
					$smarty->assign('adm_plugin_add_success', 'sucess');
					$action='modif';
				}
				catch(EsiaDbException $e)
				{
					$esialog->write('ESIA PLUGIN', 'ADD/UPDATE FAILED'.$e->getMessage());
					$ERROR[]=array('name'=>'PLUGIN ADD/UPDATE FAILED','message'=>$e->getMessage());
					$err_treat=1;
				}
			}
			//plugin de trap
			elseif($_POST['type']=='trap')
			{
				try
				{
					if($action=="modtreat"&&is_numeric($_POST['id']))
					{
						Model_adm::UpdateTrapPlugin($dbconnection,$_POST['id'],$_POST['name'],$exec,$_POST['parameter'],$_POST['oid'],$_POST['description'],$_POST['priority'] );
						$esialog->write('ESIA PLUGIN', 'UPDATE trap plugin success '.$_POST['name']);
						$smarty->assign('adm_plugin_success',$lang['ADM_PLUGIN_UPDATE_SUCCESSD']);
						$_GET['id'] = $_POST['id'];
					}
					else
					{
						Model_adm::addTrapPlugin($dbconnection,$_POST['name'],$exec,$_POST['parameter'],$_POST['oid'],$_POST['description'],$_POST['priority'] );
						$esialog->write('ESIA PLUGIN', 'ADD trap plugin success '.$_POST['name']);
						$smarty->assign('adm_plugin_success',$lang['ADM_PLUGIN_ADD_SUCCESS']);
						$_GET['id'] = $id;
					}
					$action='modif';
				}
				catch(EsiaDbException $e)
				{
					$esialog->write('ESIA PLUGIN', 'ADD/UPDATE FAILED'.$e->getMessage());
					$ERROR[]=array('name'=>'PLUGIN ADD/UPDATE FAILED','message'=>$e->getMessage());
					$err_treat=1;
				}
			}
			else
			{
				$err_treat=1;
				$ERROR[]=array('name'=>'PLUGIN ADD','message'=>'type no supported: '.$_POST['type']);
			}
		}
		else
		{
			$err_treat=1;
			$ERROR[]=array('name'=>'PLUGIN ADD','message'=>'file no found or file is not a executable: <br />'.$exec);
		}
	}
	else
	{
		$err_treat=1;
		$ERROR[]=array('name'=>'PLUGIN ADD','message'=> 'name is empty');
	}
}
//on veut supprimer un plugin
elseif($action=="deltreat")
{
	if(isset($_POST['id'])&&is_numeric($_POST['id']))
	{
		try
		{
			Model_adm::deletePlugin($dbconnection,$_POST['id']);
			Model_adm::mustRestartDaemon($dbconnection);
			$esialog->write('ESIA PLUGIN', 'DELETE SUCCESS '.$_POST['id']);
			$smarty->assign('adm_plugin_success',$lang['ADM_PLUGIN_DELETE_SUCCESS']);
		}
		catch(EsiaDbException $e)
		{
			$esialog->write('ESIA PLUGIN', 'DELETE FAILED'.$e->getMessage());
			$ERROR[]=array('name'=>'PLUGIN DELETE','message'=>$e->getMessage());
		}
	}
	else
	{
		$ERROR[]=array('name'=>'PLUGIN DELETE','message'=>'id is empty');
	}
	//$action='list';
}
//affichage de la page d'ajout/modification d'un plugin
if($action=="add" || $err_treat!=0 || $action=="modif")
{
	$smarty->assign('adm_plugin', 'add');
	//variable de langue
	$smarty->assign('l_adm_plugin_inter_msg', $lang['ADM_PLUGIN_INTERVALL_MESSAGE']);
	$smarty->assign('l_adm_plugin_path', $lang['ADM_PLUGIN_PATH']);
	$smarty->assign('l_adm_plugin_path_message', $lang['ADM_PLUGIN_PATH_MESSAGE']);
	$smarty->assign('l_adm_plugin_interval', $lang['ADM_PLUGIN_INTERVAL']);
	$smarty->assign('l_adm_plugin_oid', $lang['ADM_PLUGIN_OID']);
	$smarty->assign('l_adm_plugin_default_parameter', $lang['ADM_PLUGIN_DEFAULT_PARAMETER']);
	$smarty->assign('l_adm_plugin_default_interval', $lang['ADM_PLUGIN_DEFAULT_INTERVAL']);
	$smarty->assign('l_adm_plugin_priority', $lang['ADM_PLUGIN_PRIORITY']);
	//si il y a eu une erreur dans le traitement
	if($err_treat!=0)
	{
		if(isset($_POST['id'])&&is_numeric($_POST['id']))
			$smarty->assign('adm_plugin_id',$row->plugin_id);
		$smarty->assign('adm_plugin_name', $_POST['name']);
		$smarty->assign('adm_plugin_path', $_POST['path']);
		$smarty->assign('adm_plugin_type', $_POST['type']);
		$smarty->assign('adm_plugin_oid', $_POST['oid']);
		$smarty->assign('adm_plugin_param', $_POST['parameter']);
		$smarty->assign('adm_plugin_interval', $_POST['interval']);
		$smarty->assign('adm_plugin_description', $_POST['description']);
		$smarty->assign('adm_plugin_priority',$_POST['priority']);
	}
	//on veut modifier un plugin (affichage du formulaire)
	elseif($action=="modif")
	{
		if(is_numeric($_GET['id']))
		{
			$row = Model_esia::getPlugin($dbconnection,$_GET['id']);
			$row = $row[0];
			if($row['type']=='default')
				$smarty->assign('adm_plugin_type','pooling');
			else
				$smarty->assign('adm_plugin_type','trap');
			$smarty->assign('adm_plugin_id',$row['id']);
			$smarty->assign('adm_plugin_name',$row['name']);
			if(preg_match('#/usr/local/esia/plugins/(.*)#',$row['path'],$regs))
				$smarty->assign('adm_plugin_path',$regs[1]);
			$smarty->assign('adm_plugin_oid', $row['trap_oid']);
			$smarty->assign('adm_plugin_param', $row['parameter']);
			$smarty->assign('adm_plugin_interval', $row['interval_time']);
			$smarty->assign('adm_plugin_description',$row['description']);
			$smarty->assign('adm_plugin_priority',$row['priority']);
		}
	}
}
//on liste tout les plugins
elseif($action=='list')
{
	$smarty->assign('adm_plugin', 'list');
	$list=array();
	$rows = Model_esia::getPlugin($dbconnection);
	foreach($rows as $row)
	{
		$list[]=array('id'=>$row['id'],
				'name'=>$row['name'],
				'type'=>$row['type'],
				'description'=>$row['description'],
		);
	}
	$smarty->assign('adm_list_plugin', $list);
}
//on veut supprimer un plugin message de confirmation
elseif($action=='delete')
{
	$row = Model_esia::getPlugin($dbconnection,$_GET['id']);
	$row = $row[0];
	$nbr = Model_adm::countServiceByPlugin($dbconnection,$_GET['id']);
	$smarty->assign('adm_plugin_id',$row['id']);
	$smarty->assign('adm_plugin_name',$row['name']);
	$smarty->assign('adm_plugin_path',$row['path']);
	$smarty->assign('adm_plugin_service_nbr',$nbr);
	$smarty->assign('adm_plugin', 'delete');
	$smarty->assign('l_adm_message1', $lang['ADM_PLUGIN_DELETE_MESSAGE1']);
	$smarty->assign('l_adm_message2', $lang['ADM_PLUGIN_DELETE_MESSAGE2']);
	$smarty->assign('l_adm_message3', $lang['ADM_PLUGIN_DELETE_MESSAGE3']);
}

$smarty->assign('l_adm_add', $lang['ADD']);
$smarty->assign('l_adm_action', $lang['ACTION']);
$smarty->assign('l_adm_delete', $lang['DELETE']);
$smarty->assign('l_adm_change', $lang['MODIF']);
$smarty->assign('l_adm_cancel', $lang['CANCEL']);
$smarty->assign('l_adm_plugin_list', $lang['ADM_PLUGIN_LIST']);
$smarty->assign('l_adm_plugin_add', $lang['ADM_PLUGIN_ADD']);
$smarty->assign('l_adm_plugin_name', $lang['ADM_PLUGIN_NAME']);
$smarty->assign('l_adm_plugin_type', $lang['ADM_PLUGIN_TYPE']);
$smarty->assign('l_adm_plugin_description', $lang['ADM_DESCRIPTION']);
$smarty->assign('l_adm_err_empty_form', $lang['ADM_ERR_EMPTY_FORM']);
$smarty->assign('l_adm_pattern_list', $lang['ADM_PATTERN_SERVICE_LIST']);
$smarty->assign('l_adm_pattern_add', $lang['ADM_PATTERN_SERVICE_ADD']);
?>
