<?php
//common.php
$ESIA_WIDGET_NOTREE=true;
include_once '../common.php';

//Autre.
include_once '../Model_esia.php';
include_once DEVICE_CLASS;
include_once MVCMODEL;

header('Content-Type: application/json');

/**
 * @name adm_device.inc.php
 * @description Page gérant les noeuds (ajout,suppression,modification de noeud ou des services associé)
 * 				elle est incluse par la page administration.php
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2013
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 10/04/2013
 */

function errorType_to_lang($error_type){
	$lang = $GLOBALS["lang"];
	switch($error_type){
		case 'critical' :
			return $lang['LGD_CRI'];
		case 'warning' :
			return $lang['LGD_WARN'];
		case 'unknown' :
			return $lang['LGD_UNKNOWN'];
		case 'maintenance' :
			return $lang['LGD_MAINTENANCE'];
		default :
			return $lang['LGD_OK'];
	}
}

function getColumnsKeysList(){
	$action = $_GET['action'];
	$cols=array();
	$cols[]='name';
	$cols[]='description';
	$cols[]='group';
	$cols[]='type_error';
	$cols[]='common_name';
	$cols[]='plugin_name';
	if(empty($_GET['simpleview'])){
		$cols[]='message';
		if($action != 'acquitteerror'){
			$cols[]='time';
			if($action == 'history'){
				$cols[]='acquite';
			}
		}
	}
	return $cols;
}

$columnsList = getColumnsKeysList();
function filterNodes($node)
{
	$keys=$GLOBALS["columnsList"];

	if(empty($_REQUEST['filters'])) return true;
    $final_flag=-1;
	foreach($_REQUEST['filters'] as $num => $filters)
	{
	    $flag_and=0;
        $flag = 0;
		$key = $keys[$num];
		$str[] = $filters;
		if(strstr($filters, '||'))
		{
		    $str = explode('||', $filters);
		}
		elseif(strstr($filters, '&&'))
		{
		    $str = explode('&&', $filters);
		    $flag_and=1;
		}
		foreach ($str as $i => $filter)
		{
    		switch($key)
            {
    			//Type text
    			case 'name' :
    			case 'group' :
    			case 'common_name' :
    			case 'plugin_name' :
    			case 'message' :
    			case 'description':
    				if( preg_match('#^\!.*#',$filter))
    				{
    					$filter = preg_replace('#\!#','',$filter);
    					if( !fnmatch("*$filter*",$node[$key],FNM_CASEFOLD) )
    					{

    					    if($flag_and ==1 && $i > 0)
    					    {
    					        if($flag == 1)
    					        {
    					            $flag = 1;
    					        }
    					        else
    					        {
    					            $flag = 0;
    					        }
    					    }
    					    else
    					    {
    					       $flag = 1;
    					    }
    					}
    					else
    					{
    					    $flag = 0;
    					}
    				}
    				else
    				{
    				    if( fnmatch("*$filter*",$node[$key],FNM_CASEFOLD) )
    				    {
    				        if($flag_and ==1 && $i > 0)
    				        {
    				          //  echo $node[$key]." filter: $filter  flag: $flag flag_and: $flag_and indi: $i <br />";
    				            if($flag == 1)
    				            {
    				                $flag = 1;
    				            }
    				            else
    				            {
    				                $flag = 0;
    				            }
    				        }
    				        else
    				        {
    				            $flag = 1;
    				        }
    				    }
    				    elseif($flag_and ==1)
    				    {
    				        $flag = 0;
    				    }
    				}
    				break;

    			//Type lang(keyword)
    			case 'type_error' :
    				if( preg_match('#^\!.*#',$filter))
    				{
    					$filter = preg_replace('#\!#','',$filter);
    					if( !fnmatch("*$filter*",errorType_to_lang($node[$key]),FNM_CASEFOLD))
    					{
    					    if($flag_and ==1 && $i > 0)
    					    {
    					    //    echo $node[$key]." filter: $filter  flag: $flag flag_and: $flag_and indi: $i <br />";
    					        if($flag == 1)
    					        {
    					            $flag = 1;
    					        }
    					        else
    					        {
    					            $flag = 0;
    					        }
    					    }
    					    else
    					    {
    					        $flag = 1;
    					    }
    					}
    					elseif($flag_and ==1)
    					{
    					       $flag = 0;
    					}
    				}
    				else
    				{
    				    if( fnmatch("*$filter*",errorType_to_lang($node[$key]),FNM_CASEFOLD))
    				    {
    				        if($flag_and ==1 && $i > 0)
    				        {
    				          //  echo $node[$key]." filter: $filter  flag: $flag flag_and: $flag_and indi: $i <br />";
    				            if($flag == 1)
    				            {
    				                $flag = 1;
    				            }
    				            else
    				            {
    				                $flag = 0;
    				            }
    				        }
    				        else
    				        {
    				            $flag = 1;
    				        }
    				    }
    				    elseif($flag_and ==1)
    				    {
    				        $flag = 0;
    				    }
    				}
    				break;
    			//Type date
    			case 'time' :
    			case 'acquite' :
    				$dt = DateTime::createFromFormat('U',explode('.',$node[$key])[0]);
    				$date_str = $dt->format('d/m/Y H:i:s');
    				if( fnmatch("*$filter*",$date_str,FNM_CASEFOLD) ) $flag = 1;
    				break;
    		}
    	}
        if($final_flag == -1)
        {
            $final_flag=$flag;
        }
        elseif($final_flag==1 && $flag==1)
        {
            $final_flag=1;
        }
        elseif($final_flag==1 && $flag==0)
        {
            $final_flag=0;
        }
	}
	if($final_flag == 1)
	   return true;
	else
	   return false;
}

function cmpNodes($a,$b){
	$keys=$GLOBALS["columnsList"];

	if(empty($_REQUEST['cols'])) $cols = array();
	else $cols=$_REQUEST['cols'];

	foreach($cols as $num => $flag){
		$key = $keys[$num];

		if($flag == 0){ //Sort ASC
			$lt = -1;
			$gt = 1;
		}
		else{ //Sort DESC
			$lt = 1;
			$gt = -1;
		}

		switch($key){
			//Type text
			case 'name' :
			case 'group' :
			case 'common_name' :
			case 'plugin_name' :
			case 'message' :
			case 'description':
				$ret = strcasecmp($a[$key],$b[$key]);
				if( $ret != 0) return ($ret * $gt); // -1 * -1 = 1
				break;

			//Type lang(keyword)
			case 'type_error' :

				$ret = strcasecmp(errorType_to_lang($a[$key]),errorType_to_lang($b[$key]));
				if( $ret != 0) return ($ret * $gt); // -1 * -1 = 1
				break;

			//Type date
			case 'time' :
			case 'acquite' :
				$date_a = $a[$key];
				$date_b = $b[$key];
				if ( $date_a == $date_b ) break;
				return ( $date_a < $date_b ) ? $lt : $gt;
		}
	}
	return 0;
}

try
{
	$action = $_GET['action'];
	if($action == 'dashboard'){
		 //var_dump($_GET);
		//$is_hierarchisation = (!isset($_GET['hierarch']) || $_GET['hierarch'] === NULL || $_GET['hierarch']===true || $_GET['hierarch']==='true');
		if(!isset($_GET['hierarch']))		$is_hierarchisation = true;
		elseif(is_string($_GET['hierarch']))$is_hierarchisation = ( $_GET['hierarch'] != 'false');
		elseif(empty($_GET['hierarch']))	$is_hierarchisation = true;
		else 								$is_hierarchisation = $_GET['hierarch'];

		$is_okStatusMode = (isset($_GET['error']) && $_GET['error'] === '0' );

		if($is_okStatusMode){
			$list_node = array();

				$arr = Model_esia::getWebPluginByNodeType($dbconnection);
				foreach($arr as $row)
				{
					$nodetype[$row['type']]=$row['apache_path'].$row['control_page'];
				}

				if($is_hierarchisation){
					$nodesStates = Model_esia::getNodeListFilteredByStatus($dbconnection,$user->getId(),0);
				}
				else{
					$nodesStates = Model_esia::getNodeListFilteredByStatus($dbconnection,$user->getId(),null,0);
				}
				foreach($nodesStates as $node){
					$services = Model_esia::getServices($dbconnection,$node['id']);

					if(array_key_exists($node['type'],$nodetype))
					{
						$page_control = Model_esia::replacePageControlVariable($nodetype[$node['type']],$node);
					}
					else
					{
						$page_control = '/node_view.php?name='.$node['id'];
					}

					foreach($services as $service){
						if($service['state'] != 0) continue;

						$row['id'] = $node['id'];
						$row['name'] = $node['name'];
						$row['group'] = $node['group'];
						$row['type_device'] = $node['type'];
						$row['description'] = $node['description'];

						$row['type_error'] = 'ok';
						$row['error'] = 'ok';
						$row['time'] = strtotime($service['last_exec_time']);
						$row['message'] = $service['stdout'];
						$row['plugin_name'] = $service['name'];
						$row['check_plugin_name'] = $service['check_plugin_name'];
						$row['last_stdout'] = $service['stdout'];

						$row['page_control'] = $page_control;
						$row['group_parent'] = Model_esia::getParrentGroup($dbconnection,$node['group'])[0]['name'];
						$list_node[] = $row;
					}

			}
		}
		else{
			$list_node = Model_esia::getError($dbconnection,$user->getId(),true);
		}
		$nodes_fin =array();
		foreach($list_node as $idx => $node)
		{
			$modif = false;
			$add = false;
			//si on veut un type d'erreur précis sur un groupe de noeud précis
			if(!empty($_GET['type']))
			{
				if($_GET['type'] == $node['type_device'])
				{

					if($node['type_error']=='warning' && $_GET['error']==1)
					{
						$add = true;
					}
					elseif($node['type_error']=='critical' && $_GET['error']==2)
					{
						$add = true;
					}
					elseif($node['type_error']=='unknown' && $_GET['error']==3)
					{
						$add = true;
					}
					elseif($node['type_error']=='unknown' && $_GET['error']==0)
					{
						$add = true;
					}
				}

			}
			else
			{
				//DASHBOARD de base avec hierachisation des erreurs
				if(array_key_exists($node['name'],$nodes_fin))
				{
					if($nodes_fin[$node['name']]['plugin_name'] != $node['plugin_name'])
					{
						if($node['priority']<$nodes_fin[$node['name']]['priority'])
						{
							$modif = true;
						}
						elseif($node['priority']==$nodes_fin[$node['name']]['priority'])
						{
							if($nodes_fin[$node['name']]['type_error']!='critical' && $node['type_error']=='critical')
							{
								$modif = true;
							}
							elseif($nodes_fin[$node['name']]['type_error']=='unknown' && $node['type_error']=='warning')
							{
								$modif = true;
							}
							elseif($nodes_fin[$node['name']]['type_error']== $node['type_error'])
							{
								$add = true;
							}

						}
					}
				}
				else
				{
					$modif = true;
				}
			}
			$common_name = Model_esia::getCommonName($lang, $node['plugin_name'], $node['check_plugin_name']);

			if($is_hierarchisation){
				$row_key = $node['name'];
			}
			else{
				$row_key = $node['name'].$node['time'].$node['plugin_name'];
			}

			if($modif ==true)
			{
				$nodes_fin[$row_key]=array('name'=>$node['name'],
						'group'=>$node['group'],
						'group_parent'=>$node['group_parent'],
						'page_control'=>$node['page_control'],
						'id'=>$node['id'],
						'type_device'=>$node['type_device'],
						'type_error'=>$node['type_error'],
						'error'=>$node['error'],
						'message'=>$node['last_stdout'],
				        'description'=>$node['description'],
						'plugin_name'=>$node['plugin_name'],
						'time'=>$node['time'],
						'priority'=>$node['priority'],
						'common_name' =>$common_name
				);
			}
			if($add  ==true)
			{
				$nodes_fin[$row_key]=array('name'=>$node['name'],
						'group'=>$node['group'],
						'group_parent'=>$node['group_parent'],
						'page_control'=>$node['page_control'],
						'id'=>$node['id'],
						'type_device'=>$node['type_device'],
						'type_error'=>$node['type_error'],
						'error'=>$node['error'],
						'message'=>$node['message'].'<br />'.$nodes_fin[$node['name']]['message'] ,
						'plugin_name'=>$node['plugin_name'],
				        'description'=>$node['description'],
						'time'=>$node['time'],
						'priority'=>$node['priority'],
						'common_name' => $common_name.'<br />'.$nodes_fin[$node['name']]['common_name'],
				);
			}
		}
		$nodes = $nodes_fin;
	}
	else if($action == 'history'){
		$time=1;
		if(isset($_GET['time'])&& is_numeric($_GET['time']))
		{
			$time = $_GET['time'];
		}
		$arr = Model_esia::getAllErrorByTime($dbconnection,$user->getId(),$time );
		$list_errors=array();
		foreach($arr as $error)
		{

			$out = preg_replace('#\|.*#',"\n",$error['message']);
			$common_name = Model_esia::getCommonName($lang, $error['plugin_name'], $error['check_plugin_name']);
			//echo $out.'<br />';
			$list_errors[]=array('name'=>$error['name'],
					'group'=>$error['group'],
					'group_parent'=>$error['group_parent'],
					'page_control'=>$error['page_control'],
					'id'=>$error['id'],
					'type_device'=>$error['type_device'],
					'type_error'=>$error['type_error'],
					'error'=>$error['error'],
					'message'=>$out,
			    'description'=>$error['description'],
					'plugin_name'=>$error['plugin_name'],
					'time'=>$error['time'],
					'priority'=>$error['priority'],
					'acquite'=>$error['time_acquitte'],
					'common_name' => $common_name
			);
		}
		$nodes = $list_errors;
	}
	elseif($action=='acquitteerror'||$action=='waitingservice')
	{
		if($action == 'acquitteerror'){
			$arr = Model_esia::getAcquitteError($dbconnection,$user->getId());
		}
		else{
			$arr = Model_esia::getWaitingServices($dbconnection,$user->getId());
			//print_r($arr);
		}
		$list_errors=array();
		foreach($arr as $error)
		{
			$common_name = Model_esia::getCommonName($lang, $error['plugin_name'], $error['check_plugin_name']);
			$out = preg_replace('#\|data.*#',"\n",$error['message']);
			//echo $out.'<br />';
			$list_errors[]=array('name'=>$error['name'],
					'group'=>$error['group'],
					'page_control'=>$error['page_control'],
					'id'=>$error['id'],
					'type_device'=>$error['type_device'],
					'type_error'=>$error['type_error'],
					'error'=>$error['error'],
					'message'=>$out,
			    'description'=>$error['description'],
					'plugin_name'=>$error['plugin_name'],
					'time'=>$error['time'],
					'priority'=>$error['priority'],
					'acquite'=>$error['time_acquitte'],
					'common_name'=>$common_name,
			);
		}
		$nodes = $list_errors;
	}

	//Filter
	$nodes = array_filter($nodes,'filterNodes');

	//Sort
	usort($nodes,"cmpNodes"); //A optimiser

	//Count
	$json_array['total_rows']=count($nodes);

	//Pagination
	if( isset($_REQUEST['page']) && isset($_REQUEST['size']) && is_numeric($_REQUEST['size']) ){
		$page=$_REQUEST['page'];
		$size=$_REQUEST['size'];
		$offset = $page*$size;

		$nodes = array_slice($nodes,$offset,$size);
	}

	//Last modifs + traductions
	$list = array();
	//$nodes[]=array('name'=>implode(',',array_keys($_GET)),'type'=>'test','group'=>'julien','description'=>json_encode($_GET),'services'=>0);

	foreach($nodes as $idx => $node)
	{
		//Configuration de certains champs
		if( $node['page_control'] != ''){
			$nodes[$idx]['name'] = '<a id="linkn'.$node['id'].'" href="'.$node['page_control'].'">'.$node['name'].'</a>';
		}
		else{
			$nodes[$idx]['name'] = '<a id="linkn'.$node['id'].'" href="/node_view.php?name='.$node['name'].'">'.$node['name'].'</a>';
		}
		if( $node['description'] == null ) @$nodes[$idx][description]="";
		if( $node['group'] == null ) @$nodes[$idx][group]="";
		if( !empty($node['group_parent'])) $nodes[$idx]['group']=$node['group_parent'].' > '.$node['group'];

		switch($node['type_error']){
			case 'critical' :
				$nodes[$idx]['type_error'] = '<td class="EventCritical alignCenterTab"><p>'.$lang['LGD_CRI'].'</p></td>';
				break;
			case 'warning' :
				$nodes[$idx]['type_error'] = '<td class="EventWarning alignCenterTab"><p>'.$lang['LGD_WARN'].'</p></td>';
				break;
			case 'unknown' :
				$nodes[$idx]['type_error'] = '<td class="EventUnknown alignCenterTab"><p>'.$lang['LGD_UNKNOWN'].'</p></td>';
				break;
			case 'maintenance' :
				$nodes[$idx]['type_error'] = '<td class="EventPending alignCenterTab"><p>'.$lang['LGD_MAINTENANCE'].'</p></td>';
				break;
			case 'waiting' :
				$nodes[$idx]['type_error'] = '<td class="EventNone alignCenterTab"><p>'.$lang['LGD_PENDING'].'</p></td>';
				break;
			default :
				$nodes[$idx]['type_error'] = '<td class="EventOK alignCenterTab"><p>'.$lang['LGD_OK'].'</p></td>';
				break;
		}

		$nodes[$idx]['common_name'] = '<p class="alignCenterTab servicesEnAlerte" title="'.$node['plugin_name'].'">'.$node['common_name'].'</p>';
		$nodes[$idx]['plugin_name'] = '<p class="alignCenterTab servicesEnAlerte">'.$node['plugin_name'].'</p>';

		if($action != 'acquitteerror' && ($action != 'waitingservice' && !empty($node['time']))){
			$dt = DateTime::createFromFormat('U',explode('.',$node['time'])[0]);
			if($dt !== false){
				$nodes[$idx]['time'] = $dt->format('d/m/Y H:i:s');
			}
			if( $dt !== false && $action == 'history'){
				if( $node['acquite'] == null ) @$nodes[$idx][acquite]="";
				else {
					$dt = DateTime::createFromFormat('U',explode('.',$node['acquite'])[0]);
					$nodes[$idx]['acquite'] = $dt->format('d/m/Y H:i:s');
				}
			}
		}

		//Traductions des colonnes
		$list[$idx][$lang['ADM_NAME']] = $nodes[$idx]['name'];
		$list[$idx][$lang['ADM_DESCRIPTION']] = nl2br(htmlEntities($nodes[$idx]['description'], ENT_QUOTES),true);
		$list[$idx][$lang['GROUPS']] = $nodes[$idx]['group'];
		$list[$idx][$lang['ALERT_MENU']] = $nodes[$idx]['type_error'];
		$list[$idx][$lang['SERVICES']] = $nodes[$idx]['common_name'];

		if(empty($_GET['simpleview'])){
			$list[$idx][$lang['SERVICE_TECHNICAL_NAME']] = $nodes[$idx]['plugin_name'];
			$list[$idx][$lang['MESSAGES']] = $nodes[$idx]['message'];

			if($action != 'acquitteerror'){
				if(!empty($nodes[$idx]['time'])){
					$list[$idx][$lang['DATE']] = $nodes[$idx]['time'];
				}
				if($action == 'history'){
					$list[$idx][$lang['DATE_END']] = $nodes[$idx]['acquite'];
				}
			}
		}
	}

	$json_array['headers'] = array_keys($list[0]);
	$json_array['rows']=$list;

	echo json_encode($json_array,JSON_PRETTY_PRINT);
}
catch(EsiaDbException $e)
{
	$ERROR[]=array('name'=>'DB ERROR','message'=>$e->getMessage());
	print_r($ERROR);
}
?>
