<?php
/**
 * @name node_AvailabilityCalculation
 * @description Calcul le pourcentage de disponnibilité d'un noeud. Se script est appellé par une requête AJAX (node_control)
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 19/11/2012
 */
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';

//fonction qui dessine et affiche une image "No data"
function img_no_data()
{
	//pas de donnée à afficher service trop réçent
	$image = imagecreate(200,50);
	$blanc = imagecolorallocate($image, 255, 255, 255);
	$noir = imagecolorallocate($image, 0, 0, 0);
	imagestring($image, 4, 55, 5, "No data ", imagecolorallocate($image, 0, 0, 0));
	imagestring($image, 4, 35, 15,"for this month", imagecolorallocate($image, 0, 0, 0));
	imagecolortransparent($image, $blanc);
	imagepng($image);
}
//fonction qui force le navigateur à afficher la fenetre de téléchargement
//par défaut fichier de type image
function force_download($type='png')
{
	//on force le navigateur à afficher la fenêtre de téléchargement
	header('Content-Type: application/octet-stream');
	header('Content-disposition: attachment; filename=export.'.$type);
	header('Pragma: no-cache');
	header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
  	header('Expires: 0');	
}
try
{
	//instanciation du noeud
	$node =  Model_esia::InstanceNode($dbconnection, $_GET['id']);
	//vérification des droits
	if($user->getDroits($dbconnection,"device_view",$node->getName() ) ==1)
	{
		//type demandé (csv ou img)
		if(isset($_GET['type'])&&$_GET['type']=='img') //format image
		{
			require_once "../libs/libchart/classes/libchart.php";
			//on veut une exportation
			if(isset($_GET['action'])&&$_GET['action']=='export')
			{
				force_download();
			}
			else
			{
				//on affiche dans le navigateur (typiquement dans une balise img)
				header("Content-type: image/png");
			}
			//test si c'est  pour le noeud global ou pour un service
			if(isset($_GET['service']))
			{
				//récupération du service
				$service = Model_esia::getServices($dbconnection,$node->getId(),$_GET['service']);
				$service = $service[0];
				$pourcent = Model_esia::countPourcentAvailabilityServiceByErrorType($dbconnection,$node->getId(),$service['id'],$_GET['month'],$_GET['year']);
				foreach($pourcent as $cle => $element)
				{
					if($pourcent[$cle]==0)
					{
					
						$pourcent[$cle]=0.01;	
					}
				}
				if($pourcent['nopresent']==100)
				{
					//pas de données
					img_no_data();
				}
				else
				{
					//Affichage du cammenbert pour la disponibilité des services
					$chart = new PieChart();
					$chart->getPlot()->getPalette()->setPieColor(array(
						new Color(0, 255,0),new Color(255,255,0),new Color(255, 0, 0),new Color(100,100, 100) ));
					$chart->getPlot()->getPalette()->setBackgroundColor(array( new Color(255,255,255),new Color(255,255,255),new Color(255,255,255),new Color(255,255,255),new Color(255,255,255),new Color(255,255,255)));
					$dataSet = new XYDataSet();
					$dataSet->addPoint(new Point("OK", $pourcent['ok']));
					$dataSet->addPoint(new Point("Alerte",$pourcent['warning'] ));
					$dataSet->addPoint(new Point("Critique", $pourcent['critical']));
					$dataSet->addPoint(new Point("Inconnu", $pourcent['unknown']));
					$chart->setDataSet($dataSet);
					$chart->getPlot()->setOuterPadding(0);
					$chart->getPlot()->setTitleHeight(0);
					$chart->getPlot()->setTitlePadding(0);
					$chart->getPlot()->setGraphPadding(new Padding( '0','0','0','50px'));
					$chart->getConfig()->setSortDataPoint(false);
					$chart->render();
				}
			}
			else
			{
				$services = Model_esia::getServices($dbconnection,$node->getId());	
				//affichage du graphique en ligne pour le noeud 
				$chart = new LineChart(1100, 650);
				$dataSet = new XYSeriesDataSet();
				foreach($services as $service)
				{
					$serie = new XYDataSet();
					$arr = Model_esia::countPourcentAvailabilityServiceByMonth($dbconnection,$node->getId(),$service['id']);
					for($i=count($arr)-1;$i>=0;$i--)
					{
						$serie->addPoint(new Point($arr[$i]['month']."/".$arr[$i]['year'],preg_replace('#\.#',',',$arr[$i]['pourcent'])));
					}
					$dataSet->addSerie($service['name'], $serie);
				}
				$chart->getPlot()->getPalette()->setBackgroundColor(array( new Color(255,255,255),new Color(255,255,255),new Color(255,255,255),new Color(255,255,255),new Color(255,255,255),new Color(255,255,255)));
				$chart->setDataSet($dataSet);
				$chart->render();
			}
			
		}
		elseif(isset($_GET['type'])&&$_GET['type']=='csv')//format csv
		{
			force_download('csv');
			//test si c'est  pour le noeud global ou pour un service
			if(isset($_GET['service']))
			{
				//récupération du service
				$service = Model_esia::getServices($dbconnection,$node->getId(),$_GET['service']);
				$service = $service[0];
				$arr = Model_esia::countPourcentAvailabilityServiceByMonth($dbconnection,$node->getId(),$service['id']);
				echo "month;Availability;\"name of month\"\n";
				for($i=count($arr)-1;$i>=0;$i--)
				{
					$m =strftime('%B',strtotime($arr[$i]['month'].'/01/'.$arr[$i]['year']));
					echo $arr[$i]['month']."/".$arr[$i]['year'].";".preg_replace('#\.#',',',$arr[$i]['pourcent']).";".$m."\n";
				}
			}
			else
			{
				$services = Model_esia::getServices($dbconnection,$node->getId());	
				$csv=array('title'=>array());
				array_push($csv['title'],'month');
				foreach($services as $service)
				{
					$csv['title'] = array_merge($csv['title'],array($service['name']));
					$arr = Model_esia::countPourcentAvailabilityServiceByMonth($dbconnection,$node->getId(),$service['id']);
					for($i=count($arr)-1;$i>=0;$i--)
					{
						$m =strftime('%B',strtotime($arr[$i]['month'].'/01/'.$arr[$i]['year']));
						$key=$m.$arr[$i]['year'];
						if(array_key_exists($key,$csv))
						{
							$tmp = preg_replace('#\.#',',',$arr[$i]['pourcent']);
							$csv[$key] = array_merge($csv[$key],array($tmp));
						}
						else
						{
							$tmp = $arr[$i]['month']."/".$arr[$i]['year'];
							$csv[$key]=array($tmp,preg_replace('#\.#',',',$arr[$i]['pourcent']));
						}
					}
	
				}
				foreach($csv as $ligne)
				{
					$stringcsv = implode(";", $ligne);
					echo "$stringcsv\n";
				}
			}
		}
		else
		{
			//format XML pour l'affichage des stat "brut"
			if($_GET['action']=='pourcentPerErrorType')
			{
				if(isset($_GET['month'])&&!empty($_GET['month'])&&isset($_GET['year'])&&!empty($_GET['year']))
				{
					$pourcent = Model_esia::countPourcentAvailabilityServiceByErrorType($dbconnection,$node->getId(),$service['id'],$_GET['month'],$_GET['year']);
					header('Content-Type: text/xml; charset=utf-8');
					$xml = new DOMDocument('1.0', 'utf-8');
					$nog = $xml->createElement('service');
					$ok = $xml->createElement('ok',$pourcent['ok']);
					$nog->appendChild($ok);
					$warning = $xml->createElement('warning',$pourcent['warning']);
					$nog->appendChild($warning);
					$critical = $xml->createElement('critical',$pourcent['critical']);
					$nog->appendChild($critical);
					$unknown = $xml->createElement('unknown',$pourcent['unknown']);
					$nog->appendChild($unknown);
					$xml->appendChild($nog);
					echo $xml->saveXML();
				}
				//print_r($pourcent);
			}
			else
			{
				//affichage
				header('Content-Type: text/xml; charset=utf-8');
				$xml = new DOMDocument('1.0', 'utf-8');
				//calcul des pourcentages
				$pourcent = Model_esia::countPourcentAvailabilityService($dbconnection,$node->getId(),$service['id']);

				$nog = $xml->createElement('service');
				$nog->setAttribute('name',$service['name']);
				$nog->appendChild($xml->createElement('total_availability',round($pourcent,2)));
				$arr = Model_esia::countPourcentAvailabilityServiceByMonth($dbconnection,$node->getId(),$service['id']);
				$monthavailable = $xml->createElement('months_availability');
				foreach($arr as $row)
				{
					$month = $xml->createElement('month',$row['pourcent']);
					$m =strftime('%B',strtotime($row['month'].'/01/'.$row['year']));
					$month->setAttribute('name',$m);
					$month->setAttribute('month',$row['month']);
					$month->setAttribute('year',$row['year']);
					//ajout à l'arbre XML
					$monthavailable->appendChild($month);
				}
				$nog->appendChild($monthavailable);
				$xml->appendChild($nog);
				echo $xml->saveXML();
			}
		}
	}
	else
	{
		echo $lang['NO_ACCES'];
	}
}
catch(EsiaDbException $e)
{
	//au niveux de la requête de la base de donnée cela arrive si on demande les infos d'un noeud qui n'existe pas
	echo $e->getMessage();
}



?>
