<?php
/**
 * @name node_graph_munin.inc
 * @description script gérant l'API MUNIN
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 19/11/2012
 */
//on veut voir un graph en particulier
$smarty->assign('graph_software','munin');
if(isset($_GET['action'])&&!empty($_GET['action']))
{
	if($_GET['action']=='view')
	{
		$url=$graph['url'].rawurldecode($_GET['local_graph_id']);

		$muninpage = file_get_contents($url);
		$dom = new domDocument();
		@$dom->loadHTML($muninpage);
		$graph_array=array();
		if(preg_match('#version\s2\.0\.6#',$dom->getElementById('footer')->nodeValue)) # munin en version wheezy 
		{
			$table = $dom->getElementById('content');
			$imgs = $table->getElementsByTagName('img');
			foreach($imgs as $img)
			{
				if(preg_match('#/munin/(.*)#',$graph['url'],$regs))
				{
					$urlgraph = preg_replace('#\.\./#','',$img->getAttribute("src"));
					$urlgraph = preg_replace('#'.addslashes($regs[1]).'#','',$urlgraph);
					$urlgraph = $graph['url'].$urlgraph;
				}
				$graph_array[]= array('url'=>urlencode($urlgraph),'legend'=>$matcheslegend[1][$i]);
			}

		}
		else # munin en version squeeze 
		{
			$tables = $dom->getElementsByTagName('table');
			$url = preg_replace('#[0-9a-zA-Z_]*\.html$#','', $url);
			foreach($tables as $table)
			{
				if($table->hasAttribute("class"))
				{
					
					if($table->getAttribute("class")=='invisiblebox')
					{
						$imgs = $table->getElementsByTagName('img');
						foreach($imgs as $img)
						{

							if(preg_match('#\./(.*)#', $img->getAttribute("src"),$regs))
							{
								$urlgraph = $url.$regs[1];
							}
							$graph_array[]= array('url'=>urlencode($urlgraph),'legend'=>$matcheslegend[1][$i]);
						}
					}
				}
			}
		}
		$smarty->assign('node_graphs',$graph_array);
		$smarty->assign('action','view');
	}
}
else
{
	//Récupération des graphs global du noeud dans cacti
	//page graph_view.php de cacti
	$url=$graph['url'];
	$muninpage = file_get_contents($url);
	$dom = new domDocument();
	$dom->loadHTML($muninpage);
	$header = $dom->getElementById("header-table");
	if($header==NULL) // permet la compatibilité avec munin du Debian Wheezy
	{
		$header = $dom->getElementById("header");
	}
	$ahs = $header->getElementsByTagName('a');
	$graph_menu=array();
	foreach($ahs as $ah)
	{
		if(preg_match('/^#.*/',$ah->getAttribute("href")))
		{
			//echo $ah->nodeValue.'<br />';
			$url = $ah->getAttribute("href");
			$graph_menu[]=array('url'=> $url,'name'=>$ah->nodeValue);
		}
	}
	$smarty->assign('graph_menu',$graph_menu);
	$graph_array=array();
	if(preg_match('#version\s2\.0\.6#',$dom->getElementById('footer')->nodeValue)) # munin en version wheezy 
	{
		$table = $dom->getElementById('content');
		$childs = $table->childNodes;
		$name='';
		foreach($childs as $child)
		{	
			if($child->tagName=='h3')
			{
				$name = $child->nodeValue;
			}
			elseif($child->tagName=='table')
			{
				$imgs = $child->getElementsByTagName('img');
				foreach($imgs as $img)
				{
					if(preg_match('#/munin/(.*)#',$graph['url'],$regs))
					{
						$url = preg_replace('#\.\./#','',$img->getAttribute("src"));
						$url = preg_replace('#'.addslashes($regs[1]).'#','',$url);
						$url = $graph['url'].$url;
					}
					if($a = $img->parentNode)
					{
						$param='action=view&amp;local_graph_id='.rawurlencode( $a->getAttribute("href"));
					}
					$graph_array[]= array('id'=>$name,'list'=>array('param'=>$param,'url'=>$url));
				}
			}
		}
	}
	else  # munin en version squeeze 
	{
		foreach($graph_menu as $menu)
		{
			$table = $dom->getElementById($menu['name']);
			$imgs = $table->getElementsByTagName('img');
			foreach($imgs as $img)
			{

				if(preg_match('#\./(.*)#', $img->getAttribute("src"),$regs))
				{
					$url = $graph['url'].$regs[1];
				}
				if($a = $img->parentNode)
				{
					$param='action=view&amp;local_graph_id='.rawurlencode( $a->getAttribute("href"));
				}
				$graph_array[]= array('id'=>$menu['name'],'list'=>array('param'=>$param,'url'=>$url));
			}

		}
	}
	$smarty->assign('node_graphs',$graph_array);
	$smarty->assign('action','node');
}

?>
