<?php
/**
 * @name index.php
 * @description page d'accueil de l'application ESIA
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 16/04/2013
 */


include_once 'common.php';
//on affiche les erreurs par type de noeud
if(isset($_GET['action'])&&!empty($_GET['action']))
{
	$action=$_GET['action'];
	$smarty->assign('action', $_GET['action']);
}
else
{
	$action='defaultview';
}
if(isset($SIMPLEVIEW) && $SIMPLEVIEW==true)
{
	$smarty->assign('simpleview','yes');
}
//tableau récupitulatif de l'état du réseau
$arr = Model_esia::countNodeType($dbconnection,$user->getId(), Model_esia::NODE_COUNT_SERVICE_STATE);
$total_node=0;
$total_service=0;
$total_ok=0;
$total_warning=0;
$total_critical=0;
$total_unknown=0;

foreach($arr as $key => $val)
{
	$total_node = $total_node+$val['nbr_device'];
	$total_ok=$total_ok+$val['ok'];
	$total_warning=$total_warning+$val['warning'];
	$total_critical=$total_critical+$val['critical'];
	$total_unknown=$total_unknown+$val['unknown'];
}
$smarty->assign('total_node',$total_node);
$smarty->assign('total_node_type',count($arr));
$smarty->assign('total_ok',$total_ok);
$smarty->assign('total_warning',$total_warning);
$smarty->assign('total_critical',$total_critical);
$smarty->assign('total_unknown',$total_unknown);

if($action=='dashboard')
{
	$smarty->assign('view_error', 'view');
	$smarty->assign('pageName', "alertes");

	if(isset($_GET['type']) ) $smarty->assign('type', $_GET['type']);
	if(isset($_GET['hierarch']) ) $smarty->assign('hierarch', $_GET['hierarch']);
	if(isset($_GET['error']) ) $smarty->assign('error', $_GET['error']);
	$widgetid="";
	if(isset($_GET['widgetid']) && !empty($_GET['widgetid'])) $widgetid=$_GET['widgetid'];

	$smarty->assign('widgetid',$widgetid);

	if(isset($_GET['error_type']))
	{
		$smarty->assign('error_displayed', $_GET['error_type']);
	}
	if(isset($_GET['show_description']) && $_GET['show_description'] == 1)
	{
	    $smarty->assign('show_col_descr',1);
	}
	if(!isset($_GET['show_group']))
	{
	    $smarty->assign('show_col_group',1);
	}
	elseif($_GET['show_group'] == 1)
	{
	    $smarty->assign('show_col_group',1);
	}
	if(isset($_POST['node_filter'])&&!empty($_POST['node_filter'])) $smarty->assign('node_filter',$_POST['node_filter']);
	if(isset($_POST['group_filter'])&&!empty($_POST['group_filter'])) $smarty->assign('group_filter',$_POST['group_filter']);
	if(isset($_POST['alert_filter'])&&!empty($_POST['alert_filter'])) $smarty->assign('alert_filter',$_POST['alert_filter']);
	if(isset($_POST['service_filter'])&&!empty($_POST['service_filter'])) $smarty->assign('service_filter',$_POST['service_filter']);
	if(isset($_POST['description_filter'])&&!empty($_POST['description_filter'])) $smarty->assign('description_filter',$_POST['description_filter']);
	//ajout d'un lien dans la push barre
	$navbar->addElement($lang['ALERT_MENU'], '/index.php?action=dashboard',$ICONS['warning']);
	//array_push($_SESSION['navbar'],array('name'=> $lang['DASHBOARD'],'link'=>'/index.php?action=dashboard'));
	//variable de langue

	$smarty->assign('l_name_node', $lang['ADM_NAME']);
	$smarty->assign('l_message', $lang['MESSAGE']);
	$smarty->assign('l_messages', $lang['MESSAGES']);
	$smarty->assign('l_date', $lang['DATE']);
	$smarty->assign('l_service', $lang['SERVICE']);
	$smarty->assign('l_services', $lang['SERVICES']);
}
elseif($action=='history')
{
	if(isset($_GET['time']) ) $smarty->assign('time', $_GET['time']);
	$smarty->assign('smarty_history', '1');
	$smarty->assign('view_error', 'view');
	$smarty->assign('pageName', "history");
	$smarty->assign('list_dev',$list_errors);
	//ajout d'un lien dans la push barre
	array_push($_SESSION['navbar'],array('name'=> $lang['DASHBOARD'],'link'=>'/index.php?action=history'));
	//variable de langue
	$smarty->assign('l_name_node', $lang['ADM_NAME']);
	$smarty->assign('l_messages', $lang['MESSAGES']);
	$smarty->assign('l_date', $lang['DATE']);
	$smarty->assign('l_service', $lang['SERVICE']);
	$smarty->assign('l_services', $lang['SERVICES']);
	//echo '<pre>'.print_r($arr,true).'</pre>';
}
elseif($action=='acquitteerror'||$action == 'waitingservice')
{
	$smarty->assign('smarty_history', '1');
	$smarty->assign('view_error', 'view');
	$smarty->assign('view_acquitte', 'view');
	$arr = Model_esia::getAcquitteError($dbconnection,$user->getId());
	$list_errors=array();
	foreach($arr as $error)
	{
		$common_name = Model_esia::getCommonName($lang, $error['plugin_name'], $error['check_plugin_name']);
		$out = preg_replace('#\|data.*#',"\n",$error['message']);
		//echo $out.'<br />';
		$list_errors[]=array('name'=>$error['name'],
				'group'=>$error['group'],
				'page_control'=>$error['page_control'],
				'id'=>$error['id'],
				'type_device'=>$error['type_device'],
				'type_error'=>$error['type_error'],
				'error'=>$error['error'],
				'message'=>$out,
				'plugin_name'=>$error['plugin_name'],
				'time'=>$error['time'],
				'priority'=>$error['priority'],
				'acquite'=>$error['time_acquitte'],
				'common_name'=>$common_name,
		);
	}

	$smarty->assign('list_dev',$list_errors);
	//ajout d'un lien dans la push barre
	array_push($_SESSION['navbar'],array('name'=> $lang['DASHBOARD'],'link'=>'/index.php?action=history'));
	//variable de langue
	$smarty->assign('l_name_node', $lang['ADM_NAME']);
	$smarty->assign('l_message', $lang['MESSAGE']);
	$smarty->assign('l_messages', $lang['MESSAGES']);
	$smarty->assign('l_date', $lang['DATE']);
	$smarty->assign('l_service', $lang['SERVICE']);
	$smarty->assign('l_services', $lang['SERVICES']);
	//echo '<pre>'.print_r($arr,true).'</pre>';
}
elseif($action=='defaultview')
{
	$smarty->assign('pageName', "index");
	//tableau récupitulatif de l'état du réseau
	$arr = Model_esia::countNodeType($dbconnection,$user->getId(), Model_esia::NODE_COUNT_SERVICE_STATE);
	$total_node=0;
	$total_service=0;
	foreach($arr as $key => $val)
	{
		$list_type[]=array('type'=>$key,
				'nbr_device'=>$val['nbr_device'],
				'nbr_service'=>$val['nbr_service'],
				'ok'=>$val['ok'],
				'critical'=>$val['critical'],
				'warning'=>$val['warning'],
				'unknown'=>$val['unknown']);
		//calcul du nombre de noeud et de service totaux
		$tmp = $val['ok']+$val['warning']+$val['critical']+$val['unknown'];
		$total_service= $total_service+$tmp;
		$total_node = $total_node+$val['nbr_device'];
	}

	$smarty->assign('total_node_type',count($arr));
	$smarty->assign('total_node',$total_node);
	$smarty->assign('total_service',$total_service);
	$smarty->assign('l_list_index',$list_type);

}
elseif($action=='personnalDashboard')
{
	$smarty->assign('personnalDash','yes');
}
//variable de langue
$smarty->assign('l_total', $lang['TOTAL']);
$smarty->assign('l_statistic', $lang['STATISTIC']);
$smarty->assign('l_number_total_service', $lang['NUMBER_TOTAL_SERVICE']);
$smarty->assign('l_node_number', $lang['NODE_NUMBER']);
$smarty->assign('l_node_service_number', $lang['ADM_NODE_SERVICE']);
$smarty->assign('l_node_type', $lang['ADM_NODE_TYPE']);
$smarty->assign('l_ctrl_lgd_ok', $lang['LGD_OK']);
$smarty->assign('l_ctrl_lgd_unknown', $lang['LGD_UNKNOWN']);
$smarty->assign('l_ctrl_lgd_warn', $lang['LGD_WARN']);
$smarty->assign('l_ctrl_lgd_cri', $lang['LGD_CRI']);
$smarty->assign('l_search_desc', $lang['SEARCH_DESC']);
$smarty->assign('l_search_info_desc', $lang['SEARCH_INFO_DESC']);
$smarty->assign('l_search_ip', $lang['SEARCH_IP']);
$smarty->assign('l_search_info_ip', $lang['SEARCH_INFO_IP']);
$smarty->assign('l_search_person', $lang['SEARCH_PERSON']);
$smarty->assign('l_search_info_person', $lang['SEARCH_INFO_PERSON']);
$smarty->assign('l_last_event', $lang['NETWORK_STATE']);
$smarty->assign('l_groups', $lang['GROUPS']);
$smarty->assign('l_help', $lang['HELP']);
$smarty->assign('l_faq', $lang['FAQ']);
$smarty->assign('l_wiki', $lang['WIKI']);
$smarty->assign('l_esiadroid', $lang['ESIADROID']);
//Variable de langue pour le menu d'administration rapide
$smarty->assign('l_adm_list_node', $lang['ADM_LIST_DEV']);
$smarty->assign('l_adm_add_node', $lang['ADM_ADD_DEV']);
$smarty->assign('l_adm_add_gesa', $lang['ADM_ADD_GESA']);
$smarty->assign('l_adm_add_user', $lang['ADM_CREATE_USER']);
$smarty->assign('l_adm_add_group', $lang['ADM_CREATE_GROUP']);

//affichage de la page
$smarty->display('index_body.html');

?>
