<?php
/**
 * @name node_control
 * @description script PHP appellé en AJAX, Affiche l'état des service ainsi que son historique ou celui du noeud
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 19/11/2012
 */
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once DEVICE_CLASS;
//on vérifie que l'id est bien numérique
if(is_numeric($_GET['id']))
{
	try
	{
		//on instancie le noeud
		$node =  Model_esia::InstanceNode($dbconnection, $_GET['id']);
		//on assigne les variables du noeud
		$smarty->assign('node_name',$node->getName() );
		$smarty->assign('node_id',$node->getId() );
		$smarty->assign('node_description',$node->getDescription() );
		$smarty->assign('node_group',$node->getGroup() );
		$smarty->assign('node_type',$node->getType() );
		$smarty->assign('node_snmp_version',$node->getSNMPVersion() );
		$smarty->assign('node_ip_address',$node->getIPv4Adress());
		//vérifacation des droits d'accès
		if($user->getDroits($dbconnection,"esia_device") ==1)
		{
		    $smarty->assign('adm_access','1');
		}
		if($user->getDroits($dbconnection,"acquit_access",$node->getName()) ==1){
		    $smarty->assign('acq_access','1');
		}
		if($user->getDroits($dbconnection,"device_view",$node->getName()) ==1)
		{
			//Etats des services
			$listState = Model_esia::countNodeState($dbconnection, $node->getId());
			$nbr_error=0;
			$smarty->assign('status_nbr_critical',$listState['critical']);
			$smarty->assign('status_nbr_warning',$listState['warning']);
			$smarty->assign('status_nbr_unknown',$listState['unknown']);
			//on additionne les erreurs et les services OK (on a ainsi le total des services check et des services passifs)
			$nbr_error=$nbr_error+$listState['critical']+$listState['warning']+$listState['unknown'];
			$smarty->assign('status_nbr_error',$nbr_error);
			$smarty->assign('status_nbr_OK',$listState['OK']);
			$smarty->assign('status_nbr_service',$nbr_error + $listState['OK'] );
			$smarty->assign('icn_ack',$ICONS['ack_errors'] );
			//on vérifie l'action demandée
			if(isset($_GET['action'])&&!empty( $_GET['action']))
			{
				if($_GET['action']=='historic')
				{
					$smarty->assign('action','historic');
					if(isset($_GET['service']) && is_numeric($_GET['service']))	//historique du service
					{
						$r = Model_esia::getNodeErrorHistoric($dbconnection,$node,$_GET['service']);
					}
					else
					{
						//historique sur le noeud
						$r = Model_esia::getNodeErrorHistoric($dbconnection,$node->getId() );
						$list= array();
						foreach($r as $row)
						{
                            $row['during'] = preg_replace('#000#','',$row['during']);
							$common_name = Model_esia::getCommonName($lang, $row['service'], $row['plugin_name']);
							$list[] = array('service' => $row['service'],
											'type' => $row['type'],
											'time' => $row['time'],
											'acquitte_time' => $row['acquitte_time'],
											'during' => $row['during'],
											'value' => $row['value'],
											'message' => $row['message'],
											'user_name' => $row['user_name'],
											'common_name'=>$common_name,
											'happen_id'=>$row['happen_id']				
							);
						}
					}
					$smarty->assign('historic_error', $list);
				}
				elseif($_GET['action']=='acquitte')
				{
					if($user->getDroits($dbconnection,"acquit_access") ==1)
					{
						
						if(isset($_GET['error']))
						{
							if($user->getId()!== null)
							{
								Model_esia::acquitteError($dbconnection,$_GET['error'],$user->getId());
							}
							else 	
							{
								Model_esia::acquitteError($dbconnection,$_GET['error']);								
							}
							echo "Erreur acquitté";
						}
						else 
						{
							if($user->getId()!== null)
							{
								Model_esia::acquitteError($dbconnection,null,$_GET['service'],$user->getId());
							}
							else
							{
								Model_esia::acquitteError($dbconnection,null,$_GET['service']);
							}
							echo "Erreur acquitté";
						}
						exit(0);
					}
					else
						throw new EsiaDbException("error: you don't have acces on this node");
				}
				elseif($_GET['action']=='cancel_acquit')
				{
					if($user->getDroits($dbconnection,"acquit_access") ==1)
					{
						if(isset($_GET['service']))
						{
							try{
								Model_esia::notAcquitteError($dbconnection,$_GET['service']);
							}
							catch(Exception $e)
							{
								//au niveux de la requête de la base de donnée cela arrive si on demande les infos d'un noeud qui n'existe pas
								echo $e->getMessage()."<br>";
								$smarty->assign('cancel_acquit', $e->getMessage());
							}
						}
					}
					exit(0);
				}
				elseif($_GET['action']=='setMaintenance')
				{
					if($user->getDroits($dbconnection,"esia_device") ==1)
					{
						if(isset($_GET['error']))
						{
							try{
								Model_esia::setErrorMaintenance($dbconnection,$_GET['error']);
							}
							catch(Exception $e)
							{
								//au niveux de la requête de la base de donnée cela arrive si on demande les infos d'un noeud qui n'existe pas
								echo $e->getMessage()."<br>";
								$smarty->assign('setErrorMaintenance', $e->getMessage());
							}
						}
					}
					exit(0);
				}
				elseif($_GET['action']=='executeService')
				{
					if($user->getDroits($dbconnection,"esia_device") ==1)
					{
						$smarty->assign('nodeid', $node->getId());
						$smarty->assign('action', 'executeService');
						$smarty->assign('dialog_title', $lang['EXECUTE_SERVICE']);
						
						
						if(isset($_GET['service']))
						{
							$service_id=$_GET['service'];
							$service = Model_esia::getServices($dbconnection,$node->getId(),$service_id);
							//echo'<pre>';print_r($service[0]);echo'</pre>';
							$rrd = Model_esia::getRRDInformationByServiceId($dbconnection,$service_id);
							$smarty->assign('serviceid', $service_id);
							//echo "nom:".$service[0]['check_plugin_name'];
							if(!preg_match('#^GESA#',$service[0]['check_plugin_name']))
							{
								$smarty->assign('rrd', $rrd);
							}
							//echo'<pre>';print_r($rrd);echo'</pre>';
							//création du json C3
							$c3parameter= array();
							if($_GET['format']=="json")
							{
								try{
									$params = $service[0]['parameter'];
									$path = $service[0]['path'];
									$common_name = Model_esia::getCommonName($lang,$service[0]['name'],$service[0]['check_plugin_name']);
									$params = str_replace('$IP',$node->getIPv4Adress(),$params);
									$params = str_replace('$SNMP_COM',$node->getSNMPCommunity(),$params);
									if(is_a($node,'RemoteDevice'))
									{
										$params = str_replace('$NRPE_HOST',$node->getGESA()->getPublicIPaddress(),$params);
										$params = str_replace('$GESASN',$node->getGESA()->getSerialNumber(),$params);
									}
									//traitement particulier sur certain plugins
									
									if($service[0]['check_plugin_name'] == 'CHECK_SNMP_INTERFACE_EASY'||$service[0]['check_plugin_name'] == 'CHECK_SNMP_SW_INTERFACE_EASY')
									{
										if(!is_dir($_SERVER['DOCUMENT_ROOT'].'/data/realtime_buffer/'))
										{
											if(!mkdir($_SERVER['DOCUMENT_ROOT'].'/data/realtime_buffer/'))
											{
												throw new Exception("Can't create directory");
											}
										}
										$params= $params.' -p "'.$_SERVER['DOCUMENT_ROOT'].'/data/realtime_buffer/"';
										//echo $param;
									}
									
									
									exec($path." ".$params,$output,$result);
									$output=$output[0];
									if($result==255)
									{
										$result=3;
										$output="Unknown error: check parameter";
									}
									$last_exec = date("d-m-Y H:i:s");
									$arr=array();
									$arr["lastexec"] = "$last_exec";
									$arr["common_name"] = "$common_name";
									$arr["output"] = explode("|",$output)[0];
									$arr["result"] = "$result";
									foreach($rrd as $line)
									{
										$row=array();
										if(preg_match($line['regex'], $output,$regs))
										{
											$row[$line['name']] = array($regs[1]);
											if(array_key_exists($line['num'],$c3parameter))
											{
												array_push($c3parameter[$line['num']],$row);
											}
											else
											{
												$c3parameter[$line['num']][]=$row;
											}
										}
									}
									$arr["data"] = array_values($c3parameter);
									echo json_encode($arr);
									exit(0);
								}
								catch(Exception $e)
								{
									echo $e->getMessage()."<br>";
									$smarty->assign('executeService', $e->getMessage());
								}
							}
						}
					}
				}			
				elseif($_GET['action']=='report')
				{
					if(isset($_GET['serviceid']))
					{
						$smarty->assign('action','report');
						$smarty->assign('serviceid',$_GET['serviceid']);
						$r = Model_esia::getServices($dbconnection,$node->getId(),$_GET['serviceid']);
						$service=$r[0];					
						$plugin=array('id'=>$service['id'],
									'name'=>$service['name'],
									'state'=>$service['state'],
									'time'=>$service['last_exec_time'],
									'time_check'=>$service['added_time'],
									'check_plugin_name'=>$service['check_plugin_name'],
									'stdout'=>$out);
						$smarty->assign('plugin', $plugin);
						setlocale (LC_TIME,"fr_BE.UTF-8");
						$date = array();
						for($i=1;$i<13;$i++)
						{
							$lastmonth = mktime(0, 0, 0, date("m")-$i, 1,   date("Y"));
							$date[]=array('title'=>strftime('%B - %Y',$lastmonth), 'month'=>date('m',$lastmonth) ,'year'=>date('Y',$lastmonth));
						}
						$smarty->assign('daterepport', $date);
					}
					else
					{
						$smarty->assign('action','report');
						//état des services "check"
						$r = Model_esia::getServices($dbconnection,$node->getId());
						$list_plugin=array();
						foreach($r as $service)
						{
							$out = preg_replace('#\|[a-z].*\n#',"\n",$service['stdout']);
						//	$out = preg_replace('#\n#','<br />',$service['stdout']);
							$list_plugin[]=array('id'=>$service['id'],
									'name'=>$service['name'],
									'state'=>$service['state'],
									'time'=>$service['last_exec_time'],
									'time_check'=>$service['added_time'],
									'check_plugin_name'=>$service['check_plugin_name'],
									'stdout'=>$out);
						}
						$lastmonth = mktime(0, 0, 0, date("m")-1, date("d"),   date("Y"));
						setlocale (LC_TIME,"fr_BE.UTF-8");

						$date=array('title'=>strftime('%B - %Y',$lastmonth), 'month'=>date('m',$lastmonth) ,'year'=>date('Y',$lastmonth));
						$smarty->assign('daterepport', $date);
						$smarty->assign('list_plugin', $list_plugin);
					}

				}
				elseif($_GET['action']=='show_snmp')
				{
					try
					{
						session_write_close();
						$smarty->assign('action','show_snmp');
						include_once $path.'/libs/logo_oid.hash.php';
						$smarty->assign('node_sysdescr',$node->getSysDescr());
						$smarty->assign('node_syscontact',$node->getSysContact());
						$smarty->assign('node_syslocation',$node->getSysLocation());
						$smarty->assign('node_sysname',$node->getSysName()); 
						$smarty->assign('node_uptime',$node->getUpTime());
						$objectid = $node->getSysObjectId();
						$logo = IANA::getManufacturerLogo($objectid, $node->getSysDescr());
						$smarty->assign('manufacturer_logo',$logo['logo']);
						/*foreach($objectid as $line)
						{
							if(preg_match('#1\.3\.6\.1\.4\.1\.([0-9]*)\..*#', $line,$regs))
							{
								if(array_key_exists($regs[1],$LOGO_BY_IANA_ENTERPRISE_OID))
								{
									$logo = $LOGO_BY_IANA_ENTERPRISE_OID[$regs[1]];
									
									$smarty->assign('manufacturer_logo',$logo);
								}
							}
					
						}*/
					}
					catch(DeviceException $e)
					{
						
					}
				}
				elseif($_GET['action']=='connectedto')
				{
					if(isset($_GET['view']) &&  $_GET['view'] == 'all' )
					{
						$smarty->assign('view','all');
					}
					$smarty->assign('action','connectedto');
					$connectedto = array();
					$listsw = Model_esia::getConnectedTo($dbconnection, $user->getId(), $node->getId());
					foreach($listsw as $switch)
					{
						$swnode = Model_esia::InstanceNode($dbconnection, $switch['id']);
						$page_control = Model_esia::getPageControl($dbconnection, $swnode->getType() );
						if($page_control!=null)
						{
							$page_control = Model_esia::replacePageControlVariable($page_control,$swnode);
						}
						else
						{
							$page_control = '/node_view.php?name='.$swnode->getId();
						}
						if($swnode->getType()=='switch')
							$page_control = $page_control.'&interface='.$switch['interface_name'];
						$name = $switch['name'].' - '.$switch['interface_name'];
						$connectedto[]=array('id'=>$node->getId(),'name' => $name,'pageControl'=>$page_control,'mac'=>$switch['macnode'],'type_img'=>$ICONS[$swnode->getType()]);
					}
					if(!empty($connectedto))
					{
						$smarty->assign('connectedto', $connectedto);
					}
					else 
					{
						$smarty->assign('connectedto', '');
						exit(1);
					}
				}
			}
			else
			{
				$show_only_state = null;
				if(isset($_GET['show'])&&$_GET['show']=='state')
				{
					$smarty->assign('show','state');
					if(isset($_GET['status']))
					{
						switch($_GET['status'])
						{
							case 'ok': $show_only_state= 0; break;
							case 'warning': $show_only_state= 1; break;
							case 'critical': $show_only_state= 2; break;
							case 'unknown': $show_only_state= 3; break;
							default: break;
						}						
					}
				}
				if(isset($_GET['show_logo']))
				{
					$snmp_version = $node->getSNMPVersion(); 
					if(isset($snmp_version) && !empty($snmp_version) )
					{
						$smarty->assign('snmp_available','1');
					}
				}
				//état des services "check"
				$r = Model_esia::getServices($dbconnection,$node->getId());
				$list_plugin=array();
				foreach($r as $service)
				{
					$out = preg_replace('#\|[a-z].*#',"\n",$service['stdout']);
					if($service['real_state']==0)
					{
						$lstatus = $lang['LGD_OK'];
					}
					elseif($service['real_state']==1)
					{
						$lstatus = $lang['LGD_WARN'];
					}
					elseif($service['real_state']==2)
					{
						$lstatus = $lang['LGD_CRI'];
					}
					elseif($service['real_state']==3)
					{
						$lstatus = $lang['LGD_UNKNOWN'];
					}

					$common_name = Model_esia::getCommonName($lang,$service['name'],$service['check_plugin_name']);
					if(isset($show_only_state))
					{
						if($show_only_state == $service['state'])
						{
							$list_plugin[]=array('id'=>$service['id'],
									'name'=>$service['name'],
									'state'=>$service['state'],
									'time'=>$service['last_exec_time'],
									'time_check'=>$service['added_time'],
									'stdout'=>$out,
									'real_state'=>$service['real_state'],
									'check_plugin_name'=>$service['check_plugin_name'],
									'lstatus' =>$lstatus,
									'common_name'=>$common_name
							);
						}
					}
					else
					{
						$list_plugin[]=array('id'=>$service['id'],
							'name'=>$service['name'],
							'state'=>$service['state'],
							'time'=>$service['last_exec_time'],
							'time_check'=>$service['added_time'],
							'stdout'=>$out,
							'real_state'=>$service['real_state'],
							'check_plugin_name'=>$service['check_plugin_name'],
							'lstatus' =>$lstatus,
							'common_name'=>$common_name
						);
					}
				}
				$smarty->assign('list_plugin', $list_plugin);
				$smarty->assign('action','');
			}
		}
		else
		{
			//erreur d'accès
			$smarty->assign('l_bad_access', $lang['NO_ACCES']);
		}
	}
	catch(EsiaDbException $e)
	{
		//au niveux de la requête de la base de donnée cela arrive si on demande les infos d'un noeud qui n'existe pas
		$smarty->assign('l_bad_access', $e->getMessage());
	}
}
elseif(isset($_GET['service'])&&!empty($_GET['service']))
{
	$smarty->assign('service',$_GET['service']);
	$r = Model_esia::getServices($dbconnection,null,$_GET['service']);
	$service=$r[0];
	$common_name = Model_esia::getCommonName($lang,$service['name'],$service['check_plugin_name']);
	$smarty->assign('name',$common_name);
	$smarty->assign('action',$_GET['action']);	
}
elseif(isset($_GET['action'])&&!empty($_GET['action']))
{
	$action = $_GET['action'];
	if($action=='getRdpSoftware')
	{
		$os="";
		$node=$_GET['node'];
		$agent = $_SERVER['HTTP_USER_AGENT'];	
		if(preg_match('/Linux/',$agent)) $os = 'Linux';
		$rdp = Model_esia::getEsiaRdp($dbconnection,null,$node)[0];
		$params = json_decode($rdp['adv_param'],true);
		$software['type'] = $params['type'];
		$software['id'] = $params['id'];
		//echo "SOFT : ".$software;
		if(!empty($software))
		{
			$software['os']=$os;
			echo json_encode($software);
		}
		else
		{
			echo json_encode("");
		}
		exit(0);
	}
}
//Variables de langue
$smarty->display('node_control.html');
?>
