<?php
/**
 * @name node_list.
 * @description page affichant les noeuds se trouvant dans un groupe page node_list
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 19/11/2012
 */
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once DEVICE_CLASS;
$temps = microtime();
$temps = explode(' ', $temps);
$debut = $temps[1] + $temps[0];
//ajout d'un lien pour la navbar
array_push($_SESSION['navbar'],array('name'=> $lang['NODE'],'link'=>'/node_index.php'));

if(isset($_GET['nom'])&&!empty($_GET['nom']))
{
	$nom=$_GET['nom'];
}
else
{
	$nom='noGroup';
}
try
{
	array_push($_SESSION['navbar'],array('name'=> $nom,'link'=>'/node_list.php?nom='.$nom));
	//récupération de la liste des noeuds
	$Nodes=Model_esia::getNodeList($dbconnection,$user->getId(),$nom,Model_esia::NODE_INSTANCE);
	$devType = Model_esia::getDeviceType($dbconnection);
	$list_node=array();
	foreach($Nodes as $node)
	{
		$err_type='ok';
		$err_nbr=0;
		//on récupère l'état du noeud
		$NodeState = Model_esia::countNodeState($dbconnection, $node->getId());
		foreach($NodeState as $k => $v)
		{
			if($k!='OK')
			{
				$err_nbr=$err_nbr+$v;
			}
		}
		if($NodeState['critical']!=0)
		{
			$err_type='critical';
		}
		elseif($NodeState['warning']!=0)
		{
			$err_type='warning';
		}
		elseif($NodeState['unknown']!=0)
		{
			$err_type='unknown';
		}
		//page de control du noeud suivant sont type
		$page_control='/node_view.php?name='.$node->getName();
	 	//page donnant plus d'info (bouton plus de la page "node_list.php"
		$page_list=null;
		if(!empty($devType[$node->getType()]['web_plugin_list_page']))
		{
			$page_list = $devType[$node->getType()]['web_plugin_list_page'];
			$page_list = preg_replace('#:action#','list',$page_list);
			$page_list = preg_replace('#:dev_name#',$node->getName(),$page_list);
			$page_list =$devType[$node->getType()]['web_plugin_apache_path'].$page_list;
		}
		//page de contrôle
		if(!empty($devType[$node->getType()]['web_plugin_control_page']))
		{
			$page_control = Model_esia::replacePageControlVariable($devType[$node->getType()]['web_plugin_control_page'],$node);
			$page_control = $devType[$node->getType()]['web_plugin_apache_path'].$page_control;
		}
		//tableau contenant toutes les informations
		$list_node[]=array(
				'id'=>$node->getId(),
				'name'=>$node->getName(),
				'ip_address'=>$node->getIPv4Adress(),
				'ip_dec_address'=>preg_replace('#\n#','',$node->getIPv4DecimalAdress()),
				'type'=>$node->getType(),
				'Description'=>preg_replace('#\n#','<br />',$node->getDescription() ),
				'err_type'=>$err_type,
				'err_nbr'=>$err_nbr,
				'list_page'=>$page_list,
				'control_page'=>$page_control,
				'errors'=>$NodeState
		);

	}
	$smarty->assign('node_list',$list_node);
	$smarty->assign('node_groupname',$nom);
}
catch(EsiaDbException $e)
{
	//au niveux de la requête de la base de donnée cela arrive si on demande les infos d'un noeud qui n'existe pas
	$smarty->assign('l_bad_access', $e->getMessage());
}
//Variable de langue
$smarty->assign('l_status', $lang['STATUS']);
$smarty->assign('l_name_node', $lang['ADM_NAME']);
$smarty->assign('l_type_node', $lang['ADM_NODE_TYPE']);
$smarty->assign('l_description', $lang['ADM_DESCRIPTION']);
$smarty->assign('l_address_ip', $lang['ADM_ADDR_IP']);
$smarty->assign('l_group', $lang['ADM_GRP']);
//affichage de la page
$temps = microtime();
$temps = explode(' ', $temps);
$fin = $temps[1] + $temps[0];
$smarty->assign('l_page_exe', $lang['PAGE_EXE']);
$smarty->assign('l_page_exe_time', $lang['PAGE_EXE_TI']);
// On affiche la différence entre des deux valeurs
$smarty->assign('execute_time',round(($fin - $debut),6) );
$smarty->display('node_list.html');
?>
