<?php
/**
 * @name node_view
 * @description script gérant l'affichage par défaut des différents noeuds quand un web plugin n'est pas spécifié
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 19/11/2012
 */
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
$temps = microtime();
$temps = explode(' ', $temps);
$debut = $temps[1] + $temps[0];
try
{
	if(isset($_GET['name'])&&!empty($_GET['name']))
	{
		//on instancie le noeud
		$node = Model_esia::InstanceNode($dbconnection, $_GET['name']);
		if($user->getDroits($dbconnection,"device_view",$node->getName()) ==1)	//on vérifie les droit
		{
			//ajout d'un lien pour la navbar
			$navbar->addNode($node, $ICONS[$node->getType()]);
			//Etats des services
			$listState = Model_esia::countNodeState($dbconnection, $node->getId());
			$nbr_error=0;
			//on additionne les erreurs et les services OK (on a ainsi le total des services check et des services passifs)
			$nbr_error=$nbr_error+$listState['critical']+$listState['warning']+$listState['unknown'];
			$smt_status = array('nbr_error'=>$nbr_error,
								'nbr_service'=>$nbr_error + $listState['OK']);
			$smt_status = array_merge ($smt_status,$listState);
			
			$smt_node = array('name'=>$node->getName(),
								'ip'=>$node->getIPv4Adress(),
								'id'=>$node->getId(),
								'description'=>$node->getDescription(),
								'group'=>$node->getGroup()
								);
			$smarty->assign('node_status',$smt_status);
			$smarty->assign('node',$smt_node);
			$smarty->assign('node_control_id',$node->getId());
			//affiche les graphs
			if(isset($_GET['action']) && $_GET['action']=='graph')
			{
				$smarty->assign('mode','graph');
			}
			elseif(isset($_GET['action']) && $_GET['action']=='view')
			{
				//affiche un graph en particulié
				$smarty->assign('mode','view_graph');
				$smarty->assign('local_graph_id',$_GET['local_graph_id']);
				$smarty->assign('rra_id',$_GET['rra_id']);
			}
			elseif(isset($_GET['action']) && $_GET['action']=='historic')
			{
				//affiche l'historique d'un noeud
				$smarty->assign('mode','historic');
			}
			else
			{
				//affiche le service
				$smarty->assign('mode','service');
			}
		}
		else	//accès refusé
		{
			$smarty->assign('node_bad_access',$lang['NODE_NO_ACCESS']);
			$smarty->assign('node_bad_access_1',$lang['NODE_NO_ACCESS_1']);
		}
	}
	else	//la variables name n'est pas setté
	{
		$smarty->assign('node_bad_access',$lang['NODE_NO_ACCESS']);
		$smarty->assign('node_bad_access_1',$lang['NODE_NO_ACCESS_1']);
	}
}
catch(EsiaDbException $e)
{
	//au niveux de la requête de la base de donnée cela arrive si on demande les infos d'un noeud qui n'existe pas
	$smarty->assign('node_bad_access',$lang['NODE_NO_ACCESS']);
	$smarty->assign('node_bad_access_1',$lang['NODE_NO_ACCESS_1']);
}
//affichage de la page
$temps = microtime();
$temps = explode(' ', $temps);
$fin = $temps[1] + $temps[0];

// On affiche la différence entre des deux valeurs
$smarty->assign('execute_time',round(($fin - $debut),6) );

$smarty->display('node_view.html');
?>
