<?php
/**
 * Classe telnet du projet ESTIA
 *
 * @name Switch
 * @author Nicolas Biersart <dracosaloc@gmail.com>
 * @copyright Nicolas Biersart 2010
 * @version 0.0.9
 */
class Telnet
{
	private $fp;
	private $usleep;
	public function __construct ($host,$time)
	{
		$this->fp=@fsockopen($host,23,$errno,$errstr);
		if($this->fp===false)
			throw new TelnetUnableToConnectException($errstr);
		stream_set_timeout($this->fp,$time);
		# sending the Telnet header
		fputs($this->fp,chr(0xFF).chr(0xFB).chr(0x1F).chr(0xFF).chr(0xFB).
				chr(0x20).chr(0xFF).chr(0xFB).chr(0x18).chr(0xFF).chr(0xFB).
				chr(0x27).chr(0xFF).chr(0xFD).chr(0x01).chr(0xFF).chr(0xFB).
				chr(0x03).chr(0xFF).chr(0xFD).chr(0x03).chr(0xFF).chr(0xFC).
				chr(0x23).chr(0xFF).chr(0xFC).chr(0x24).chr(0xFF).chr(0xFA).
				chr(0x1F).chr(0x00).chr(0x50).chr(0x00).chr(0x18).chr(0xFF).
				chr(0xF0).chr(0xFF).chr(0xFA).chr(0x20).chr(0x00).chr(0x33).
				chr(0x38).chr(0x34).chr(0x30).chr(0x30).chr(0x2C).chr(0x33).
				chr(0x38).chr(0x34).chr(0x30).chr(0x30).chr(0xFF).chr(0xF0).
				chr(0xFF).chr(0xFA).chr(0x27).chr(0x00).chr(0xFF).chr(0xF0).
				chr(0xFF).chr(0xFA).chr(0x18).chr(0x00).chr(0x58).chr(0x54).
				chr(0x45).chr(0x52).chr(0x4D).chr(0xFF).chr(0xF0));
		usleep(100000);

		fputs($this->fp,chr(0xFF).chr(0xFC).chr(0x01).chr(0xFF).chr(0xFC).
				chr(0x22).chr(0xFF).chr(0xFE).chr(0x05).chr(0xFF).chr(0xFC).chr(0x21));
		usleep(100000);
		$this->usleep=100000;
	}
	public function login($log, $pwd)
	{
		fputs($this->fp,"$log\r");
		usleep($this->usleep);
		fputs($this->fp,"$pwd\r");
		usleep($this->usleep);
		do
		{
			$output.=fread($this->fp, 80);
			// read line by line, or at least small chunks
			$stat=socket_get_status($this->fp);
		}
		while($stat["unread_bytes"]);
		//check login
		if(stristr($output,'Login invalid')) //For Cisco device
			throw new TelnetLoginException('Login failed');
		elseif(stristr($output,'incorrect password')) //For 3com device
		throw new TelnetLoginException('Login failed');
	}
	public function cmd ($cmd)
	{
		fputs($this->fp,"$cmd\r");
		usleep($this->usleep);
		do
		{
			$output.=fread($this->fp, 80);
			// read line by line, or at least small chunks
			$stat=socket_get_status($this->fp);
		}
		while($stat["unread_bytes"]);
		return $output;
	}
	public function close()
	{
		fclose($this->fp);
	}
	public function setTimer($t)
	{
		$this->usleep=$t;
	}
}
class TelnetException extends Exception {}
class TelnetUnableToConnectException extends TelnetException {}
class TelnetLoginException extends TelnetException {}
?>