<?php
define('DEBUG',1);
if(!empty($_SERVER['DOCUMENT_ROOT']))
{
	$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
}
else
{
	$path = '/usr/local/esia/public_html/';
	$_SERVER['DOCUMENT_ROOT'] = $path;
}
include $path.'/esia.conf.php';
//include_once $path.'/data/libs/CiscoSwitch.class.php';


//connection à la base de donnée
try
{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
}
catch(Exception $e)
{
	echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	echo 'N° : '.$e->getCode();
}

include_once MVCMODEL;
include_once $path."/plugin/cloudswitch/model_switch.php";
include_once $path."/plugin/cloudswitch/libs/USL.class.php";
include_once $path."/data/libs/CiscoSwitch.class.php";

//préparation de la requête d'insertion
$queryInsert = $dbconnection->prepare("INSERT INTO esia_interface(interface_id,interface_name,interface_type,interface_device_id,interface_ifindex,interface_mac_addr)
		VALUES (DEFAULT,:name,:type,:dev_id,:ifindex,:mac);");

//prépartation de la requête d'update
$queryUpdate = $dbconnection->prepare("UPDATE esia_interface SET interface_name=:name,interface_type=:type,interface_mac_addr=:mac WHERE interface_device_id=:dev_id AND interface_ifindex=:ifindex;");


//prépartation de la requête d'update pour LLDP
$queryLLDPUpdate = $dbconnection->prepare("UPDATE esia_interface SET interface_name=:name,interface_type=:type WHERE interface_device_id=:dev_id AND interface_mac_addr=:mac;");
//préparation de la requête d'insertion pour LLDP
$queryLLDPInsert = $dbconnection->prepare("INSERT INTO esia_interface(interface_id,interface_name,interface_type,interface_device_id,interface_mac_addr)
		VALUES (DEFAULT,:name,:type,:dev_id,:mac);");

echo "Synchronisation des adresses mac des noeuds contenu dans la DB\n";
//on syncrhonise via SNMP les mac adresse
//provisionne le champ interface_mac_addr de la table interface
$nbrInsertInt=SyncMacAddressWithSNMP($dbconnection,$queryInsert,$queryUpdate);

//on syncrhonise via LLDP les mac adresse
//provisionne le champ interface_mac_addr de la table interface
//permet de lié par exemple un téléphone non snmp.
$nbrLLDP = SyncMacAddressWithLLDP($dbconnection, $queryLLDPInsert, $queryLLDPUpdate);
echo "Synchronisation TERMINEE: $nbrInsertInt nouvelles entrée via SNMP et $nbrLLDP via LLDP\n ";


//récupération de l'entiereté des switchs.

//
//FIN DE LA PHASE1
//


echo "Debut de récupération des tables de mac-adresses des switchs\n";

$querySelectInter = $dbconnection->prepare("SELECT interface_id FROM esia_interface WHERE interface_mac_addr = ?");
$querySelectInterWithInterfaceName = $dbconnection->prepare("SELECT interface_mac_addr FROM esia_interface WHERE interface_name = ? AND interface_device_id=?");
$querySelectInterSwitch = $dbconnection->prepare("SELECT interface_id FROM esia_interface WHERE interface_device_id = ?  AND interface_ifindex =?");
$queryDeleteConnected = $dbconnection->prepare("DELETE FROM esia_interface_connected_to WHERE conint_switch_interface_id = ?;");
$queryInsertConnected = $dbconnection->prepare("INSERT INTO esia_interface_connected_to(conint_switch_interface_id, conint_interface_id2,conint_protocol)VALUES (?, ?,?);");

//
//récupération de l'entiereté des switchs.
//

//Liaison via les adresse mac des liens non trunk. 
$list = Model_switch::getNodebyType($dbconnection,null,'switch');
//$list[] = Model_switch::InstanceSwitch($dbconnection, 'zyxel');
foreach ($list as $node)
{
		Trace($node->getId().' '.$node->getName().' MAC ADDRESS TABLE: ');
		$objectid = $node->getSysObjectId();
		//si c'est un switch cisco
		if(preg_match($objectid[0],'\.3\.6\.1\.4\.1\.9'))
		{
			getCiscoMacAdresseTable($node,$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected);
		}
		else
		{
			getMacAdresseTable($node,$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected);
		}
		//getCiscoMacAdresseTable($node,$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected)
}
exit(0);
echo "Récupération des tables de mac adresse terminée\n";

echo " LIAISON VIA LLDP\n";
//
//on interroge via LLDP
//
$list = Model_switch::getNodebyType($dbconnection,null,'switch');
foreach ($list as $node)
{
	try
	{
		//récupération de la correspondace LLDPID ==> IfIndex
		$portifIndex = array();
		$snmp = $node->getSNMPObject();
		$lldpId =  array();
		//Si switch est bien compatible LLDP-MIB il ne générera pas d'exception
		$result = $snmp->snmpwalkoid($node->getIPv4Adress(), '1.0.8802.1.1.2.1.3.7.1.4');
		foreach($result as $key => $value)
		{
			$ifDesc = formatString($value);
			if(preg_match('#0\.8802\.1\.1\.2\.1\.3\.7\.1\.4\.([0-9\.]*)#',$key,$regs ))
			{
				$lldpId[$ifDesc]= $regs[1];

			}
		}
		$list_LLDPID_Ifindex =array();
		//on a les LLDP ID maintenant on va récupérer le ifIndex
		$result = $snmp->snmpwalkoid($node->getIPv4Adress(), '1.3.6.1.2.1.2.2.1.2');
		foreach($result as $key => $value)
		{
			$ifDesc = formatString($value);
			if(preg_match('#3\.6\.1\.2\.1\.2\.2\.1\.2\.([0-9\.]*)#',$key,$regs ))
			{
				if(array_key_exists($ifDesc, $lldpId))
				{
					//création du tableau de correspondance ifindex vs lldpid
					$list_LLDPID_Ifindex[$lldpId[$ifDesc]]= $regs[1];
				}
			}
		}
		// Si le $list_LLDPID_Ifindex est égal à 0  c'est que le switch ne respecte pas le standart grrr ><
		//on va donc interrogé le lldpLocPortId 	1.0.8802.1.1.2.1.3.7.1.3 afin de savoir si on peut faire une correspondance:
		if(count($list_LLDPID_Ifindex)==0)
		{
			//Si switch est bien compatible LLDP-MIB il ne générera pas d'exception
			$result = $snmp->snmpwalkoid($node->getIPv4Adress(), '1.0.8802.1.1.2.1.3.7.1.3');
			foreach($result as $key => $value)
			{
				$ifDesc = formatString($value);
				if(preg_match('#0\.8802\.1\.1\.2\.1\.3\.7\.1\.3\.([0-9\.]*)#',$key,$regs ))
				{
					$lldpId[$ifDesc]= $regs[1];
			
				}
			}
			$list_LLDPID_Ifindex =array();
			//on a les LLDP ID maintenant on va récupérer le ifIndex
			$result = $snmp->snmpwalkoid($node->getIPv4Adress(), '1.3.6.1.2.1.2.2.1.2');
			foreach($result as $key => $value)
			{
				$ifDesc = formatString($value);
				if(preg_match('#3\.6\.1\.2\.1\.2\.2\.1\.2\.([0-9\.]*)#',$key,$regs ))
				{
					if(array_key_exists($ifDesc, $lldpId))
					{
						//création du tableau de correspondance ifindex vs lldpid
						$list_LLDPID_Ifindex[$lldpId[$ifDesc]]= $regs[1];
					}
				}
			}
		}
		
		//TABLEAU DE CORRESPONDANCE OK
		Trace("\t LLDP:".$node->getId().' '.$node->getName().' TABLEAU DE CORRESPONDANCE OK' );
		Trace($list_LLDPID_Ifindex);
		
		try
		{
			//on récucpère la liste des mac adresse connectée 
			$listmac = getLLDPMacAddressBySNMP($node);
			Trace($listmac);
			foreach($listmac as $lineMac)
			{
				$counter = $lineMac['counter'];
				$lldpid = $lineMac['lldpid'];
				$neighborid =$lineMac['neighborid'];
				$mac = $lineMac['mac'];
				Trace("\t\tLLDP: ".$mac.":".$list_LLDPID_Ifindex[$lldpid].":LLDPID:$lldpid:$counter:$neighborid");
				$state = linkInterface($mac, $list_LLDPID_Ifindex[$lldpid], $node,'LLDP', $querySelectInter, $queryDeleteConnected, $querySelectInterSwitch, $queryInsertConnected);
				//si state == -1 alors la mac n'a pas été trouvée dans la DB (noeud inexistant) ou alors il s'agit de la mac interne d'un switch et non pas de la mac de l'interface
				if($state==-1)
				{
					//on va tenter de récupérer le nom de l'appareil et l'interface et de quand même essayer de les liée
					$value = $node->snmpget("1.0.8802.1.1.2.1.4.1.1.9.$counter.$lldpid.$neighborid");
					$value = formatString($value);
					//si le nom n'est pas vide on va tenter d'instancier un noeud
					if(!empty($value))
					{
						try
						{
							$distnode = Model_esia::InstanceNode($dbconnection, $value);
							Trace("\tLLDP: ".$distnode->getName().' Instance SUCCESS');
							//Ona le noeud maintenant on récupère l'interface
							$value = $node->snmpget("1.0.8802.1.1.2.1.4.1.1.8.$counter.$lldpid.$neighborid");
							$value = formatString($value);
							Trace($value);
							$result = Model_esia::executeStatement($querySelectInterWithInterfaceName,array($value,$distnode->getId()));
							$result = $result->fetchAll();
							Trace($result);
							//si c'est différents de 0 c'est que l'interface a été trouvée est dans la base de données.
							if(count($result)!=0)
							{
								Trace("\tLLDP: ".$distnode->getName().' '.$result[0]['interface_mac_addr'].' '.$list_LLDPID_Ifindex[$lldpid].' '.$distnode->getName());
								$state = linkInterface($result[0]['interface_mac_addr'], $list_LLDPID_Ifindex[$lldpid], $node,'LLDP', $querySelectInter, $queryDeleteConnected, $querySelectInterSwitch, $queryInsertConnected);
							}
						}
						catch(Exception $e )
						{
							Trace("\tLLDP: $value : NODE NO FOUND");
						}
					}
				}
			}
		}
		catch(Exception $e )
		{
			Trace("\tLLDP: ".$node->getName()." LLDPID:$lldpid:".$e->getMessage());
		}
	}
	catch(Exception $e)
	{
		Trace("\tLLDP:".$node->getId().' '.$node->getName().' SNMP ERROR: '.$e->getMessage());
	}
}
echo " LIAISON VIA CDP\n";
//
//on interroge via CDP
//

$querySelectSwitchByIP = $dbconnection->prepare("SELECT device_id,interface_id 
												 FROM esia_device 
												 JOIN esia_interface ON interface_device_id = device_id 
												 WHERE device_ip_addr = ? AND interface_name=?");

$list = Model_switch::getNodebyType($dbconnection,null,'switch');
foreach ($list as $node)
{
	try
	{
		$result = $node->snmpwalkoid("1.3.6.1.4.1.9.9.23.1.2.1.1.20");
		foreach($result as $key => $value)
		{
			if(preg_match('#\.3\.6\.1\.4\.1\.9\.9\.23\.1\.2\.1\.1\.20\.([0-9\.]*)\.([0-9]*)#',$key,$regs ))
			{
				$value = formatHexString($value);
				$ip = hexdec($value);
				$cdpid = $regs[2];
				//on va rechercher le nom de l'interface distante:
				$ifName = $node->snmpget("1.3.6.1.4.1.9.9.23.1.2.1.1.7.$regs[1].$cdpid");
				$ifname = formatString($ifName);
				//on sélectionne le switch distant
				$swdistant = Model_esia::executeStatement($querySelectSwitchByIP,array($ip,$ifname));
				$swdistant = $swdistant->fetchAll();
				//si c'est différents de 0 c'est que le switch distant est référencé
				if(count($swdistant)!=0)
				{
					//on prend l'id de l'interface locale:
					$ridlocal = Model_esia::executeStatement($querySelectInterSwitch,array($node->getId(),$regs[1]));
					$ridlocal = $ridlocal->fetchAll();
					$idlocal = $ridlocal[0]['interface_id'];
					Model_esia::executeStatement($queryDeleteConnected,array($idlocal));
					Model_esia::executeStatement($queryInsertConnected,array($swdistant[0]['interface_id'],$idlocal,'CDP'));

				}


			}
		}
	
	}
	catch(Exception $e)
	{
		Trace("\tCDP:".$node->getId().' '.$node->getName().' SNMP ERROR: '.$e->getMessage());
	}
}



/**
 * Synchronise les adresses MAC des interface réseau avec la base de donnée
 * Le noeud doit être compatible avec la if-mib 
 * @param: $dbconnection l'objet de connexion PDO
 * @param: $queryInsert requete préparée d'insertion des interface dans la DB
 * @param: $queryUpdate requete préparée d'update des interface dans la DB
 * @return: le nombre d'interface qui on été insérée. Ne retourne pas le nombre d'update
 * @exception: /
 */
function SyncMacAddressWithSNMP($dbconnection,$queryInsert,$queryUpdate)
{
	$nbrInsertInt=0;
	//mise à jour des interfaces réseau de chaque noeuds
	$nodes = Model_esia::getNodeList($dbconnection,null,null,Model_esia::NODE_INSTANCE);
	foreach($nodes as $node)
	{
		try
		{
			//	$node = new Device();
			//on vérife que SNMP est activé
			if(!empty($node->getSNMPVersion()))
			{
				Trace($node->getId().' '.$node->getName().' SYNC INTERFACE '. $node->getSNMPVersion());
				$results = $node->snmpwalkoid('1.3.6.1.2.1.2.2.1.6');
				foreach($results as $oid => $value)
				{
					try
					{
						if(preg_match('#Hex-STRING:\s+(.*)#', $value,$regs))
						{
							$mac=$regs[1];
							//on récupère le ifindex
							if(preg_match('#3\.6\.1\.2\.1\.2\.2\.1\.6\.([0-9]*)#', $oid,$regif))
							{
								$ifindex = $regif[1];
								//on prend le ifType et on ne prend que les interface de type 6
								$ifType = $node->snmpget('1.3.6.1.2.1.2.2.1.3.'.$ifindex);
								$ifType = preg_replace('#INTEGER:\s+#', '', $ifType);
								if($ifType=="6"||$ifType=="117")
								{
									//nous n'avons que les interfaces physiques.
									$name='';
									$resname= $node->snmpget('1.3.6.1.2.1.2.2.1.2.'.$ifindex);
									if(preg_match('#Hex-STRING:#', $resname))
									{
										$resname = preg_replace('#\s+#', '', $resname);
										$resname = preg_replace('#Hex-STRING:#', '', $resname);
										$name= Hex2String($resname);
									}
									elseif(preg_match('#STRING:\s+\"(.*)\"#', $resname,$regs))
									{
										$name= $regs[1];
									}
									$params = array(':name'=>$name,':ifindex'=>$ifindex,':type'=>$ifType,':dev_id'=>$node->getId(),':mac'=>$mac );
									$result = Model_esia::executeStatement($queryUpdate,$params);
									if($result->rowCount()==0)
									{
										$result = Model_esia::executeStatement($queryInsert,$params);
										$nbrInsertInt++;
									}
									Trace("\t".$node->getId().' '.$node->getName().' INTERFACE: '. $ifindex.' == '."$mac == ".$result->rowCount());
								}
							}
						}
					}
					catch (Exception $e)
					{
						Trace("\t".$node->getId().' '.$node->getName().' INTERFACE: '.$e->getMessage());
					}
				}
			}
		}
		catch (Exception $e)
		{
			Trace("\t".$node->getId().' '.$node->getName().' SNMP ERROR: '.$e->getMessage());
		}
	}
	return $nbrInsertInt;
}
/**
 * Synchronise les adresses MAC des interface réseau avec la base de donnée
 * Le noeud doit être compatible avec la if-mib
 * @param: $dbconnection l'objet de connexion PDO
 * @return: le nombre d'interface qui on été insérée. Ne retourne pas le nombre d'update
 * @exception: /
 */
function SyncMacAddressWithLLDP($dbconnection,$queryInsert,$queryUpdate)
{
	$querysearchByIP = $dbconnection->prepare('SELECT device_id FROM esia_device WHERE device_ip_addr=?;');
	$nbrInsertInt=0;
	$list = Model_switch::getNodebyType($dbconnection,null,'switch');
	foreach ($list as $node)
	{
		try
		{
			//on récucpère la liste des mac adresse connectée 
			$listmac = getLLDPMacAddressBySNMP($node);
			foreach($listmac as $lineMac)
			{
				$counter = $lineMac['counter'];
				$lldpid = $lineMac['lldpid'];
				$neighborid =$lineMac['neighborid'];
				$mac = $lineMac['mac'];
				//on va tenter de récupérer le nom de l'appareil et l'interface et de quand même essayer de les liée
				$value = $node->snmpget("1.0.8802.1.1.2.1.4.1.1.9.$counter.$lldpid.$neighborid");
				$value = formatString($value);
				//si le nom n'est pas vide on va tenter d'instancier un noeud
				if(!empty($value))
				{
					$distnode = null;
					try
					{
						//on instancie via le nom du noeud 
						$distnode = Model_esia::InstanceNode($dbconnection, $value);
					}
					catch(Exception $e )
					{
						//le noeud n'a pu etre instancier via le nom. Car il ne se trouve pas en DB 
						//on va tenter via l'adresse IP
						$results = $node->snmpwalkoid("1.0.8802.1.1.2.1.4.2.1.3.$counter.$lldpid.$neighborid");
						//l'oid lldpRemManAddrIfSubtype est composée de différent élément 
						//1.0.8802.1.1.2.1.4.2.1.3.{timer count},{port number}, {record number},{type}, {ip address of neighbor} . 
						$ipaddress=0;
						foreach($results as $oid => $value)
						{
							$value = formatInteger($value);
							//si value est égal à 3 c'est que l'addresse ip est contenue dans l'OID
							if($value == 3)
							{
								if(preg_match('#\.([0-9]*\.[0-9]*\.[0-9]*\.[0-9]*)$#', $oid,$reg))
								{
									$ipaddress = $reg[1];
									break;
								}
							}
						}
						if($ipaddress!=0)
						{
							$tmp =  new Device();
							$tmp->setIPv4Adress($ipaddress);
							$results = Model_esia::executeStatement($querysearchByIP,array($tmp->getIPv4DecimalAdress()));
							$row = $results->fetch(PDO::FETCH_OBJ);
							$distnode = Model_esia::InstanceNode($dbconnection, $row->device_id);
						}
						Trace("\tSYNC LLDP: ".$ipaddress.' SUCCESS');
					}
					//on regarde si on a reussi a instancier un noeud.
					if(isset($distnode))
					{
						Trace("\tSYNC LLDP: ".$distnode->getName().' Instance SUCCESS');
						//on élimine les switchs afin de ne pas pourrir avec la mac addresse virtuelle du switch et si SNMP est activer on a pu récupérer via la première méthode
						if($distnode->getType()!='switch' && empty($distnode->getSNMPVersion()))
						{
							//on récupère le nom de l'interface
							$value = $node->snmpget("1.0.8802.1.1.2.1.4.1.1.7..$counter.$lldpid.$neighborid");
							$name = formatString($value);
							//on a l'id du nom 
							$params = array(':name'=>$name,':type'=>6,':dev_id'=>$distnode->getId(),':mac'=>$mac );
							$result = Model_esia::executeStatement($queryUpdate,$params);
							if($result->rowCount()==0)
							{
								$result = Model_esia::executeStatement($queryInsert,$params);
								$nbrInsertInt++;
							}
							Trace("\tSYNC LLDP: ".$node->getId().' '.$node->getName().' INTERFACE: '."$mac == ".$result->rowCount());
						}
					}
				}
			}
		}
		catch (Exception $e)
		{
			Trace("\tSYNC LLDP: ".$node->getId().' '.$node->getName().' SNMP ERROR: '.$e->getMessage());
		}
	}
	return $nbrInsertInt;
}
/**
 * Lie les mac addresse d'un noeud à une interface donnée
 * @param: $dbconnection l'objet de connexion PDO
 * @param: $ifindex ifindex de l'interface ou est connectée la mac
 * @param: $node Un object device représentant le switch
 * @param: $type Type de protocol utilisé
 * @param: $querySelectInter requete préparée qui récupère l'id de l'interface lié à la mac address
 * @param: $queryDeleteConnected requete préparée qui supprime l'ancienne liaison
 * @param: $querySelectInterSwitch requete préparée qui permet de récupéré l'id de l'interface via le node Id et le ifindex
 * @param: $queryInsertConnected requete préparée qui de lié les 2 autre interface
 * @return: /
 * @exception: esiaDBException si une erreur survient
 */
function linkInterface($mac,$ifindex,$node,$type,$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected )
{
	$status = 1;
	//On récupère les identifiants des interface liée à cette mac addresse
	$result = Model_esia::executeStatement($querySelectInter,array($mac));
	$result = $result->fetchAll();
	//si c'est différents de 0 c'est que l'appareil est dans la base de données.
	if(count($result)!=0)
	{
		$int = $result[0];
		$result = Model_esia::executeStatement($querySelectInterSwitch,array($node->getId(),$ifindex));
		$result = $result->fetchAll();
		$int_swId = $result[0];
		Model_esia::executeStatement($queryDeleteConnected,array($int_swId['interface_id']));
		//on insert toutes les données.
		Model_esia::executeStatement($queryInsertConnected,array($int_swId['interface_id'],$int['interface_id'],$type));		
	}
	else
	{
		$status = -1;
	}
	return $status;
}
function getLLDPMacAddressBySNMP(Device $node)
{
	$listmac = array();
	//on va maintenant récupérer les information sur les noeuds connectés via le LldpChassisIdSubtyp
	$result = $node->snmpwalkoid('1.0.8802.1.1.2.1.4.1.1.4');
	Trace("\t\t\tFCT:getLLDPMacAddressBySNMP:1.0.8802.1.1.2.1.4.1.1.4: success");
	foreach($result as $key => $value)
	{
		$type = formatInteger($value);
		//si le  LldpChassisIdSubtype il est égal à 4 ça signigie que le chassisID est égal à la mac address
		if($type == 4)
		{
			//on va récupérer l'id snmp du noeuds ainsi que le LLDPid du port du switch
			if(preg_match('#0\.8802\.1\.1\.2\.1\.4\.1\.1\.4\.([0-9\.]*)\.([0-9\.]*)\.([0-9\.]*)#',$key,$regs ))
			{
				$counter = $regs[1];
				$lldpid = $regs[2];
				$neighborid = $regs[3];
				//récupération de la mac adresse
				Trace("\t\t\tFCT:getLLDPMacAddressBySNMP:1.0.8802.1.1.2.1.4.1.1.5.$counter.$lldpid.$neighborid");
				$value='';
				//l'Alpine ne permet pas d'interroger en direct les oid donc si une erreur est levée on fera un test indirect.
				try
				{
					$value = $node->snmpget("1.0.8802.1.1.2.1.4.1.1.5.$counter.$lldpid.$neighborid");
				}
				catch(Exception $e)
				{
					$l_snmp_macaddress = $node->snmpwalkoid("1.0.8802.1.1.2.1.4.1.1.5");
					Trace($l_snmp_macaddress);
					foreach($l_snmp_macaddress as $key => $snmpmac)
					{
						$pattern = "#0\.8802\.1\.1\.2\.1\.4\.1\.1\.5.$counter\.$lldpid\.$neighborid#";
						if(preg_match($pattern,$key))
						{
							$value = $snmpmac;
							break;
						}
					}	
				}
				Trace("\t\t\tFCT:getLLDPMacAddressBySNMP:1.0.8802.1.1.2.1.4.1.1.5.$counter.$lldpid.$neighborid SUCCESS $value");
				if(preg_match('#Hex-STRING#', $value))
				{
					$mac = formatHexString($value);
				}
				elseif(preg_match('#STRING#', $value))
				{
					$mac = formatString($value);
					$mac = preg_replace('#\:#'," " , $mac);
				}
				$listmac[]=array('mac'=>$mac,'lldpid'=>$lldpid,'neighborid'=>$neighborid,'counter'=>$counter);
			}
		}
	}
	return $listmac;
}
/**
 * @brief parse la table de mac adresse en SNMP 
 * @param Device $node objet node
 * @param PDOStatement $querySelectInter request pdo de selection d'interface
 * @param PDOStatement $queryDeleteConnected request pdo qui élimine les liaison entre les interface
 * @param PDOStatement $querySelectInterSwitch selectetionne l'interface des switch 
 * @param PDOStatement $queryInsertConnected lie les interfaces des device avec les switchs
 */
function getCiscoMacAdresseTable($node,$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected)
{
	try 
	{
		Trace($node->getId().' '.$node->getName().' MAC ADDRESS TABLE: ');
		//on instancie des switchs cisco.
		$sw = new CiscoSwitch();
		//$sw = new Switchs();
		$sw->constructDevice($node);
		//on récupère la vlan database pour récupérer les dot1 port qui ne sont accessible que via la communauté snmp +@<vlanid>
		//$vlandatabase = $sw->getVlanDataBase();
		Trace($node->getId().' '.$node->getName().' MAC ADDRESS TABLE: VLAN DATABASE SUCCESS');
		
		//récupération de la correspondace dot1port ==> IfIndex
		$portifIndex = array();
		$snmp = $sw->getSNMPObject();
		$com = $snmp->getCommunity();
		foreach($vlandatabase as $vlanid)
		{
			try
			{
				$comu = $com.'@'.$vlanid;
				$snmp->setCommunity($comu);
				$result = $snmp->snmpwalkoid($sw->getIPv4Adress(), '1.3.6.1.2.1.17.1.4.1.2');
				foreach($result as $key => $line)
				{
					$line = formatInteger($line);
					if(preg_match('#\.3\.6\.1\.2\.1\.17\.1\.4\.1\.2\.([0-9\.]*)#',$key,$regs ))
					{
						$portifIndex[$line]= $regs[1];
					}
				}
			}
			catch(Exception $e)
			{
				Trace("\t".$node->getId().' '.$node->getName().' dot1port ==> IfIndex: ERROR: '.$e->getMessage());
			}
		}
		//récupération des interfaces et des ifindex
		$inters = $sw->getInterfacesMib();
		$arrInterface = array();
		foreach($inters as $int)
		{
			$mode = $int->getModeBySNMP();
			//si l'interfance n'est pas en trunk on la met dans le tableau de correspondance dot1port = > ifindex
			if($mode != 'trunk' )
			{
				if(array_key_exists($int->ifIndex, $portifIndex))
				{
					$arrInterface[$portifIndex[$int->ifIndex]] =$int->ifIndex;
				}
			}
		}
		Trace($node->getId().' '.$node->getName().' List interface no trunk with dot1Port');
		Trace($arrInterface);
		
		//on a toutes les interface qui ne sont pas en mode 'trunk' on va récupérer les mac adresse
		$com = $snmp->getCommunity();
		//on va récupérer toute les mac-addresse
		$dot1port=array();
		foreach($vlandatabase as $vlanid)
		{
			try
			{
				$comu = $com.'@'.$vlanid;
				$snmp->setCommunity($comu);
				//récupération du dot1dTpFdbPort (nécessaire pour récupéer les adresse mac par dot1port
				$result = $snmp->snmpwalkoid($sw->getIPv4Adress(), '1.3.6.1.2.1.17.4.3.1.2');
				foreach($result as $key => $line)
				{
					$line = formatInteger($line);
					//on regarde que l'interface ne soit pas une interface trunk
					if(array_key_exists($line, $arrInterface))
					{
						//ce n'est pas une interface trunk. on va récupérer les mac adresses
						$line=$arrInterface[$line];
						$mac=null;
						if(preg_match('#\.3\.6\.1\.2\.1\.17\.4\.3\.1\.2\.([0-9\.]*)#',$key,$regs ))
						{
							//on a l'identifiant de la mac dans la mib on peut maintenant la récupérer
							$id = $regs[1];
							$mac = $snmp->snmpget($sw->getIPv4Adress(),'1.3.6.1.2.1.17.4.3.1.1.'.$id);
							$mac = formatHexString($mac);
						}
						//si la mac n'est pas vide on l'ajoute au tableau.
						if(!empty($mac))
						{
								
							//sert pour le debug.
							if(!array_key_exists($line,$dot1port ) )
							{
								$dot1port[$line] = array($mac);
							}
							else
							{
								$dot1port[$line] = array_merge($dot1port[$line],array($mac));
							}
							try
							{
								//on va lié les interface entre elle
								linkInterface($mac,$line,$node,'MACTABLE',$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected );
							}
							catch(Exception $e)
							{
								Trace($node->getId().' '.$node->getName().' ERROR INSERT: '.$e->getMessage());
							}
						}
					}
				}
			}
			catch(Exception $e)
			{
				Trace("\t".$node->getId().' '.$node->getName()." mac-addresse FINAL ERROR: $vlanid :".$e->getMessage());
			}
		}
		Trace($node->getId().' '.$node->getName().' MAC ADDRESSE TABLE: ifindex => liste mac');
		Trace($dot1port);
	}
	catch(Exception $e)
	{
		Trace($node->getId().' '.$node->getName().' SNMP ERROR: '.$e->getMessage());
	}	
}
/**
 * @brief parse la table de mac adresse en SNMP
 * @param Device $node objet node
 * @param PDOStatement $querySelectInter request pdo de selection d'interface
 * @param PDOStatement $queryDeleteConnected request pdo qui élimine les liaison entre les interface
 * @param PDOStatement $querySelectInterSwitch selectetionne l'interface des switch
 * @param PDOStatement $queryInsertConnected lie les interfaces des device avec les switchs
 */
function getMacAdresseTable($node,$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected)
{
	try
	{
		Trace($node->getId().' '.$node->getName().' MAC ADDRESS TABLE: ');
		//on instancie des switchs cisco.
		$sw = new Switchs();
		$sw->constructDevice($node);
		//récupération de la correspondace dot1port ==> IfIndex
		$portifIndex = array();
		$snmp = $sw->getSNMPObject();
		$com = $snmp->getCommunity();
		try
		{
			$result = $snmp->snmpwalkoid($sw->getIPv4Adress(), '1.3.6.1.2.1.17.1.4.1.2');
			foreach($result as $key => $line)
			{
				$line = formatInteger($line);
				if(preg_match('#\.3\.6\.1\.2\.1\.17\.1\.4\.1\.2\.([0-9\.]*)#',$key,$regs ))
				{
					$portifIndex[$line]= $regs[1];
				}
			}
		}
		catch(Exception $e)
		{
			Trace("\t".$node->getId().' '.$node->getName().' dot1port ==> IfIndex: ERROR: '.$e->getMessage());
		}
		//récupération des interfaces et des ifindex
		$inters = $sw->getInterfacesMib();
		$arrInterface = array();
		foreach($inters as $int)
		{
			if(array_key_exists($int->ifIndex, $portifIndex))
			{
				$arrInterface[$portifIndex[$int->ifIndex]] =$int->ifIndex;
			}
		}
		Trace($node->getId().' '.$node->getName().' List interface no trunk with dot1Port');
		Trace($arrInterface);

		//on a toutes les interface qui ne sont pas en mode 'trunk' on va récupérer les mac adresse
		$com = $snmp->getCommunity();
		//on va récupérer toute les mac-addresse
		$dot1port=array();
		try
		{
			//récupération du dot1dTpFdbPort (nécessaire pour récupéer les adresse mac par dot1port
			$result = $snmp->snmpwalkoid($sw->getIPv4Adress(), '1.3.6.1.2.1.17.4.3.1.2');
			foreach($result as $key => $line)
			{
				$line = formatInteger($line);
				//on regarde que l'interface ne soit pas une interface trunk
				if(array_key_exists($line, $arrInterface))
				{
					//ce n'est pas une interface trunk. on va récupérer les mac adresses
					$line=$arrInterface[$line];
					$mac=null;
					if(preg_match('#\.3\.6\.1\.2\.1\.17\.4\.3\.1\.2\.([0-9\.]*)#',$key,$regs ))
					{
						//on a l'identifiant de la mac dans la mib on peut maintenant la récupérer
						$id = $regs[1];
						$mac = $snmp->snmpget($sw->getIPv4Adress(),'1.3.6.1.2.1.17.4.3.1.1.'.$id);
						$mac = formatHexString($mac);
					}
					//si la mac n'est pas vide on l'ajoute au tableau.
					if(!empty($mac))
					{
							//sert pour le debug.
						if(!array_key_exists($line,$dot1port ) )
						{
							$dot1port[$line] = array($mac);
						}
						else
						{
							$dot1port[$line] = array_merge($dot1port[$line],array($mac));
						}
					}
				}
			}
		}
		catch(Exception $e)
		{
			Trace("\t".$node->getId().' '.$node->getName()." mac-addresse FINAL ERROR: $vlanid :".$e->getMessage());
		}
		Trace($node->getId().' '.$node->getName().' MAC ADDRESSE TABLE: ifindex => liste mac');
		Trace($dot1port);
		foreach($dot1port as $ifindex => $macs)
		{
			if(count($macs)<5)
			{
				foreach($macs as $mac)
				{
					try
					{
						//on va lié les interface entre elle
						linkInterface($mac,$ifindex,$node,'MACTABLE',$querySelectInter,$queryDeleteConnected,$querySelectInterSwitch,$queryInsertConnected );
					}
					catch(Exception $e)
					{
						Trace($node->getId().' '.$node->getName().' ERROR INSERT: '.$e->getMessage());
					}	
				}
			}
		}
	}
	catch(Exception $e)
	{
		Trace($node->getId().' '.$node->getName().' SNMP ERROR: '.$e->getMessage());
	}
}
function Hex2String($hexStr)
{
	$string='';
	for ($i=0; $i < strlen($hexStr)-1; $i+=2)
	{
		$string .= chr(hexdec($hexStr[$i].$hexStr[$i+1]));
	}
	return $string;
}
function Trace($string)
{
	if(DEBUG!=0)
	{
		if(is_array($string))
			print_r($string);
		else
			echo "$string\n";
	}
}
?>
