<?php
/**
 * @name building.inc.php
 * @description script PHP gérant l'administration des bâtiments. Il est inséré dans map_admin.php
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 30/01/2013
 */
if($user->getDroits($dbconnection,"map_administration") ==1 && $_GET['admin']=='Building') //on vérifie les droits d'accès
{
	//si on veux modifier un bâtiment
	if($action=='modifBuilding')
	{
		$building = MapModel::GetBuilding($dbconnection,$_GET['id']);
		$building =  $building[$_GET['id']];
		//on passe dans le create building pour chargé les élément graphique
		$action="createBuilding";
		$smarty->assign('building',$building);
		//print_r($building);
		//on indique que c'est une modification
		$smarty->assign('l_map_save',$lang['MAP_SAVE']);
		$smarty->assign('l_building_modify',$lang['MAP_BUILDING_MODIFY']);
	}
	if($action=="createBuilding") //si on veut créer un bâtiment
	{
		$conf = MapModel::GetMapConfiguration($dbconnection);
		//on récupe toute les zones
		$list_zone = MapModel::GetZone($dbconnection,null,false); //on récupère toutes les zones
		$smarty->assign('list_zone',$list_zone);
		$smarty->assign('img_taille_max',$conf['IMAGE_MAX_SIZE']);
		$smarty->assign('img_taille_max_mo',($conf['IMAGE_MAX_SIZE']/1024/1024));
		$smarty->assign('map_admin','create_building');
		if(isset($_POST['name'])&&!empty($_POST['name']))
		{ //traitement de l'ajout ou de la modification d'un bâtiment
			if(isset($_POST['coord_gps'])&&!empty($_POST['coord_gps']))
			{
				//on récupère les coordonnée GPS
				$coord = preg_split('#\n#',$_POST['coord_gps']);
				foreach ($coord as $c)
				{
					$t = preg_split('#:#',$c);
					if(preg_match('#-*[0-9]*\.[0-9]*#',$t[0]) && preg_match('#-*[0-9]*\.[0-9]*#',$t[1]))
					{
						$lat=$t[0];
						$lng=$t[1];
					}
				}
			}
			$error=0;
			try
			{
				$zone=null;
				if(isset($_POST['zone']) && is_numeric($_POST['zone'])&&$_POST['zone']!=0)
				{
					$zone = $_POST['zone'];
				}
				//MODIFICATION
				if(isset($_POST['building_id']) && is_numeric($_POST['building_id']))
				{
					if(isset($lat)&&!empty($lat)&&isset($lng)&&!empty($lng)) //si on a bien spécifié la latitude et la longitude
					{
						$buildingid = MapModel::UpdateBuilding($dbconnection,$_POST['building_id'],$_POST['name'],$_POST['abreviation'],$_POST['description'],$zone,$lat,$lng);
					}
					else //si c'est un bâtiment non localisé
					{
						$buildingid = MapModel::UpdateBuilding($dbconnection,$_POST['building_id'],$_POST['name'],$_POST['abreviation'],$_POST['description'],$zone);
					}
				}
				else	//AJOUT
				{
					if(isset($lat)&&!empty($lat)&&isset($lng)&&!empty($lng)) //si on a bien spécifié la latitude et la longitude
					{
						$buildingid = MapModel::CreateBuilding($dbconnection,$zone,$_POST['name'],$_POST['abreviation'],$_POST['description'],$lat,$lng);
					}
					else //si c'est un bâtiment non localisé
					{
						$buildingid = MapModel::CreateBuilding($dbconnection,$zone,$_POST['name'],$_POST['abreviation'],$_POST['description']);
					}
				}
				//si on ajouté un nouveau plan
				if(isset($_POST['floor_number']) && is_numeric($_POST['floor_number']))
				{
					//préparation de la requête de création d'étage
					$q_floor = MapModel::PrepareCreateFloor($dbconnection,$buildingid);
					$nbr = $_POST['floor_number'];
					for($i=1;$i<=$nbr;$i++)
					{
				   		$link='';
				   		//on check la taille de l'image
				   		$file = new uploadFile(RACINE_SITE.$conf['IMG_DIRECTORY'],$conf['IMAGE_MAX_SIZE']);
				   		if(!isset($_POST["namemap".$i]) || empty($_POST["namemap".$i])) $_POST["namemap".$i] = $i;
				   		if (isset($_FILES["floor$i"])&&!empty($_FILES["floor$i"]['type']))
				   		{
				   			$link= $_POST['zone']."-".$_POST['name']."-".$_POST["namemap".$i];
				   			$link = preg_replace('#\s+#','_',$link);
				   			$link = $file->uploadImage("floor$i",$link);
				   		}
				   		Model_esia::executeStatement($q_floor,array(':name'=>$_POST["namemap".$i],':map'=>$link));
					}
				}
				//on affiche le bâtiment nouvellement créé /modifié
				$building = MapModel::GetBuilding($dbconnection,$buildingid);
				$building =  $building[$buildingid];
				$smarty->assign('building',$building);
				$smarty->assign('l_map_save',$lang['MAP_SAVE']);
				$smarty->assign('l_building_modify',$lang['MAP_BUILDING_MODIFY']);
				$smarty->assign('map_configuration_success',$lang['MAP_BUILDING_SAVE_SUCCESS']);
			}
			catch(EsiaDbException $e)
			{
				$error = $e->getMessage();
				$smarty->assign('adm_error',$error);
				$smarty->assign('adm_building_failed',$lang['MAP_BUILDING_SAVE_FAILED']);
			}
			catch(FileUploadException $e)
			{
				$error = $e->getMessage();
				$smarty->assign('adm_error',$error);
				$smarty->assign('adm_building_failed',$lang['MAP_BUILDING_SAVE_FAILED']);
			}
		}
		else
		{
			if($_GET['flag']==1) // corrige un bug, n'afffiche une erreur que si on a bien clique sur le bouton "ajouter"
			{
				$smarty->assign('adm_error',$lang['MAP_BUILDING_SAVE_FAILED_NAME']);
			}
		}
		$smarty->assign('l_map_building_max_size_image',$lang['MAP_BUILDING_MAX_SIZE_IMAGE']);
		$smarty->assign('l_map_building_max_size_image_unit',$lang['MAP_BUILDING_MAX_SIZE_IMAGE_UNIT']);
		$smarty->assign('l_map_building_name',$lang['MAP_BUILDING_NAME']);
		$smarty->assign('l_map_building_add_map',$lang['MAP_BUILDING_ADD_MAP']);
		$smarty->assign('l_map_building_description',$lang['MAP_BUILDING_DESCRIPTION']);
		$smarty->assign('l_map_building_abreviation',$lang['MAP_ABREVIATION']);
		$smarty->assign('l_map_building_area',$lang['MAP_AREA']);
		$smarty->assign('l_map_building_coordinated',$lang['MAP_BUILDING_COORDINATED']);
		$smarty->assign('l_map_add',$lang['ADM_MAP_ADD']);
		$smarty->assign('l_map_building_add',$lang['MAP_BUILDING_ADD']);
		$smarty->assign('l_map_clear',$lang['MAP_CLEAR']);
	}
	elseif($action=="del_building")
	{
		//on veut supprimer un bâtiment
		if(isset($_POST['building'])&&is_numeric($_POST['building']))
		{
			MapModel::DeleteBuilding($dbconnection,$_POST['building']);
			$smarty->assign('list_building',$list_build);
			$smarty->assign('list_zone',$list_zone);
			$smarty->assign('map_configuration_success',$lang['MAP_BUILDING_DELETE_SUCCESS']);
			//cache l'affichage ('Gestion de zone,etc quand on a reussi une suppression
			$smarty->assign('no_zone_menu','yes');
		}
		elseif(is_numeric($_GET['id']))
		{
			//demande de confirmation
			$list_build = MapModel::GetBuilding($dbconnection,$_GET['id']);
			$build =  $list_build[$_GET['id']];
			$smarty->assign('building',$build);
			$smarty->assign('map_admin','del_building');
			$smarty->assign('l_cancel',$lang['CANCEL']);
			$smarty->assign('l_yes',$lang['YES']);
			$smarty->assign('l_confirmed_del_building', $lang['ADM_CONFIRMED_DEL_BUILDING']);
		}
		$smarty->assign('list_building',$list_build);
	}
	else
	{
		//liste les bâtiments, page par défaut quand aucune action n'est spécifiée
		$smarty->assign('map_admin','building');
		$list_build = MapModel::GetBuilding($dbconnection);
		$list_zone =MapModel::GetZone($dbconnection);
		$smarty->assign('list_building',$list_build);
		$smarty->assign('list_zone',$list_zone);
	}
	//variable de langue
	$smarty->assign('l_map_building_create',$lang['MAP_BUILDING_CREATE']);
	$smarty->assign('l_map_building_show',$lang['MAP_BUILDING_SHOW']);
	$smarty->assign('l_map_configuration_building',$lang['MAP_CONFIGURATION_BUILDING']);
	$smarty->assign('l_map_name',$lang['MAP_NAME']);
	$smarty->assign('l_map_area',$lang['MAP_AREA']);
	$smarty->assign('l_map_action',$lang['MAP_ACTION']);
	$smarty->assign('l_map_floor_delete_confirm',$lang['ADM_FLOOR_DELETE_CONFIRM']);

}
?>
