<?php
/**
 * @name building.inc.php
 * @description script PHP gérant l'administration des bâtiments. Il est inséré dans map_admin.php
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 07/01/2013
 */
function searchImage($list,$pattern)
{
	foreach($list as $l)
	{
		if($l['name'] == $pattern)
		{
			return $l['id'];
		}
	}
}
if($user->getDroits($dbconnection,"map_administration") ==1 && $_GET['admin']=='Floor') //on vérifie les droits d'accès
{
	if($action=="treatplan")
	{
		try
		{
			if(isset($_POST['imgnode'])&&!empty($_POST['imgnode']) && isset($_POST['floorid'])&&!empty($_POST['floorid']))
			{
				MapModel::DeleteAllObjectInMap($dbconnection, $_POST['floorid']);
				$listimg = MapModel::getImage($dbconnection);
				$imgs = explode(";",$_POST['imgnode']);
				$imgs = array_filter($imgs);
			//	MapModel::printHTMLarray($imgs);
				foreach($imgs as $img)
				{
					$arr = preg_split("#:#",$img);
					$imgid = searchImage($listimg,$arr[2]);
					MapModel::insertInMap($dbconnection, $_POST['floorid'], $arr[0], $imgid, $arr[3], $arr[4], $arr[5], $arr[6],$arr[7]);
				}
				//$smarty->assign('adm_floor_success','reussi');
				$smarty->assign('adm_floor_success',$lang['ADM_FLOOR_ADD_SUCCES']);
				$action="modifFloor";
				$_GET['id']=$_POST['floorid'];
			}
		}
		catch(EsiaDbException $e)
		{
			$error = $e->getMessage();
			$smarty->assign('adm_error',$error);
		}
	}
	if($action=="delete")
	{
		$smarty->assign('l_map_previous_page',$lang['ADM_MAP_PREVIOUS_PAGE']);
		$smarty->assign('map_previous_uri',$_SESSION['previous_page']);
		try
		{
			if(isset($_GET['id']) && is_numeric($_GET['id']))
			{
				$floor = MapModel::GetFloors($dbconnection,$_GET['id']); 
				$smarty->assign('map_floor_building_id',$floor[$_GET['id']]['building_id']);
				MapModel::DeleteFloor($dbconnection,$_GET['id']);
				
				$smarty->assign('map_configuration_success',$lang['ADM_FLOOR_DELETE_SUCCESS']);
				$smarty->assign('map_admin','floor');
				$smarty->assign('action','deleteFloor');
			}
		}
		catch(EsiaDbException $e)
		{
			$error = $e->getMessage();
			$smarty->assign('adm_error',$error);
			$smarty->assign('adm_floor_delete_failed',$lang['ADM_FLOOR_DELETE_FAILED']);
		}
	}
	elseif($action=="modifFloor")
	{
		if(isset($_GET['id']) && is_numeric($_GET['id']))
		{
			$floor = MapModel::GetFloors($dbconnection,$_GET['id']);
			$image = MapModel::GetImage($dbconnection);
			//$nodeGroup = MapModel::getGroupNode($dbconnection);

			//on va rechercher les groupes de noeuds
			$arr = Model_esia::getGroupDeviceIn($dbconnection);
			//echo'<pre>'; print_r($arr); echo '</pre>';
			$nodeGroup =array();
			foreach($arr as $top)
			{
				$tmp = convert_tree_to_select($top,0);
				$nodeGroup = array_merge($nodeGroup, $tmp);
			}
			//echo '<pre>'.print_r($nodeGroup,true).'</pre>';
			$tmp = array();
			foreach($nodeGroup as $group)
			{
				$tmp[]=array('id'=>$group['id'],'name'=>$group['parent_name']);
			}
			usort($tmp,"cmptree");
			//print_r($tmp);
			//echo '<pre>'.print_r($tmp,true).'</pre>';
			$smarty->assign('adm_nodegroup', $tmp);

			$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
			$list=array();
			foreach($nodes as $node)
			{
				$selected='no';
				if(in_array($node->getId(),$params['nodeid']))
				{
					$selected='yes';
				}
				$list[]=array('id'=>$node->getId(),
						'name'=>$node->getGroup().'>'.$node->getName(),
						'selected'=>$selected
						
				);
			}
			$smarty->assign('adm_list_node', $list);
			
			$containers = MapModel::getContainers($dbconnection);
			//on récupère les images de chaque type de device suivant leur type
			$list_img=  MapModel::getImage($dbconnection);
			$nodelocal = MapModel::getNodesLocalizationByFloor($dbconnection,$_GET['id']);
			$containerlocal =  MapModel::getContainerLocalizationByFloor($dbconnection,$_GET['id']);
			$list_elem=array();
			foreach($nodelocal as $node)
			{
				//ajout dans la liste des éléments qui seront affichés
				$list_elem[]=array('nodeid'=>$node['id'],
						'name'=>$node['name'],
						'description'=>$node['description'],
						'type'=>'node',
						'x'=>$node['x'],
						'y'=>$node['y'],
						'width'=>$node['width'],
						'height'=>$node['height'],
						'img'=>$list_img[$node['image_id']]['img_ok'],
						'image_id'=>$list_img[$node['image_id']]['name']);
			}
			foreach($containerlocal as $node)
			{
				//ajout dans la liste des éléments qui seront affichés
				$list_elem[]=array('nodeid'=>$node['id'],
						'name'=>$node['name'],
						'description'=>$node['description'],
						'type'=>'container',
						'x'=>$node['x'],
						'y'=>$node['y'],
						'width'=>$node['width'],
						'height'=>$node['height'],
						'img'=>$list_img[$node['image_id']]['img_ok'],
						'image_id'=>$list_img[$node['image_id']]['name']);
			}			
			//echo'<pre>';print_r($nodelocal);echo'</pre>';
			$smarty->assign('map_admin','floor');
			$smarty->assign('map_action','modifFloor');
			$smarty->assign('map_node_group',$nodeGroup);
			$smarty->assign('map_node_local',$list_elem);
			$smarty->assign('map_container',$containers);
			$smarty->assign('floor',$floor[$_GET['id']]);
			$smarty->assign('images',$image);
			$smarty->assign('l_map_save',$lang['MAP_SAVE']);
			$smarty->assign('l_map_delete',$lang['MAP_DELETE']);
			$smarty->assign('l_map_resize',$lang['MAP_RESIZE']);
			$smarty->assign('l_map_move',$lang['MAP_MOVE']);
			$smarty->assign('l_map_groupname',$lang['MAP_GROUP_NAME']);
			$smarty->assign('l_map_node',$lang['MAP_NODE']);
			$smarty->assign('l_map_container',$lang['MAP_CONTAINER']);
		}
	}
	else
	{
		$smarty->assign('map_admin','floor');
		$list_zone = MapModel::GetZone($dbconnection);
		$list_floors = MapModel::GetFloors($dbconnection);
		$smarty->assign('list_floors',$list_floors);
		//print_r($list_zone);
		$smarty->assign('list_zone',$list_zone);
	}
}
