<?php
/**
 * @name zone.inc.php
 * @description script PHP gérant l'administration des zones. Il est inséré dans map_admin.php
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 30/01/2013
 */
if($user->getDroits($dbconnection,"map_administration") ==1 && $_GET['admin']=='Zone')
{
	$smarty->assign('map_admin','zone');
	if($action=="createZone") // si on veut créer une zone
	{
		if(isset($_POST['name'])&&!empty($_POST['name']) ) //traitement de l'ajout de la zone
		{
			$lat=array();
			$lng=array();
			try
			{
				$name = $_POST['name'];
				$zoneid = 0;				
				//on regarde si on a des coordonnées gps
				if(isset($_POST['coord_gps'])&&!empty($_POST['coord_gps']))
				{
					$coord = preg_split('#\n#',$_POST['coord_gps']);
					foreach ($coord as $c)
					{
						$t = preg_split('#[:,]#',$c);
						if(preg_match('#-*[0-9]*\.[0-9]*#',$t[0]) && preg_match('#-*[0-9]*\.[0-9]*#',$t[1]))
						{
							$lat[]=$t[0];
							$lng[]=$t[1];
						}
					}
					//on ajoute la zone à la BD
					$zoneid = MapModel::CreateZone($dbconnection,$name,$_POST['abreviation'],$lat,$lng);
				}
				else
				{
					//on ajoute la zone à la BD
					$zoneid = MapModel::CreateZone($dbconnection,$name,$_POST['abreviation']);
				}
				$_GET['id'] = $zoneid;
				$action="modifZone";
				$smarty->assign('map_configuration_success',$lang['MAP_AREA_SAVE_SUCCESS']);
			}
			catch(EsiaDbException $e)
			{
				$smarty->assign('adm_error',$e->getMessage());
				$smarty->assign('create_zone','createZone');
				$zone =array('name'=>$_POST['name'],'abbreviation'=>$_POST['abreviation'],'latitude'=>$lat,'longitude'=>$lng );
				$smarty->assign('zone',$zone);
			}
		}
		else
		{
			$smarty->assign('create_zone','createZone');
		}
	}
	if($action=="modifZone") //si on veut modifier la zone
	{
		$smarty->assign('modif_zone','createZone');
		$smarty->assign('create_zone','createZone');
		if(isset($_POST['name'])&&!empty($_POST['name'])&&is_numeric($_POST['id']) )
		{
			try
			{
				$name = $_POST['name'];
				if(isset($_POST['coord_gps'])&&!empty($_POST['coord_gps']))
				{
					$coord = preg_split('#\n#',$_POST['coord_gps']);
					$lat=array();
					$lng=array();
					foreach ($coord as $c)
					{
						$t = preg_split('#[:,]#',$c);
						if(preg_match('#-*[0-9]*\.[0-9]*#',$t[0]) && preg_match('#-*[0-9]*\.[0-9]*#',$t[1]))
						{
							$lat[]=$t[0];
							$lng[]=$t[1];
						}
					}
					MapModel::UpdateZone($dbconnection,$_POST['id'],$name,$_POST['abreviation'],$lat,$lng);
				}
				else
				{
					MapModel::UpdateZone($dbconnection,$_POST['id'],$name,$_POST['abreviation']);
				}
				$_GET['id'] = $_POST['id'];
				$smarty->assign('map_configuration_success',$lang['MAP_AREA_UPDATE_SUCCESS']);
			}
			catch(EsiaDbException $e)
			{
				$smarty->assign('adm_error',$e->getMessage());
			}
		}
		if(is_numeric($_GET['id']))
		{
			$zone = MapModel::GetZone($dbconnection,$_GET['id'],false);
			$smarty->assign('zone',$zone[$_GET['id']]);
		}
	}
	elseif($action=="delZone")
	{
		if(isset($_POST['zone'])&&is_numeric($_POST['zone']))
		{
			try
			{
				MapModel::DeleteZone($dbconnection,$_POST['zone']);
				$smarty->assign('map_configuration_success',$lang['MAP_AREA_DELETE_SUCCESS']);
				//cache l'affichage ('Gestion de zone,etc quand on a reussi une suppression
				$smarty->assign('no_zone_menu','yes');
			}
			catch(EsiaDbException $e)
			{
				$smarty->assign('adm_error',$e->getMessage());
			}
		}
		elseif(is_numeric($_GET['id']))
		{
			$zone= MapModel::GetZone($dbconnection,$_GET['id']);
			$zone =  $zone[$_GET['id']];
			$smarty->assign('zone',$zone);
			$smarty->assign('delzone','delzone');
			$smarty->assign('l_cancel',$lang['CANCEL']);
			$smarty->assign('l_yes',$lang['YES']);
			$smarty->assign('l_confirmed_del_zone', $lang['ADM_CONFIRMED_DEL_ZONE']);
		}
	}
	else
	{
		$list_zone = MapModel::GetZone($dbconnection);
		$smarty->assign('list_zone',$list_zone);
	}
	//variable de langue
	$smarty->assign('l_map_area_coordinated',$lang['MAP_AREA_COORDINATED']);
	$smarty->assign('l_map_action',$lang['MAP_ACTION']);
	$smarty->assign('l_map_name',$lang['MAP_NAME']);
	$smarty->assign('l_map_abreviation',$lang['MAP_ABREVIATION']);
	$smarty->assign('l_map_configuration_area',$lang['MAP_CONFIGURATION_AREA']);
	$smarty->assign('l_map_area_created',$lang['MAP_AREA_CREATED']);
	$smarty->assign('l_map_area_change',$lang['MAP_AREA_CHANGE']);
	$smarty->assign('l_map_area_show',$lang['MAP_AREA_SHOW']);
	$smarty->assign('l_map_area_hidden',$lang['MAP_AREA_HIDDEN']);
	$smarty->assign('l_map_save',$lang['MAP_SAVE']);
	$smarty->assign('l_map_clear',$lang['MAP_CLEAR']);
	$smarty->assign('l_map_delete',$lang['MAP_DELETE']);
}
?>
