<?php
/**
 * @name map_adm_container.php
 * @description page de gestion des containers de noeud
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 26/06/2013
 */

include_once $_SERVER['DOCUMENT_ROOT'].'common.php';
include_once $_SERVER['DOCUMENT_ROOT'].'libs/uploadFile.class.php';
include_once './map_model.php';
$esialog = new EsiaLog(FILE_LOG,$user->getName());
$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_LOCATION');
$template_path= $path.$arr[0]['apache_path'].'template/';
$smarty->assign('map_template_directory',$template_path);
//vérification des droits d'accès
if($user->getDroits($dbconnection,"map_administration") ==1)
{	
	//on récupère les infos de configurations
	$conf = MapModel::GetMapConfiguration($dbconnection);
	$smarty->assign('map_img_taille_max', $conf['IMAGE_MAX_SIZE']);
	if(isset($_GET['action'])&&!empty($_GET['action']))
	{
		$action=$_GET['action'];
	}
	else
	{
		// action par défaut
		$action ='view';
	}
	
	//on veut créer ou modifier un container
	if($action=='create_container' || $action=='modifier')
	{		
		$errContainer=0;
		//on vérifie que le type de container $list_node_grpest bien numéric
		if(is_numeric($_POST['type'])&&$_POST['type']!=0&&isset($_POST['name'])&&!empty($_POST['name']))
		{
			//on test si on veut charger un fichier + upload
			$link='';
			if (isset($_FILES["photo"])&&!empty($_FILES["photo"]['type']))
			{
				$file = new uploadFile(RACINE_SITE.$conf['IMG_DIRECTORY'],$conf['IMAGE_MAX_SIZE']);
				try
				{
					$link=$_POST['name']."container".time();
					$link = preg_replace('#\s+#','_',$link);
					$link = $file->uploadImage('photo',$link);
					$root =$_SERVER['DOCUMENT_ROOT'];
					$link = preg_replace("#$root#",'/',$link);
				}
				catch(FileUploadException $e)
				{
					$smarty->assign('container_error',$e->getMEssage());
				}
			}
			try
			{
				//creation d'un container
				if($action=='create_container')
				{
					if(isset($_POST['listeDispo']) && !empty($_POST['listeDispo']))
					{
						$_GET['id'] = MapModel::CreateContainer($dbconnection,$_POST['name'],$_POST['description'],$_POST['type'],$link,$_POST['listeDispo']);
					}
					else
					{
						$_GET['id'] = MapModel::CreateContainer($dbconnection,$_POST['name'],$_POST['description'],$_POST['type'],$link,array());
					}
					$smarty->assign('container_success','SUCCESS');
				}
				else
				{
				//	echo 'ici';
					//update du container
					$_GET['id'] = $_POST['id'];
					if(isset($_POST['listeDispo']) && !empty($_POST['listeDispo']))
					{
						MapModel::UpdateContainer($dbconnection,$_POST['id'],$_POST['name'],$_POST['description'],$_POST['type'],$link,$_POST['listeDispo']);
					}
					else
					{
						MapModel::UpdateContainer($dbconnection,$_POST['id'],$_POST['name'],$_POST['description'],$_POST['type'],$link,array());
					}
					$smarty->assign('container_success',$lang['ADM_UPDATE_SUCCESS']);
				}
				$action='view';
			}
			catch(EsiaDbException $e)
			{
				$errContainer=1;
				$smarty->assign('container_error',$e->getMEssage());
			}
		}
		else
		{
			$errContainer=1;
		}
		if($errContainer==1)
		{
			if(isset($_POST['id']))
			{
				$_GET['id'] = $_POST['id'];
			}
			else
			{
				$tmpContainer = array("name"=>$_POST['name'],'description'=>$_POST['description'],'type_id'=>$_POST['type']);	
			}
			$action="view";
		}
	}
	elseif($action=='listjson')
	{
		$containers = MapModel::getContainers($dbconnection);
		echo json_encode($containers);
		exit(0);
	}
	if($action == 'view')
	{
		//page de vision d'un container
		$list_type_container = MapModel::getContainerType($dbconnection);
		$list_device=array();
		$list_grp=array();
		$arr = Model_esia::getNodeList($dbconnection);
		foreach($arr as $row)
		{
			$list_device[$row['id']]=array('id'=>$row['id'],
						'name'=>$row['name'],
						'groupname'=>$row['group']);
			if(!in_array($row['group'],$list_grp))
					$list_grp[]=$row['group'];
		}
	//	usort($list_device,"cmptree");
		$smarty->assign('List_container', $list_type_container);
		//si on veut modifier un container
		if(is_numeric($_GET['id'])&&$action!='create_container')
		{
			$container = MapModel::getContainers($dbconnection,$_GET['id']);
			$container = $container[$_GET['id']];
		//	print_r($container);
			$smarty->assign('container', $container);
			$smarty->assign('cont_update', 'update');
			//on prend la différence des 2 tableaux pour savoir qu'elles sont les noeuds non assignés
			$list_device = array_diff_assoc($list_device,$container['nodes']);
		//	print_r($list_device);
		}
		elseif(isset($tmpContainer))
		{
			$smarty->assign('container',$tmpContainer);
		}
		
		usort($list_device,"cmptree");
		//variable de langue
		$smarty->assign('l_container_type', $lang['MAP_CONTAINER_TYPE']);
		$smarty->assign('l_name', $lang['MAP_NAME']);
		$smarty->assign('l_image', $lang['MAP_IMAGE']);
		$smarty->assign('l_description', $lang['MAP_DESCRIPTION']);
		$smarty->assign('l_available_node', $lang['MAP_NODE_AVAILABLE']);
		$smarty->assign('l_available_container', $lang['MAP_NODE_CONTAINER']);
		$smarty->assign('l_groupname', $lang['MAP_GROUP_NAME']);
		$smarty->assign('l_save', $lang['MAP_SAVE']);
		$smarty->assign('list_group', $list_grp);
		$smarty->assign('list_device', $list_device);
	}
}
else
{
	$smarty->assign('l_no_access', $lang['NO_ACCESS']);
}
$smarty->display($template_path.'map_adm_container.html');
