<?php
/**
 * @name map_admin.php
 * @description page d'administration de la géolocalisation
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 26/06/2013
 */
include_once $_SERVER['DOCUMENT_ROOT'].'common.php';
include_once $_SERVER['DOCUMENT_ROOT'].'libs/uploadFile.class.php';
include_once './map_model.php';
$esialog = new EsiaLog(FILE_LOG,$user->getName());
//chemin d'accès au repertoire du plugin contenant les templates
$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_LOCATION');
$template_path= $path.$arr[0]['apache_path'].'template/';
$smarty->assign('map_template_directory',$template_path);
$smarty->assign('apache_path',$arr[0]['apache_path']);
//test du droit d'accès
if($user->getDroits($dbconnection,"map_administration") ==1)
{
	//on récupère les information de base pour la configuration
	$conf = MapModel::GetMapConfiguration($dbconnection);
	$smarty->assign('map_center_lat',$conf['CENTER_LATITUDE']);
	$smarty->assign('map_center_long',$conf['CENTER_LONGITUDE']);
	$smarty->assign('map_type',$conf['TYPE']);
	$smarty->assign('map_zoom',$conf['ZOOM']);
	$smarty->assign('map_zoom_changed',$conf['ZOOM_CHANGED']);

	$smarty->assign('l_zone_create', $lang['MAP_ZONE_CREATE']);
	$smarty->assign('l_add', $lang['ADM_MAP_ADD']);
	$action ='';
	if(isset($_GET['action']))
	{
		$action = $_GET['action'];
	}
	else
	{
		if(!isset($_GET['admin']))
		{
			$smarty->assign('showmenu','yes');
		}
	}
	//configuration général de la carte
	if($action=="configure")
	{
		$smarty->assign('map_admin','configure');
		$smarty->assign('l_map_configure',$lang['MAP_CONFIGURE_GOOGLE_MAP']);
		$smarty->assign('l_map_configure_center',$lang['MAP_CONFIGURE_CENTER_COORDINATED']);
		$smarty->assign('l_map_configure_default_zoom',$lang['MAP_CONFIGURE_DEFAULT_ZOOM']);
		$smarty->assign('l_map_configure_changed_zoom',$lang['MAP_CONFIGURE_CHANGED_ZOOM']);
		$smarty->assign('l_map_configure_type',$lang['MAP_CONFIGURE_TYPE']);
		$smarty->assign('l_map_save',$lang['MAP_SAVE']);
	}
	elseif($action=="updateConfiguration")
	{
		$smarty->assign('map_admin','configure');
		//on regarde pour mettre à jour les informations de la carte
		if(isset($_POST['coord_gps'])&&!empty($_POST['coord_gps']))
		{
			$coord = preg_split('#\n#',$_POST['coord_gps']);
			//on vérifie si il y a des coordonnées pour le centre de la carte
			foreach ($coord as $c)
			{
				$t = preg_split('#:#',$c);		
				if(preg_match('#-*[0-9]*\.[0-9]*#',$t[0]) && preg_match('#-*[0-9]*\.[0-9]*#',$t[1]))//on isole la latitude et la longitude
				{
					$lat=$t[0];
					$lng=$t[1];
				}
			}
			if(isset($lat)&&!empty($lat)&&isset($lng)&&!empty($lng))
			{
				//update de la latitude et de la longitude
				MapModel::UpdateCenterLatitude($dbconnection,$lat);
				MapModel::UpdateCenterLongitude($dbconnection,$lng);
				if(isset($_POST['zoom_default'])&&is_numeric($_POST['zoom_default'])&&$_POST['zoom_default']>=0&&$_POST['zoom_default']<20 )
				{
					if(isset($_POST['zoom_changed'])&&is_numeric($_POST['zoom_changed'])&&$_POST['zoom_changed']>=0&&$_POST['zoom_changed']<20 )
					{
						if($_POST['zoom_changed']>$_POST['zoom_default'])
						{
							//update des niveaux de zoom
							MapModel::UpdateZoom($dbconnection,$_POST['zoom_default']);
							MapModel::UpdateZoomChanged($dbconnection,$_POST['zoom_changed']);
							if(isset($_POST['map_type'])&&!empty($_POST['map_type']))
							{
								//update du type de carte
								MapModel::UpdateMapType($dbconnection,strtoupper($_POST['map_type']));
								$smarty->assign('configurationSuccess','success');
								$url="/administration.php?tab=Localisation&message=ADM_MAP_SAVE_SUCCESS&typemsg=OK";
								header("Location: $url");
								exit(0);							
							}
						}
					}
				}
			}
		}
	}
	//on inclus le bon fichier suivant ce que l'on désire
	switch($_GET['admin'])
	{
		case 'Zone': include './inc/zone.inc.php'; break;
		case 'Building': include './inc/building.inc.php'; break;
		case 'Floor': include './inc/floor.inc.php'; break;
		default: break;
	}

}
else
{
	$smarty->assign('l_no_access', $lang['NO_ACCESS']);
}
//variable de langue 
$smarty->assign('l_name', $lang['MAP_NAME']);
$smarty->assign('l_action', $lang['MAP_ACTION']);
$smarty->assign('l_path', $lang['MAP_PATH']);
$smarty->assign('l_area', $lang['MAP_AREA']);
$smarty->assign('l_building', $lang['MAP_BUILDING']);
$smarty->assign('l_localization', $lang['MAP_LOCALIZATION']);
$smarty->assign('l_configuration', $lang['MAP_CONFIGURATION']);
$smarty->display($template_path.'map_admin.html');
/*@NAME: convert_tree_to_select
 *@IN: $top un tableau associatif de type renvoyer par Model_esia::getGroupDeviceIn($dbconnection)
*	$parent_id id du groupe du groupe parent
*@OUT: un tableau contenant les noms des groupes de device enfants
*array('id'=>$row->device_group_id,
		*		'name'=> $row->device_group_name,
		'level'=> niveau dans le tableau
		'id du parent'=> niveau dans le tableau
		*@TREAT: FONCTION RECURSIVE !!!!! (utilisée avec la fonction getGroupDeviceIn)
		*		transforme un tableau de tableau récursif de  getGroupDeviceIn en tableau simple avec une valeur 'level' indiquant le niveau du auquelle ils se trouvent
		*@EXCEPTION: /
		*/

function convert_tree_to_select($top,$itt,$parentid=null,$parentname=null)
{
	/*for($i=0;$i<$itt;$i++)
		echo'=';
	echo $top['name'].'<br />';*/
	$pname=null;
	if(isset($parentname))
	{
		$pname = $parentname.' > '.$top['name'];
	}
	else
	{
		$pname = $top['name'];
	}
	$arr=array();
	$arr[]=array('id'=>$top['id'],'name'=>$top['name'],'level'=>$itt,'parent'=>$parentid,'parent_name'=>$pname);
	$itt++;
	if(isset($top['child']))
	{
		$tmp=array();
		foreach($top['child'] as $child)
		{
			$tmp = convert_tree_to_select($child,$itt,$top['id'],$pname);
			$arr = array_merge($arr, $tmp);
		}
	}
	return $arr;
}
?>
