<?php
/**
 * @name map_floor
 * @description script générant la page de vue des étages
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 26/06/201.
 */
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
if(isset($SIMPLEVIEW) && $SIMPLEVIEW==true)
{
	$smarty->assign('map_simple_view',true);
}
//vérification des accès
if($user->getDroits($dbconnection,"map_view") ==1)
{
	//chemin d'accès au repertoire du plugin contenant les templates
	$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_LOCATION');
	$template_path= $path.$arr[0]['apache_path'].'template/';
	$smarty->assign('map_template_directory',$template_path);
	include_once  $path.$arr[0]['apache_path'].'/map_model.php';
	//on vérife que l'id de l'étage est bien numérique
	if(is_numeric($_GET['floor_id']))
	{
		//information général sur la carte et l'étage
		$info = MapModel::getMapFloorInformation($dbconnection, $_GET['floor_id']);
		$smarty->assign('zone_name', $info['zone_name']);
		$smarty->assign('building_name', $info['building_name']);
		$smarty->assign('floor_name', $info['floor_name']);
		$smarty->assign('floor_map', $info['floor_map']);
		$smarty->assign('floor_id', $info['floor_id']);
		$smarty->assign('map_width', $info['map_width']);
		$smarty->assign('map_height', $info['map_height']);
		//on récupère les images de chaque type de device suivant leur type
		$list_img=  MapModel::getImage($dbconnection);
		//on récupère les plugins et les pages de controle de chaque type de noeud
		$list_elem=array();
		//on récupère les noeuds ainsi que leur localisation sur le plan
		$nodes =  MapModel::getNodesLocalizationByFloor($dbconnection, $_GET['floor_id']);
		//affichage des noeuds classiques
		foreach($nodes as $node)
		{
			//vérifaction des droits d'accès
			if($user->getDroits($dbconnection,"device_view",$node['name']) ==1)
			{
				$list_error=array();
				//on récupère les erreur du noeud
				$errors = Model_esia::getNodeError($dbconnection,$node['id']);
				$state='OK';
				$img=$list_img[$node['image_id']]['img_ok'];
				$list_error=array();
				foreach($errors as $error)
				{
					if($error['type']=='critical')
					{
						$state='critical';
						$img=$list_img[$node['image_id']]['img_critical'];
						break;
					}
					elseif($error['type']=='warning' && $state!='critical')
					{
						$state='warning';
						$img=$list_img[$node['image_id']]['img_warning'];
					}
					elseif($error['type']=='unknown' && $state!='warning' && $state!='critical')
					{
						$state='unknown';
						$img=$list_img[$node['image_id']]['img_unknown'];
					}
		 		}
		 		//ajout dans la liste des éléments qui seront affichés
		 		$list_elem[]=array(
		 			'localtype'=>'node',
		 			'id'=>$node['id'],
		 			'name'=>$node['name'],
		 			'description'=>$node['description'],
		 			'type'=>$node['type'],
		 			'page_control'=>$page_control,
		 			'x'=>$node['x'],
		 			'y'=>$node['y'],
		 			'width'=>$node['width'],
		 			'height'=>$node['height'],
		 			'state'=>$state,
		 			'img'=>$img);
			}
		}		
		$containerlocal =  MapModel::getContainerLocalizationByFloor($dbconnection,$_GET['floor_id']);
		foreach($containerlocal as $cont)
		{
			$nodes = MapModel::getContainers($dbconnection,$cont['id'] );
			$nodes = $nodes[$cont['id']];
			$img=$list_img[$cont['image_id']]['img_ok'];
			$state='OK';
			if(!empty($nodes['nodes']))
			{
				foreach($nodes['nodes'] as $node)
				{
					//test du droits d'accès au noeuds
					if($user->getAccess($dbconnection,"device_view",$node['name']) ==1)
					{
						$errors = Model_esia::getNodeError($dbconnection,$node['id']);
						//test de l'états d'un noeud
						foreach($errors as $error)
						{
							if($error['type']=='critical')
							{
								$state='critical';
								$img=$list_img[$cont['image_id']]['img_critical'];
								break;
							}
							elseif($error['type']=='warning' && $state!='critical')
							{
								$state='warning';
								$img=$list_img[$cont['image_id']]['img_warning'];
							}
							elseif($error['type']=='unknown' && $state!='warning' && $state!='critical')
							{
								$state='unknown';
								$img=$list_img[$cont['image_id']]['img_unknown'];
							}
						}
						if($state=='critical')
						{
							break;
						}
					}
				}
			}		
			//ajout dans la liste des éléments qui seront affichés
			$list_elem[]=array(
					'localtype'=>'container',
					'id'=>$cont['id'],
					'name'=>$cont['name'],
					'description'=>$cont['description'],
					'type'=>'container',
					'x'=>$cont['x'],
					'y'=>$cont['y'],
					'width'=>$cont['width'],
					'height'=>$cont['height'],
					'img'=>$img,
					'state'=>$state,
					'image_id'=>$list_img[$cont['image_id']]['name']);
		}
		
		$smarty->assign('list_device',$list_elem);
		$smarty->assign('l_map_building',$lang['MAP_BUILDING']);
	}
	$smarty->display($template_path.'map_floor.html');
}
?>
