<?php
/**
 * @name map_refresh
 * @description script appellé lors du rafraichissement de la google map (génère un xml) ou l'HTML de l'infobulle
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 26/06/2013
 */
$path = $_SERVER['DOCUMENT_ROOT'];
$no_trace_uri=true;

include_once $path.'common.php';
include_once './map_model.php';
//paramètre de configuration de base (centre,zoom,type de carte,etc)
$conf = MapModel::GetMapConfiguration($dbconnection);
if($user->getDroits($dbconnection,"map_view") ==1)
{
	//variable de langue 
	$smarty->assign('l_map_errors',$lang['MAP_ERRORS']);
	$smarty->assign('l_map_node',$lang['MAP_NODE']);
	$smarty->assign('l_map_message',$lang['MAP_MESSAGE']);
	$smarty->assign('l_map_node_type',$lang['MAP_NODE_TYPE']);
	$smarty->assign('l_map_date',$lang['MAP_DATE']);
	$smarty->assign('l_map_description',$lang['MAP_DESCRIPTION']);
	$smarty->assign('l_map_service',$lang['MAP_SERVICE']);
	//si veut le rafraichissement de la carte
	if($_GET['action']=='map' && isset($_GET['zoom']))
	{
	 //générations d'un XML pour l'état de chaque bâtiment
		if($_GET['zoom']>=$conf['ZOOM_CHANGED']) //affichage batiment
		{
			ob_clean();
			header('Content-Type: text/xml; charset=utf-8');
			$xml = new DOMDocument('1.0', 'utf-8');
			$root = $xml->createElement('list');
			//récupération des noms de groupes et de leur état
			$arr = MapModel::getBuildingState($dbconnection,null,$user->getId());
			//création de l'XML
			foreach($arr as $zone => $row)
			{
				$nog = $xml->createElement('building');
				$nog->setAttribute('id', $zone);
				$nog->appendChild($xml->createElement('name',$row['name']));
				$nog->appendChild($xml->createElement('ok',$row['ok']));
				$nog->appendChild($xml->createElement('warning',$row['warning']));
				$nog->appendChild($xml->createElement('critical',$row['critical']));
				$nog->appendChild($xml->createElement('unknown',$row['unknown']));
				if(!empty( $row['latitude'])&&!empty($row['longitude']))
				{
					$point = $xml->createElement('point');
					$point->setAttribute('latitude', $row['latitude']);
					$point->setAttribute('longitude', $row['longitude']);
					$nog->appendChild($point);
				}
				$root->appendChild($nog);
			}
			$xml->appendChild($root);
			echo $xml->saveXML(); //af
		}
		//générations d'un XML pour l'état de chaque zone
		else  //affichage des zones
		{
			ob_clean();
			header('Content-Type: text/xml; charset=utf-8');
			$xml = new DOMDocument('1.0', 'utf-8');
			$root = $xml->createElement('list');
			//récupération des noms de groupes et de leur état
			$arr = MapModel::getZoneState($dbconnection,null,$user->getId());
			foreach($arr as $zone => $row)
			{
				$nog = $xml->createElement('zone');
				$nog->setAttribute('id', $zone);
				$nog->appendChild($xml->createElement('name',$row['name']));
				//ajout à l'arbre XML
				$nog->appendChild($xml->createElement('ok',$row['ok']));
				$nog->appendChild($xml->createElement('warning',$row['warning']));
				$nog->appendChild($xml->createElement('critical',$row['critical']));
				$nog->appendChild($xml->createElement('unknown',$row['unknown']));
				$gps = $xml->createElement('gps');
				//$nog->appendChild($xml->createElement('nbrpoint',count($row['latitude'])));
				for($i=0;$i<count($row['latitude']);$i++)
				{
					$point = $xml->createElement('point');
					$point->setAttribute('latitude', $row['latitude'][$i]);
					$point->setAttribute('longitude', $row['longitude'][$i]);
					$gps->appendChild($point);
				}
				$nog->appendChild($gps);
				$root->appendChild($nog);
			}
			$xml->appendChild($root);
			echo $xml->saveXML();
		}
	}
	elseif($_GET['action']=='zone') //on veut la liste des zones et de leurs bâtiments
	{
		if(is_numeric($_GET['id']))
		{
			$arr = MapModel::GetZone($dbconnection,$_GET['id']);
		}
		else
		{
			$arr = MapModel::GetZone($dbconnection);
		}
		ob_clean();
		header('Content-Type: text/xml; charset=utf-8');
		$xml = new DOMDocument('1.0', 'utf-8');
		$root = $xml->createElement('list');
		foreach($arr as $zone => $row)
		{
			$nog = $xml->createElement('zone');
			$nog->setAttribute('id', $zone);
			$nog->setAttribute('name', $row['name']);
			foreach($row['building'] as $build)
			{
				$building = $xml->createElement('building');
				$building->setAttribute('id', $build['id']);
				$building->setAttribute('name', $build['name']);
				
				if($_GET['state']==1)
				{
					//récupération des noms de groupes et de leur état
					$buildingState = MapModel::getBuildingState($dbconnection,$build['id'],$user->getId());
					$buildingState= $buildingState[$build['id']];
					$building->appendChild($xml->createElement('ok',$buildingState['ok']));
					$building->appendChild($xml->createElement('warning',$buildingState['warning']));
					$building->appendChild($xml->createElement('critical',$buildingState['critical']));
					$building->appendChild($xml->createElement('unknown',$buildingState['unknown']));
				}
				$nog->appendChild($building);
			}
			$gps = $xml->createElement('gps');
			//$nog->appendChild($xml->createElement('nbrpoint',count($row['latitude'])));
			for($i=0;$i<count($row['latitude']);$i++)
			{
				$point = $xml->createElement('point');
				$point->setAttribute('latitude', $row['latitude'][$i]);
				$point->setAttribute('longitude', $row['longitude'][$i]);
				$gps->appendChild($point);
			}
			$nog->appendChild($gps);
			$root->appendChild($nog);
		}
		$xml->appendChild($root);
		echo $xml->saveXML();
	}
	elseif($_GET['action']=='building') //on veut la liste des zones et de leurs bâtiments
	{
		if(is_numeric($_GET['id']))
		{
			$arr = MapModel::GetBuilding($dbconnection,$_GET['id']);
		}
		else
		{
			$arr = MapModel::GetBuilding($dbconnection);
		}
		ob_clean();
		//echo'<pre>';print_r($arr);echo'</pre>';
		header('Content-Type: text/xml; charset=utf-8');
		$xml = new DOMDocument('1.0', 'utf-8');
		$root = $xml->createElement('list');
		foreach($arr as $building => $row)
		{
			$nog = $xml->createElement('building');
			$nog->setAttribute('id', $building);
			$nog->setAttribute('name', $row['name']);
			$nog->appendChild($xml->createElement('description',$row['description']));
			$nog->appendChild($xml->createElement('abbreviation',$row['abbreviation']));
			if(isset($row['floor']))
			{
				foreach($row['floor'] as $floor)
				{
					$flo = $xml->createElement('floor');
					$flo->setAttribute('id', $floor['id']);
					$flo->appendChild($xml->createElement('name',$floor['name']));
					$flo->appendChild($xml->createElement('map',$floor['map']));
					$nog->appendChild($flo);
				}
			}
			$point = $xml->createElement('point');
			$point->setAttribute('latitude', $row['latitude']);
			$point->setAttribute('longitude', $row['longitude']);
			$nog->appendChild($point);
			$root->appendChild($nog);
		}
		$xml->appendChild($root);
		echo $xml->saveXML();
	}
	//on veut une infobulle
	elseif($_GET['action']=='infobulle')
	{
		//chemin d'accès au repertoire du plugin contenant les templates
		$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_LOCATION');
		$template_path= $path.$arr[0]['apache_path'].'template/';
		$smarty->assign('map_template_directory',$template_path);
		$smarty->assign('map_path_plugin',$arr[0]['apache_path']);
		//Infobulle des zones
		if($_GET['type']=='zone' && is_numeric($_GET['id']))
		{
			$arr = MapModel::GetZone($dbconnection,$_GET['id']);
			//préparation de la requête
			$query = MapModel::PrepareGetFloorError($dbconnection,$user->getId());
			$building=array();
			$zone['name']=$arr[$_GET['id']]['name'];
			//on parcour tout les bâtiments
			foreach($arr[$_GET['id']]['building'] as $build)
			{
				$building[$build['id']] = array('name'=> $build['name'],'description'=>$build['description']);
				$floors=array();
				foreach($build['floor'] as $floor)
				{
					$floors[$floor['id']]= MapModel::ExecuteGetFloorState($dbconnection,$query,$floor['id']);
					$floors[$floor['id']]['name']=$floor['name'];
				}
				//echo'<pre>';print_r($floors);echo'</pre>';
				//on ajoute le tableau des étages au bâtiments
				$building[$build['id']]['floor']=$floors;
			}
			//on ajout le tableau des bâtiments au tableau des zones
			$zone['building'] =$building;
			$smarty->assign('zone',$zone);
			//variable de langue
			$smarty->assign('l_map_floor',$lang['MAP_FLOOR']);
			$smarty->assign('l_map_area',$lang['MAP_AREA']);
			$smarty->assign('l_map_building',$lang['MAP_BUILDING']);
			//génération de l'HTML présent dans l'infobulle
			$smarty->display($template_path.'map_infobulle.html');
		}
		elseif($_GET['type']=='building' && is_numeric($_GET['id']))
		{
			//Infobule des bâtiments
			$arr = MapModel::GetBuilding($dbconnection,$_GET['id']);
			$build = $arr[$_GET['id']];
			$query = MapModel::PrepareGetFloorError($dbconnection,$user->getId());
			$floors=array();
			if(!empty($build['floor']))
			{
				foreach($build['floor'] as $floor)
				{
					$floors[$floor['id']]= MapModel::ExecuteGetFloorState($dbconnection,$query,$floor['id']);
					$floors[$floor['id']]['name']=$floor['name'];
				}
			}
			//on ajoute le tableau des étages au bâtiments
			$build['floor']=$floors;
			//on ajout le tableau des bâtiments au tableau des zones
			$smarty->assign('building',$build);
			$smarty->assign('buildinginfo','bat');
			//variable de langue
			$smarty->assign('l_map_floor',$lang['MAP_FLOOR']);
			$smarty->assign('l_map_errors',$lang['MAP_ERRORS']);
			$smarty->assign('l_map_node',$lang['MAP_NODE']);
			$smarty->assign('l_map_message',$lang['MAP_MESSAGE']);
			$smarty->assign('l_map_area',$lang['MAP_AREA']);
			$smarty->assign('l_map_building',$lang['MAP_BUILDING']);
			//génération de l'HTML présent dans l'infobulle
			$smarty->display($template_path.'map_infobulle.html');
		}
		elseif($_GET['type']=='floor' && is_numeric($_GET['id']))
		{
			//echo' salut '.$_GET['id'].' '.$_GET['localtype'];
			if($_GET['localtype']=='container')
			{				
				$container = MapModel::getContainers($dbconnection,$_GET['id']);
				$container = $container[$_GET['id']];
				$listNode=array();
				if(!empty($container['nodes']))
				{
					//on récupère les plugins et les pages de controle de chaque type de noeud
					$devType = Model_esia::getDeviceType($dbconnection);
					foreach($container['nodes'] as $node)
					{
						if($user->getAccess($dbconnection,"device_view",$node['name']) ==1)
						{
							$page_control='/node_view.php?name='.$node['name'];
							if(!empty($devType[$node['type']]['web_plugin_control_page']))
							{
								$page_control = Model_esia::replacePageControlVariable($devType[$node['type']]['web_plugin_control_page'], $node);
								$page_control = $devType[$node['type']]['web_plugin_apache_path'].$page_control;
							}
							//on récupère l'état du noeud
							$errors = Model_esia::getNodeError($dbconnection,$node['id']);
							$state='OK';
							$list_error =array();
							foreach($errors as $error)
							{
								$list_error[]=array('type'=>$error['type'],
										'name'=>$error['error'],
										'service'=>$error['service'],
										'message'=>$error['message'],
										'time'=>$error['time'],
								);
								if($error['type']=='critical')
								{
									$state='critical';
								}
								elseif($error['type']=='warning' && $state!='critical')
								{
									$state='warning';
								}
								elseif($error['type']=='unknown' && $state!='warning' && $state!='critical')
								{
									$state='unknown';
								}
							}
														
							/*if(count($list_error)=="0")
							{								
								$nbrErr = "OK";
							}
							else
							{
								$nbrErr=count($list_error);
							}*/
							
							$listNode[]=array('name'=>$node['name'],
											'type'=>$node['type'],
											'group'=>$node['group'],
											'page_control'=>$page_control,
											'nbrErr'=>count($list_error),
											'state'=>$state,
											'errors'=>$list_error);
						}
					}
				}
				$smarty->assign('l_map_state',$lang['MAP_STATE']);
				$smarty->assign('l_map_node_group',$lang['MAP_NODE_GROUP']);
				$smarty->assign('l_map_container_type',$lang['MAP_CONTAINER_TYPE']);
				$smarty->assign('container',$container);
				$smarty->assign('nodes',$listNode);
			}
			elseif($_GET['localtype']=='node')
			{
				$node = Model_esia::InstanceNode($dbconnection, $_GET['id']);
				if($user->getAccess($dbconnection,"device_view",$node->getName()) ==1)
				{
					$page_control = Model_esia::getPageControl($dbconnection, $node->getType());
					if($page_control!=null)
					{
						$page_control = Model_esia::replacePageControlVariable($page_control, $node);
					}
					else
					{
						$page_control='/node_view.php?name='.$node->getId();
					}
					//on récupère l'état du noeud
					$errors = Model_esia::getNodeError($dbconnection,$node->getId());
					$state='OK';
					$list_error =array();
					foreach($errors as $error)
					{
						$list_error[]=array('type'=>$error['type'],
								'name'=>$error['error'],
								'service'=>$error['service'],
								'message'=>$error['message'],
								'time'=>$error['time'],
						);
						if($error['type']=='critical')
						{
							$state='critical';
						}
						elseif($error['type']=='warning' && $state!='critical')
						{
							$state='warning';
						}
						elseif($error['type']=='unknown' && $state!='warning' && $state!='critical')
						{
							$state='unknown';
						}
					}
					
					/*if(count($list_error)=="0")
					{
						$nbrErr = "OK";
					}
					else
					{
						$nbrErr=count($list_error);
					}*/
					
					$listNode=array('name'=>$node->getName(),
							'type'=>$node->getType(),
							'description'=>$node->getDescription(),
							'description'=>$node->getIPv4Adress(),
							'group'=>$node->getType(),
							'page_control'=>$page_control,
							'nbrErr'=>count($list_error),
							'state'=>$state,
							'errors'=>$list_error);
					$smarty->assign('node',$listNode);
				}
			}
			$smarty->display($template_path.'map_infobulle.html');
		}
	}
	//on recupère la list des noeuds 
	elseif($_GET['action']=="getNode")
	{
		if($user->getAccess($dbconnection,"map_administration") ==1)
		{
			if(isset($_GET['group'])&&!empty($_GET['group']))
			{
				//echo 'ici';
				$nodes  = Model_esia::newgetNodeList($dbconnection,$user->getId(),$_GET['group'],Model_esia::NODE_INSTANCE);
				//print_r($nodes);
				//création de l'XML
				ob_clean();
				header('Content-Type: text/xml; charset=utf-8');
				$xml = new DOMDocument('1.0', 'utf-8');
				$root = $xml->createElement('list');
				//création de l'XML
				foreach($nodes as $node)
				{
					$nog = $xml->createElement('node');
					$nog->setAttribute('id', $node->getId());
					$nog->setAttribute('name', $node->getName());
					$root->appendChild($nog);
				}
				$xml->appendChild($root);
				echo $xml->saveXML();
			}
		}
	}
}
?>
