<?php
/**
 * @name srv_scanport.php
 * @description Script appellé lorsque l'on demande un scannage des ports du serveurs, il est appellé via une requête AJAX
 *		attention faire en root  chmod u+s /usr/bin/nmap pour que nmap soit exécutable par PHP
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */
//pas de mise en cache
header("Expires: Mon, 10 Feb 1988 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-cache, must-revalidate");
header("Pragma: no-cache");
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once DEVICE_CLASS;
include_once './libs/Server.class.php';
include_once './model_srv.php';
$server=$_GET['server'];
//test des droits d'accès
if($user->getDroits($dbconnection,"device_view",$server) ==1)
{
	try
	{
		//instanciation d'un objet serveur
		$srv=Model_server::getInstanceServer($dbconnection,$server);

		if(isset($_GET['start_port'])&&isset($_GET['end_port']))
		{
			$start_port=$_GET['start_port'];
			$end_port=$_GET['end_port'];
			//on vérifie que les ports entrés sont bien numériques
			if(is_numeric($start_port)&&is_numeric($end_port))
			{
				$output=array();
				//exécution de la requête
				exec('nmap -sS -n -p '.$start_port.'-'.$end_port.' '.$srv->getIPv4Adress(),$output);
				//on format la sortie
				formatNmapOutput($output);
			}
		}
		else
		{
			$output=array();
			exec('nmap -sS -n '.$srv->getIPv4Adress(),$output);
			formatNmapOutput($output);
		}
	}
	//Traitement des exceptions SNMP et des erreurs de traitement dans la base de donnée
	catch(DeviceNotAliveException $e)
	{
		$smarty->assign('l_host_no_response','no');
	}
	catch(DeviceSNMPException $e)
	{
		$smarty->assign('l_host_no_response',$lang['ADM_ERR_SNMP_FAILED']);
	}
	catch(ModelServerException $e)
	{
		$smarty->assign('error_node_no_found',$srv->getId());
	}
}
/*@NAME: formatNmapOutput
 *@IN: $output l'affichage envoyée sur la sortie standard par nmap
*@OUT: /
*@TREAT: Format la sortie en un tableau HTML
*@EXCEPTION: 	/
*/
function formatNmapOutput($output)
{
	foreach($output as $out)
	{
		if(preg_match('#PORT#',$out))
		{
			echo'<table class="tab"><tr><th>Port</th><th>Protocol</th><th>Etat</th><th>Service</th></tr>';
		}
		elseif(preg_match('#([0-9]*)/([a-z]*)\s+([a-z\|]*)\s+(.*)#',$out,$regs))
		{
			echo'<tr><td>'.$regs[1].'</td>';
			echo'<td>'.$regs[2].'</td>';
			if(preg_match('#^filtered$#',$regs[3]))
			{
				echo'<td class="EventOK">'.$regs[3].'</td>';
			}
			elseif(preg_match('#^closed$#',$regs[3]))
			{
				echo'<td class="EventWarning">'.$regs[3].'</td>';
			}
			elseif(preg_match('#^open$#',$regs[3]))
			{
				echo'<td class="EventWarning">'.$regs[3].'</td>';
			}
			elseif(preg_match('#^unfiltered$#',$regs[3]))
			{
				echo'<td class="EventCritical">'.$regs[3].'</td>';
			}
			else
			{
				echo'<td class="EventUnknown">'.$regs[3].'</td>';
			}
			echo'<td>'.$regs[4]."</td></tr>\n";
		}
		elseif(preg_match('#MAC#',$out))
		{
			echo'</table>';
			echo $out.'<br />';
		}
		else
		{
			echo $out.'<br />';
		}
	}
}
?>
