<?php
/**
 * @name  Model_server
 * @description Classe héritant de "Model_esia" gèrent tout les accès à la base de donnée du plugin Server
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 08/11/2012
 */
include_once DEVICE_CLASS;
include_once MVCMODEL;
include_once './libs/RemoteWmi.class.php';
if(!class_exists('Wmi'))
{
	include_once './libs/Wmi.class.php';

}

class Model_wmi extends Model_esia
{
	/*@NAME: getInstanceServer
	 *@IN: $dbconnection un objet PDO
	* 	$server nom ou ID du wmi
	*	$manufacturer (optionnelle) pas encore implémenté
	*@OUT: un objet Server
	*@TREAT: Instance un objet wmi
	*@EXCEPTION: 	EsiaDbException  si une erreur avec la BD survient
	*/
	public static function InstanceWmi($dbconnection,$wmi,$manufacturer=null)
	{
		try
		{
			$node = Model_esia::InstanceNode($dbconnection,$wmi);
			$srv = New Wmi($node);
			if(@get_class($node)=='RemoteDevice')
			{
				$srv = New RemoteWmi($node,$node->getGESA() );
			}
			
			return $srv;
		}
		catch(EsiaDbException $e)
		{			
			throw new ModelServerException('Errors in instanciation Server\'s object'.$server,1,$e);
		}
	}
}
class ModelServerException extends EsiaDbException{}
?>
