<?php
/**
 * @name wmi_control.php
 * @description Fichier principal du plugin winclient
 * @author George Julien <j.george@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 08/01/2015
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once './model_wmi.php';


$temps = microtime();
$temps = explode(' ', $temps);
$debut = $temps[1] + $temps[0];

//on récupère l'id du serveur
$node_id=$_GET['win_host'];

//chemin d'accès au repertoire du plugin contenant les templates
$arr = Model_esia::getWebPlugin($dbconnection,false,'PCWin');
$template_path= $path.$arr[0]['apache_path'].'template/';

//ajout d'un lien pour la navbar
array_push($_SESSION['navbar'],array('name'=> $lang['NODE'],'link'=>'/node_index.php'));

//on récupère le nom du PC
$node=Model_wmi::InstanceWmi($dbconnection, $node_id);

if($user->getDroits($dbconnection,"device_view",$node->getName()) ==1) { //on test si on a les autorisation d'accès
	try
	{
		//On a reussi a instancier un objet server donc on complète la navbar
		$navbar->addNode($node, $ICONS[$node->getType()]);
		//Etats des services
		$listState = Model_esia::countNodeState($dbconnection, $node->getId());
		$nbr_error=0;
		//on additionne les erreurs et les services OK (on a ainsi le total des services check et des services passifs)
		$nbr_error=$nbr_error+$listState['critical']+$listState['warning']+$listState['unknown'];
		$smt_status = array('nbr_error'=>$nbr_error,
				'nbr_service'=>$nbr_error + $listState['OK']);
		$smt_status = array_merge ($smt_status,$listState);
		
		$smt_node = array('name'=>$node->getName(),
				'ip'=>$node->getIPv4Adress(),
				'id'=>$node->getId(),
				'description'=>$node->getDescription(),
				'group'=>$node->getGroup()
		);		
		$smarty->assign('node_status',$smt_status);
		$smarty->assign('node',$smt_node);
	}	
	//Traitement des exceptions SNMP et des erreurs de traitement dans la base de donnée
	catch(DeviceNotAliveException $e)
	{
		$smarty->assign('l_host_no_response','no');
	}
	catch(DeviceSNMPException $e)
	{		
		$smarty->assign('l_host_no_response',$lang['ADM_ERR_SNMP_FAILED']);
	}
	catch(ModelServerException $e)
	{		
		$smarty->assign('error_node_no_found',$srv->getId());
	}
}

//Affichage de la page
$temps = microtime();
$temps = explode(' ', $temps);
$fin = $temps[1] + $temps[0];

$smarty->assign('l_srv_page_exe', $lang['SRV_PAGE_EXE']);
$smarty->assign('l_srv_page_exe_time', $lang['SRV_PAGE_EXE_TI']);
$smarty->assign('l_show_portscanner', $lang['SRV_PORT_SCANNER']);
$smarty->assign('l_show_service', $lang['SHOW_SERVICE']);
$smarty->assign('l_show_historic', $lang['SHOW_HISTORIC']);
$smarty->assign('l_show_graph', $lang['SHOW_GRAPH']);
$smarty->assign('l_srv_report', $lang['REPORT']);

$smarty->assign('node_id',$node_id);
$smarty->assign('node_name',$node->getName());

$smarty->assign('execute_time',round(($fin - $debut),6) );

if( isset($_GET['action'])) {
	if($_GET['action'] == "main"){	
		//Hardware		
		$smarty->assign('l_hardware', $lang['WMI_HARDWARE']);
		$smarty->assign('l_Motherboard', $lang['WMI_MOTHERBOARD']);
		$smarty->assign('l_CPU', $lang['WMI_CPU']);
		$smarty->assign('l_RAM', $lang['WMI_RAM']);
		$smarty->assign('l_network', $lang['WMI_NETWORK']);
		
		//Partitions
		$smarty->assign('l_partitions', $lang['WMI_PARTITIONS']);
		
		//Software
		$smarty->assign('l_software', $lang['WMI_SOFTWARE']);
		$smarty->assign('l_OS', $lang['WMI_OS']);
		$smarty->assign('l_updates', $lang['WMI_UPDATES']);
		$smarty->assign('l_security', $lang['WMI_SECURITY']);
		
		//Date
		$smarty->assign('l_date', $lang['WMI_DATE']);
		
		$smarty->display($template_path.'wmi_show.html');
	}
	else if($_GET['action'] == "hardware"){
		$smarty->assign('l_DiskDrives', $lang['WMI_DISKDRIVES']);
		$smarty->assign('l_LogicalDisks', $lang['WMI_LOGICALDISKS']);
		$smarty->assign('l_DiskPartitions', $lang['WMI_DISKPARTITIONS']);
		$smarty->assign('l_network', $lang['WMI_NETWORK']);
		$smarty->assign('l_printers', $lang['WMI_PRINTERS']);
		
		$smarty->display($template_path.'wmi_hardware.html');
	}
	else if($_GET['action'] == "software"){
		$smarty->assign('l_OS', $lang['WMI_OS']);
		$smarty->assign('l_services', $lang['WMI_SERVICES']);
		$smarty->assign('l_features', $lang['WMI_FEATURES']);
		$smarty->assign('l_programs', $lang['WMI_PROGRAMS']);
		$smarty->assign('l_security', $lang['WMI_SECURITY']);
		$smarty->assign('l_updates', $lang['WMI_UPDATES']);
		
		$smarty->display($template_path.'wmi_software.html');	
	}
}
else {
	//Etats des services
	$listState = Model_esia::countNodeState($dbconnection, $node->getId());
	$nbr_error=0;
	$smarty->assign('status_nbr_critical',$listState['critical']);
	$smarty->assign('status_nbr_warning',$listState['warning']);
	$smarty->assign('status_nbr_unknown',$listState['unknown']);
	
	//on additionne les erreurs et les services OK (on a ainsi le total des services check et des services passifs)
	$nbr_error=$nbr_error+$listState['critical']+$listState['warning']+$listState['unknown'];
	$smarty->assign('status_nbr_error',$nbr_error);
	$smarty->assign('status_nbr_OK',$listState['OK']);
	$smarty->assign('status_nbr_service',$nbr_error + $listState['OK'] );
	
	//affichage de quelques informations général sur le noeud
	$smarty->assign('srv_control_name',$node->getName());
	$smarty->assign('srv_control_id',$node->getId());
	$smarty->assign('srv_control_IP',$node->getIPv4Adress());
	$smarty->assign('node_name',$node->getName() );
	$smarty->assign('node_description',$node->getDescription() );
	$smarty->assign('node_group',$node->getGroup() );
	$smarty->assign('node_type',$node->getType() );
	
	
	$smarty->assign('l_information', $lang['INFORMATION_NODE']);
	$smarty->assign('l_state_service', $lang['SERVICE_STATE']);
	$smarty->assign('l_state_service_passifcheck', $lang['SERVICE_STATE_CHECK_PASSIF']);
	$smarty->assign('l_modification', $lang['MODIF']);
	$smarty->assign('l_pattern_add_service',$lang['ADM_PATTERN_ADD_SERVICE']);
	$smarty->assign('l_pattern_service_add',$lang['ADM_PATTERN_SERVICE_ADD']);
	$smarty->assign('l_device', $lang['DEVICE']);
	$smarty->assign('l_srv_ctrl_ip', $lang['SRV_CTRL_IP']);
	$smarty->assign('l_description', $lang['ADM_DESCRIPTION']);
	$smarty->assign('l_group', $lang['ADM_GRP']);
	
	
	$smarty->assign('l_show_service', $lang['SHOW_SERVICE']);
	$smarty->assign('l_show_historic', $lang['SHOW_HISTORIC']);
	$smarty->assign('l_srv_report', $lang['REPORT']);
	$smarty->assign('l_show_graph', $lang['SHOW_GRAPH']);
	
	$smarty->assign('l_hardware', $lang['WMI_HARDWARE']);
	$smarty->assign('l_programs', $lang['WMI_PROGRAMS']);
	
	$smarty->display($template_path.'wmi_control.html');
}
?>
