<?php
/**
 * @name check_nrpe.php
 * @description Fichier principal du plugin winclient
 * @author George Julien <j.george@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 08/01/2015
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once './model_wmi.php';

//include_once '../gesa/gesa_config.php';
//include_once $path.'/Model_adm.php';
//include_once $path.'/plugin/gesa/libs/gesa.class.php';


//$params=$list[$_GET['nrpe_id']];
$mode=$_GET['mode'];
$node=Model_wmi::InstanceWmi($dbconnection,$_GET['node_id']);

//chemin d'accès au repertoire du plugin contenant les templates
$arr = Model_esia::getWebPlugin($dbconnection,false,'PCWin');
$template_path= $path.$arr[0]['apache_path'].'template/';

$GLOBALS["lang"]=$lang;
session_write_close();
try{
if($user->getDroits($dbconnection,"device_view",$node->getName()) ==1){
		session_write_close();	
		
		$smarty->assign("l_showing",$lang["WMI_SHOWING_WORD"]);
		
		if($mode=="cpu"){
			$smarty->assign("data",$node->getCpuInfos());
			$smarty->display($template_path.'wmi_elm.html');
		}
		else if($mode=="mb"){
			$result=$node->getMotherBoardInfos();
	
			$vals=$result[0];
			$message=$vals["Manufacturer"]." ";
   			$tip=$vals["Product"]." ".$vals["Version"];
			$data=array();	
			$smarty->assign("data",addtext($data,$lang["WMI_MOTHERBOARD"],$message,$tip));
			$smarty->display($template_path.'wmi_elm.html');
		}
		else if($mode=="ram"){
			$result=$node->getRamInfos();
			preg_match('#[^:]*:\s*(\d*)\s*(\w*)[^\(]\((\d*)%[^:]*:\s*(\d*)\/(\d*)\s*#',$result["data"][0],$matches);
			
			$data=array();
			$smarty->assign("data",addusage($data,$lang["WMI_RAM"], $matches[1], $matches[5], $matches[2]));
			$smarty->display($template_path.'wmi_elm.html');
		}
		else if($mode=="eth"){
			$result=$node->getNetInfos();
			
			$data=array();
			$smarty->assign("data",addtext($data,$lang["WMI_NETWORK"],count($result) . " interfaces."));
			$smarty->display($template_path.'wmi_elm.html');			
		}
		else if($mode=="part"){
			$result=$node->getDiskInfos();
			
			$arr=array();
			for($i=1;$i<count($result);$i++){
				$vals=GESA::line_to_array($result[0], $result[$i]);
			
				$size=$vals["Size"];
				$free=$vals["FreeSpace"];
				$used= $size-$free;
			
				if($vals["Size"]>0) $percent= (100/$size)*$used;
				else $percent=0;
			
				$uf=octetBetterUnit($free);
				$ut=octetBetterUnit($size);
				$uu=octetBetterUnit($used);
			
				$vf=intval(convertOctets($free,$uf));
				$vt=intval(convertOctets($size,$ut));
				$vu=intval(convertOctets($used,$uu));
			
				$message="";
				$message=$message . " ".$lang['WMI_USED_WORD']." : " . $vu . " " . $uu;
				$message=$message . " ".$lang['WMI_FREE_WORD']." : ". $vf . " " . $uf;
				$message=$message . " ".$lang['WMI_SIZE_WORD']." : " . $vt . " " . $ut;
				$message=$message . " ".$lang['WMI_SUPPORT_WORD']." : " . $vals["Description"];
				
				addpercent($arr,explode(":",$vals["Name"])[0],$percent,$message);
			}
			$smarty->assign("data",$arr);
			$smarty->display($template_path.'wmi_elm.html');
		}
		else if($mode=="os"){
			$result=$node->getOsInfos();	
			$vals=GESA::data_to_arrays($result)[0];
				
			$message=explode("|",$vals["Name"],2)[0];
			$data=array();
			addtext($data,$lang["WMI_OS"],$message," (" . $vals["OSArchitecture"] . ") ".$vals["CSDVersion"]);
			$smarty->assign("data",$data);
			$smarty->display($template_path.'wmi_elm.html');
		}
		else if($mode=="updates"){
			$result=$node->getUpdatesInfos();
			
			$recent_date=DateTime::createFromFormat('j/m/Y',"01/02/1970");
			foreach($result as $date){
				$current_date=DateTime::createFromFormat('m/j/Y',$date[0]);
				if($recent_date < $current_date ) $recent_date = $current_date;
			}
			
			$interval = $recent_date->diff(new DateTime("now"));
			$m=$interval->format('%y')*12;
			$m+=$interval->format('%m');
			
			$text="$m ".$lang["WMI_MONTHS"];
			$tip=$lang["WMI_LAST_UPDATES_SENTENCE"]. " " . $recent_date->format($lang["WMI_DATE_FORMAT"]);
			
			$error_type=2;
			if($m<1){		
				$error_type=0;
				$text=$interval->format("%d ".$lang["WMI_DAYS"]);
			}
			else if($m<2)	$error_type=1;

			$data=array();
			addbartext($data,$lang["WMI_UPDATES"],$text,$error_type,$tip);
			
			$smarty->assign("data",$data);
			$smarty->display($template_path.'wmi_elm.html');
		}
		else if($mode=="security"){
			$security=array();
			//Antivirus
			$av=$node->getSecurity("antivirus");
			$protect=0;
			$def=0;
			$ok=0;
			foreach($av as $value){
				if($value["Protection"]=="Enabled") $protect++;
				if($value["Definitions"]=="Updated") $def++;
				if($value["Definitions"]=="Enabled"&&$value["Protection"]=="Updated") $def++;
			}
			
			$security["av"]["error"]=0;
			$security["av"]["text"]=$lang['WMI_AV_WORD'];
			if($ok !=1 || $protect!=1){
				$security["av"]["error"]=2; //CRITICAL
				if(count($av)==0)    $security["av"]["tip"]=$lang['WMI_AV_NOT_INSTALLED_SENTENCE'].".";
				else if($protect>1)  $security["av"]["tip"]=$lang['WMI_AV_CONCURRENTS_SENTENCE']." ($protect).";
				else if($protect==0) $security["av"]["tip"]=$lang['WMI_AV_NOT_ENABLED_SENTENCE'].".";
				else{
					$security["av"]["tip"]=$lang['WMI_AV_NOT_UPDATED_SENTENCE'].".";
					$security["av"]["error"]=1; // WARNING	
				}
			}
		
			//Firewall
			$fw=$node->getSecurity("firewall");
			$protect=0;
			$def=0;
			$ok=0;
			foreach($fw as $value){
				if($value["Protection"]=="Enabled") $protect++;
				if($value["Definitions"]=="Updated") $def++;
				if($value["Definitions"]=="Enabled"&&$value["Protection"]=="Updated") $def++;
			}
			$security["fw"]["error"]=0;		
			$security["fw"]["text"]=$lang['WMI_FW_WORD'];
			if($ok<1){
				$security["fw"]["error"]=1;
				if(count($fw)==0)		$security["fw"]["tip"]=$lang['WMI_FW_NOT_INSTALLED_SENTENCE'].".";
				else if($protect==0)  	$security["fw"]["tip"]=$lang['WMI_FW_NOT_ENABLED_SENTENCE'].".";
				else 					$security["fw"]["tip"]=$lang['WMI_FW_NOT_UPDATED_SENTENCE'].".";
			}
			
			//Spyware
			$sw=$node->getSecurity("spyware");
			$protect=0;
			$def=0;
			$ok=0;
			foreach($sw as $value){
				if($value["Protection"]=="Enabled") $protect++;
				if($value["Definitions"]=="Updated") $def++;
				if($value["Definitions"]=="Enabled"&&$value["Protection"]=="Updated") $def++;
			}
			$security["sw"]["error"]=0;
			$security["sw"]["text"]=$lang['WMI_SP_WORD'];
			if($ok<1){
				$security["sw"]["error"]=1;
				if(count($sw)==0)		  	$security["sw"]["tip"]=$lang['WMI_SP_NOT_INSTALLED_SENTENCE'].".";
				else if($protect==0)  	$security["sw"]["tip"]=$lang['WMI_SP_NOT_ENABLED_SENTENCE'].".";
				else 					$security["sw"]["tip"]=$lang['WMI_SP_NOT_UPDATED_SENTENCE'].".";
			}
			
			$error_type=0; //OK
			$text=$tip="";
			$i=0;
			foreach($security as $value){
				if($value["error"]>0){
					if($error_type>0){
						$text=$text.", ";
						$tip=$tip. " ";
					}
					if($error_type<$value["error"]) $error_type=$value["error"];
					$text=$text.$value["text"];
					$tip=$tip.$value["tip"];
					$i++;
				}
			}
			if($i==3) $text=$lang['WMI_AV_FW_SP_ABV'];
			if($error_type==0){
				$text="OK";
				$tip=$lang['WMI_SECURITY_OK_SENTENCE'].".";
			}		
			$data=array();
			addbartext($data,"Sécurité",$text,$error_type,$tip);
	
			$smarty->assign("data",$data);
			$smarty->display($template_path.'wmi_elm.html');
		}
		else if($mode=="date"){
			$arr=array();
			$result=$node->getDateInfos();
			
			$remote_date=parse_date($result[0][0]);
			$actual_date=new DateTime('NOW');
			$diff=abs($actual_date->format("U")-$remote_date->format("U"));
			
			addtext($arr,$lang['WMI_ESIA_SERVER'],$actual_date->format($lang['WMI_DATETIME_FORMAT']),$_SERVER['SERVER_NAME']);
			addtext($arr,$lang['WMI_COMPUTER'],$remote_date->format($lang['WMI_DATETIME_FORMAT']),$node->getName());
			addtext($arr,$lang['WMI_TIME_DIFF'],$diff . " ".$lang['WMI_SECONDES']);

			$smarty->assign("data",$arr);
			$smarty->display($template_path.'wmi_elm.html');
		}
		else if($mode=="info_tab"){
			$type="OS";
			$data=$node->getOsDetails();
				
			$os[getLang($type,"MUILanguages")]=$data[0]["MUILanguages"];
			$os[getLang($type,"SerialNumber")]=$data[0]["SerialNumber"];
			$os[getLang($type,"NumberOfProcesses")]=$data[0]["NumberOfProcesses"];
			
			$licensed=$data[0]["NumberOfLicensedUsers"];
			if($licensed==0) $licensed=$lang["WMI_UNLIMITED_WORD"];
			else if ($licensed==-1) $licensed=$lang["WMI_UNKNOWN_WORD"];
			$users[getLang($type,"NumberOfLicensedUsers")]=$licensed;
			$users[getLang($type,"NumberOfUsers")]=$data[0]["NumberOfUsers"];
			$users[getLang($type,"RegisteredUser")]=$data[0]["RegisteredUser"];
			
			$time[getLang($type,"LocalDateTime")]=parse_date($data[0]["LocalDateTime"])->format($lang["WMI_DATETIME_FORMAT"]);
			$time[getLang($type,"InstallDate")]=parse_date($data[0]["InstallDate"])->format($lang["WMI_DATETIME_FORMAT"]);
			$time[getLang($type,"LastBootUpTime")]=parse_date($data[0]["LastBootUpTime"])->format($lang["WMI_DATETIME_FORMAT"]);
				
			$smarty->assign('os',$os);
			$smarty->assign('users',$users);
			$smarty->assign('time',$time);
			$smarty->display($template_path.'wmi_info.html');
		}
		else if($mode=="services_tab"){
			$type="SERVICES";
			$data=$node->getServicesDetails();

			$data=correct_bad_chars($data);
			
			$tip=array();	
			for($i=0;$i<count($data);$i++){
				$tip[$i]=$data[$i]["Description"];
				unset($data[$i]["Description"]);
			}
		
			$data=tabLang($type, $data,"Name");
			$data=tabLang($type, $data,"Caption");
			$data=tabLang($type, $data,"Started",true);
			$data=tabLang($type, $data,"StartMode",true);
			$data=tabLang($type, $data,"ServiceType",true);
			$data=tabLang($type, $data,"PathName");
			
			$arr=array();
			foreach ($data as $value){
				$key=$value[getLang($type,"Started")];
				if(isset($arr[$key])) $arr[$key]++;
				else $arr[$key]=0;
			}
				
			$smarty->assign('started',$arr);
			
			$arr=array();
			foreach ($data as $value){
				$key=$value[getLang($type,"StartMode")];
				if(isset($arr[$key])) $arr[$key]++;
				else $arr[$key]=0;
			}
			
			$smarty->assign('l_graphicals',$lang['WMI_GRAPHICALS_WORD']);
			$smarty->assign('startmode',$arr);
			$smarty->assign('line_tip',$tip);
			
			$smarty->assign('data',$data);
			$smarty->assign('id',"services");
			
			$smarty->display($template_path.'wmi_table.html');
		}
		else if($mode=="features_tab"){
			$type="FEATURES";
			$data=$node->getFeatureDetails();
			$data=correct_bad_chars($data);
				
			
			$InstallStates=array(1=>"Enabled","Disabled","Absent","Unknown");
			for($i=0;$i<count($data);$i++){
				$data[$i]["InstallState"]=$InstallStates[$data[$i]["InstallState"]];
			}
			
			$data=tabLang($type, $data,"Name");
			$data=tabLang($type, $data,"Caption");
			$data=tabLang($type, $data,"InstallState",true);
			
			$smarty->assign('data',$data);
			$smarty->assign('id',"features");
			
			$smarty->display($template_path.'wmi_table.html');
		}
		else if($mode=="software_tab"){
			$type="SOFTWARE";
			$data=$node->getSoftwareDetails();
			
			$data=correct_bad_chars($data);
			
			$InstallStates=array(
					-6	=> "Bad Configuration",
					-2 	=> "Invalid Argument",
					-1 	=> "Unknown Package",
					1	=> "Advertised",
					2	=> "Absent",
					5	=> "Installed",
			);

			for($i=0;$i<count($data);$i++){
				if($data[$i]["InstallLocation"]=="(null)") $data[$i]["InstallLocation"]=""; 
				$data[$i]["InstallDate"]=DateTime::createFromFormat("Ymj",($data[$i]["InstallDate"]))->format($lang["WMI_DATE_FORMAT"]);
				$data[$i]["InstallState"]=$InstallStates[$data[$i]["InstallState"]];
			}
			
			$data=tabLang($type, $data,"Name");
			$data=tabLang($type, $data,"Vendor");
			$data=tabLang($type, $data,"InstallDate");
			$data=tabLang($type, $data,"Version");
			$data=tabLang($type, $data,"InstallLocation");
			$data=tabLang($type, $data,"InstallSource");
			$data=tabLang($type, $data,"PackageName");
			$data=tabLang($type, $data,"InstallState",true);
			
			$smarty->assign('sort_type',array(getLang($type,"InstallDate")=>"sorter-ddmmyy"));
			$smarty->assign('data',$data);
			$smarty->assign('id',"software");
			$smarty->display($template_path.'wmi_table.html');
		}
		else if($mode=="security_tab"){
			$type="SECURITY";
			$data=$node->getSecurity();
			
			$data=tabLang($type, $data,"displayName");
			$data=tabLang($type, $data,"Type",true);
			$data=tabLang($type, $data,"Definitions",true);
			$data=tabLang($type, $data,"Protection",true);
			$data=tabLang($type, $data,"pathToSignedProductExe");
			$data=tabLang($type, $data,"pathToSignedReportingExe");
			
			$smarty->assign('data',$data);
			$smarty->assign('id',"security");
			$smarty->display($template_path.'wmi_table.html');
				
		}
		else if($mode=="disk_tab"){
			$type="DRIVE";
			$data=$node->getDriveDetails();
			
			for($i=0;$i<count($data);$i++){
				$data[$i]["Size"]=octetString($data[$i]["Size"]);
				$data[$i]["CapabilityDescriptions"]=explode('(',explode(')',$data[$i]["CapabilityDescriptions"])[0])[1];
				$data[$i]["CapabilityDescriptions"]=str_replace(",",", ", $data[$i]["CapabilityDescriptions"]);
			}
			
			$data=tabLang($type, $data,"Model");
			$data=tabLang($type, $data,"Description");
			$data=tabLang($type, $data,"MediaType",true);
			$data=tabLang($type, $data,"Size");
			$data=tabLang($type, $data,"Partitions");
			$data=tabLang($type, $data,"SerialNumber");
			$data=tabLang($type, $data,"CapabilityDescriptions");

			$smarty->assign('sort_type',array(getLang($type,"Size")=>"B|byte"));
			$smarty->assign('data',$data);
			$smarty->assign('id',"disk");
			$smarty->display($template_path.'wmi_table.html');
		}
		else if($mode=="logical_tab"){
			$type="VOLUME";
			$data=$node->getLogicalDetails();
			
			$DriveTypes=array("Unknown","No Root Directory","Removable Disk","Local Disk","Network Drive","Compact Disk","RAM Disk");

			for($i=0;$i<count($data);$i++){
				if($data[$i]["VolumeName"]=="(null)") $data[$i]["VolumeName"]="";
				if($data[$i]["FileSystem"]=="(null)") $data[$i]["FileSystem"]="";
				if($data[$i]["VolumeSerialNumber"]=="(null)") $data[$i]["VolumeSerialNumber"]="";
				
				$data[$i]["Used"]=$data[$i]["Size"]-$data[$i]["FreeSpace"];
				if($data[$i]["Size"]>0)
				$data[$i]["FreePercent"]=intval((100/$data[$i]["Size"])*$data[$i]["FreeSpace"])."%";
				else $data[$i]["FreePercent"]="0%";
				
				$data[$i]["Size"]=octetString($data[$i]["Size"]);
				$data[$i]["FreeSpace"]=octetString($data[$i]["FreeSpace"]);
				$data[$i]["Used"]=octetString($data[$i]["Used"]);
				$data[$i]["DriveType"]=$DriveTypes[$data[$i]["DriveType"]];
			}
		
			$data=tabLang($type, $data,"Name");
			$data=tabLang($type, $data,"VolumeName");
			$data=tabLang($type, $data,"Description");
			$data=tabLang($type, $data,"DriveType",true);
			$data=tabLang($type, $data,"Used");
			$data=tabLang($type, $data,"FreeSpace");
			$data=tabLang($type, $data,"Size");
			$data=tabLang($type, $data,"FreePercent");
			$data=tabLang($type, $data,"FileSystem");
			$data=tabLang($type, $data,"VolumeSerialNumber");
			$data=tabLang($type, $data,"PowerManagementSupported",true);
			$data=tabLang($type, $data,"VolumeDirty",true);
			
	
			$smarty->assign('sort_type',array(getLang($type,"Size")=>"B|byte",
					getLang($type,"FreeSpace")=>"B|byte",getLang($type,"Used")=>"B|byte"));
			
			$smarty->assign('data',$data);
			$smarty->assign('id',"logical");
			$smarty->display($template_path.'wmi_table.html');
		}
		else if($mode=="part_tab"){
			$type="PARTITION";
			$data=$node->getPartDetails();
			
			$data=correct_bad_chars($data);
			
			for($i=0;$i<count($data);$i++){
				$data[$i]["Size"]=octetString($data[$i]["Size"]);
			}
		
			$data=tabLang($type, $data,"DiskIndex");
			$data=tabLang($type, $data,"Index");
			$data=tabLang($type, $data,"Type",true);
			$data=tabLang($type, $data,"Size",true);
			$data=tabLang($type, $data,"Bootable",true);
			$data=tabLang($type, $data,"BootPartition",true);
			$data=tabLang($type, $data,"PrimaryPartition",true);
			$data=tabLang($type, $data,"RewritePartition",true);
			$data=tabLang($type, $data,"StartingOffset");
			$data=tabLang($type, $data,"NumberOfBlocks");
			$data=tabLang($type, $data,"PowerManagementSupported",true);

			$smarty->assign('sort_type',array(getLang($type,"Size")=>"B|byte"));
			$smarty->assign('data',$data);
			$smarty->assign('id',"partitions");
			$smarty->display($template_path.'wmi_table.html');
		}
		else if($mode=="updates_tab"){
			$type="UPDATES";
			$data=$node->getUpdatesDetails();
			
			$urls=array();
			
			for($i=0;$i<count($data);$i++){
				$data[$i]["InstalledOn"]=DateTime::createFromFormat("m/j/Y",($data[$i]["InstalledOn"]))->format($lang["WMI_DATE_FORMAT"]);
				$urls[$i][getLang($type,"Caption")]=$data[$i]["Caption"];
			}
	
			$data=tabLang($type, $data,"HotFixID");
			$data=tabLang($type, $data,"Description",true);
			$data=tabLang($type, $data,"InstalledOn");
			$data=tabLang($type, $data,"Caption");
			
			$smarty->assign('sort_type',array(getLang($type,"InstalledOn")=>"sorter-ddmmyy"));
			$smarty->assign('urls',$urls);
			$smarty->assign('data',$data);
			$smarty->assign('id',"updates");
			$smarty->display($template_path.'wmi_table.html');
		}
		else if($mode=="net_tab"){
			$type="NETWORK";
			$config=$node->getNetConfigDetails();
			$adapter=$node->getNetAdapterDetails();
			
			for($i=0;$i<count($config);$i++){
				for($j=0;$j<count($adapter);$j++){
					if($config[$i]["Index"]==$adapter[$j]["DeviceID"]){
						$data[$i]=array_merge($config[$i],$adapter[$i]);
						$j=1000;
					}
				}
				unset($data[$i]['nl']);
				unset($data[$i]['Index']);
				unset($data[$i]['DeviceID']);
				
				foreach($data[$i] as $key=>$value){
					if($value=='NULL' || $value =='(null)'){
						$data[$i][$key]="";
					}
				}
				
				if(strlen($data[$i]["IPAddress"])>0){
					$line=explode("(",explode(")",$data[$i]["IPAddress"])[0])[1];
					$arr=explode(",",$line);
					$data[$i]["IPv4Address"]=$arr[0];
					$data[$i]["IPv6Address"]=$arr[1];
				}
				unset(	$data[$i]["IPAddress"]);
				
				if(strlen($data[$i]["IPSubnet"])>0){
					$line=explode("(",explode(")",$data[$i]["IPSubnet"])[0])[1];
					$arr=explode(",",$line);
					$data[$i]["IPv4Subnet"]=$arr[0];
					$data[$i]["IPv6Subnet"]=$arr[1];
				}
				unset(	$data[$i]["IPSubnet"]);
				
				if(strlen($data[$i]["DefaultIPGateway"])>0){
					$data[$i]["DefaultIPGateway"]=explode("(",explode(")",$data[$i]["DefaultIPGateway"])[0])[1];
				}	
			}
			
			$data=correct_bad_chars($data);
			
			$data=tabLang($type, $data,"NetConnectionID");
			$data=tabLang($type, $data,"Description");
			$data=tabLang($type, $data,"MACAddress");
			$data=tabLang($type, $data,"DHCPEnabled",true);
			$data=tabLang($type, $data,"DHCPServer");
			$data=tabLang($type, $data,"IPv4Address");
			$data=tabLang($type, $data,"IPv4Subnet");
			$data=tabLang($type, $data,"IPv6Address");;
			$data=tabLang($type, $data,"IPv6Subnet");
			$data=tabLang($type, $data,"DefaultIPGateway");
			$data=tabLang($type, $data,"DNSHostName");
			$data=tabLang($type, $data,"DNSDomain");
			$data=tabLang($type, $data,"ServiceName");
			
			$smarty->assign('data',$data);
			$smarty->assign('id',"net");
			$smarty->display($template_path.'wmi_table.html');
		}
		else if($mode=="printer_tab"){
			$type="PRINTER";
			$MarkingTechnology=array( "Software","Other","Unknown","Electrophotographic LED","Electrophotographic Laser","Electrophotographic Other","Impact Moving Head Dot Matrix 9pin",
					"Impact Moving Head Dot Matrix 24pin","Impact Moving Head Dot Matrix Other","Impact Moving Head Fully Formed","Impact Band","Impact Other","Inkjet Aqueous","Inkjet Solid",
					"Inkjet Other","Pen","Thermal Transfer","Thermal Transfer","Thermal Diffusion","Thermal Other","Electroerosion","Electrostatic","Photographic Microfiche",
					"Photographic Imagesetter","Photographic Other","Ion Deposition","eBeam","Typesetter");

			$data=$node->getPrinterDetails();
		
			for($i=0;$i<count($data);$i++){
				$data[$i]["MarkingTechnology"]=$MarkingTechnology[$data[$i]["MarkingTechnology"]];
			}
			
			$data=tabLang($type, $data,"DeviceID");
			$data=tabLang($type, $data,"MarkingTechnology");
			$data=tabLang($type, $data,"Default",true);	

			
			$smarty->assign('data',$data);
			$smarty->assign('id',"printer");
			$smarty->display($template_path.'wmi_table.html');		
	}
}
}
catch(Exception $e){	
	$message=$e->getMessage();
	if($e instanceof GesaConnectionFailed){
		$message=$lang["HOST_UNREACHEABLE"]." : $message";
	}

	if( $mode != 'security' && $mode != "cpu" && $mode != 'ram' ){
		$message=explode(':',$message);
		$message=trim(array_pop($message));

		$t_lang = getLang('ERROR',$message);
		if( $t_lang != null ) $message = $t_lang;

		$smarty->assign("error_message",$message);
		$smarty->display($template_path.'wmi_error.html');
	}
}
/*
function generic_security_parser($data,$type_security,$other=null){
	$state=array();
	$state[262144]=array("def"=>"Updated","protection"=>"Disabled");
	$state[262160]=array("def"=>"Outdated","protection"=>"Disabled");
	$state[266240]=array("def"=>"Updated","protection"=>"Enabled");
	$state[266256]=array("def"=>"Outdated","protection"=>"Enabled");
	$state[393216]=array("def"=>"Updated","protection"=>"Disabled");
	$state[393232]=array("def"=>"Outdated","protection"=>"Disabled");
	$state[393488]=array("def"=>"Outdated","protection"=>"Disabled");
	$state[397312]=array("def"=>"Updated","protection"=>"Enabled");
	$state[397328]=array("def"=>"Outdated","protection"=>"Enabled");
	$state[397584]=array("def"=>"Outdated","protection"=>"Enabled");
	
	if($other==null) $other=array();
	$i=count($other);
	$max=$i+count($data);
	for($j=0;$i<$max;$i++,$j++){
		$other[$i]=$data[$j];
		
		if(empty($state[$other[$i]["productState"]])){
			$other[$i]["Definitions"]="Unknown";
			$other[$i]["Protection"]="Unknown";
		}
		else{
			$other[$i]["Definitions"]=$state[$other[$i]["productState"]]["def"];
			$other[$i]["Protection"]=$state[$other[$i]["productState"]]["protection"];
		}
		unset($other[$i]["productState"]);	
		$other[$i]["Type"]=$type_security;
	}
	return $other;
}
*/
function octetBetterUnit($octet){
	$units=array("B","KB","MB","GB","TB","PB");
	for($i=0;$i<count($units);$i++){
		if($octet<10000) return $units[$i];
		$octet/=1024;
	}
}

function convertOctets($octets,$unit){
	$units=array("B","KB","MB","GB","TB","PB");
	foreach($units as $value){
		if($unit==$value) return $octets;
		$octets/=1024;
	}
}

function octetString($octet){
	$unit=octetBetterUnit($octet);
	$value=intval(convertOctets($octet,$unit));
	return $value . " " . $unit;
}

function addtext(array &$arr,$title,$text,$tip=null,$color=null){
	array_push($arr,array("title"=>$title,"text"=>$text,"tip"=>$tip,"color"=>$color));
	return $arr;
}

function addusage(array &$arr,$title,$used,$total,$unit,$tip=null,$color=null){	
	$lang=$GLOBALS["lang"];
	
	if($used>0) $value=(100/$total)*$used;
	else $value=0;

	if($tip==null){
		$tip=     $lang['WMI_USED_WORD']." : ".$used." ".$unit.", ";
		$tip=$tip.$lang['WMI_FREE_WORD']." : ".($total-$used)." $unit, ";
		$tip=$tip.$lang['WMI_SIZE_WORD']." : $total $unit";
	}
	
	return addpercent($arr, $title,$value,$tip,$color);
}

function getURLPictures(){
	if( isset($_SERVER['HTTPS'] )) $scheme="https://";
	else  $scheme="http://";
	
	return $scheme.$_SERVER['HTTP_HOST']."/theme/default-image/";
}

function addbartext(array &$arr,$title,$text,$type=3,$tip=null){
	$color=getURLPictures();
	switch($type){
		case 0  : $color=$color."ok.png";      break;
		case 1  : $color=$color."warning.png"; break;
		case 2  : $color=$color."critical.png"; break;
		default : $color=$color."unknown.png"; break;
	}
	
	array_push($arr,array("title"=>$title,"textbar"=>$text,"tip"=>$tip,"color"=>$color));
	return $arr;
}

function addpercent(array &$arr,$title,$value,$tip=null,$color=null){
	if($color==null){
		if($value<80) $color="ok.png";
		else if($value<90) $color="warning.png";
		else $color="critical.png";
		
		$color=getURLPictures().$color;
	}
	array_push($arr,array("title"=>$title,"value"=>$value,"tip"=>$tip,"color"=>$color));
	return $arr;
}
/*
function nrpe_wmic($gesa,$node,$mode,$min_line,$max_line,$filter,$columns=NULL){
	$trealer_args=$filter;
	if (isset($columns)) {
		$trealer_args = $trealer_args . " " .$columns;
	}

	$data=array();
	do{
		$args=$mode . " " . "$min_line " . $trealer_args;
		//	return $args;
		$arr=$gesa->check_nrpe($node,"get_wmi_info",$args);
		$data=array_merge($data,$arr["data"]);
		$min_line = count($data);
		if($max_line != -1 && $min_line<$max_line) break;
	}while($arr["status"]=="MORE");
	
	if(  $max_line == -1 ) return $data;
	else return array_slice($data,0,$max_line);
}
*/
function parse_date($date){
	$arr=explode("+",$date);
	$arr[1]/=60;

	$str=sprintf("%s+%02d00",$arr[0],$arr[1]);
	return DateTime::createFromFormat('YmjHis.uO',$str);
}

function correct_bad_chars($arr){              
	$searchs=	array("Ú","Þ","¶","╔","Ó","Ô","á","Û");

	$replaces=	array("é","è","ô","É","à","â"," ","ê");
	
	if(is_array($arr)){
		$ret=array();
		foreach($arr as $key => $value) {
			$ret[$key]=correct_bad_chars($value);
		}
		return $ret;
	}
	if(is_string($arr)){
		for($i=0;$i<count($searchs);$i++){
			$arr=str_replace($searchs[$i],$replaces[$i],$arr);
		}
		return $arr;
	}
}
function tabLang($type,$arr,$col,$data=false){
	$ret=array();
	foreach($arr as $line){
		$ret_line=array();
		
		if(is_int($col)) $key=array_keys($line)[$col];
		else $key=$col;
		
		if(isset($line[$key])) $cell=$line[$key];
		else $cell="";	
		
		$nc=null;
		$nk = getLang($type,$key);
		if($data) $nc=getLang($type,$cell);
		
		unset($line[$key]);
		if($nk==null) $nk=$key;
		if($nc==null) $nc=$cell;
		
		$ret_line[$nk]=$nc;
		$ret_line=array_merge($line,$ret_line);	
		array_push($ret, $ret_line);
	}
	return $ret;
}

function getLang($type,$var){
	$lang=$GLOBALS["lang"];
	$var='WMI_'.$type.'_'.$var;
	
	if( ! array_key_exists($var,$lang)) return null;
	return $lang[$var];
}
?>
